-- debug 设定
-- ZG_DEBUG_TEST_CCB_SingleFile = "ccb/Test/TestAnim.ccbi" 		-- 测试单个的ccb文件
ZG_DEBUG_PRINT_HTTP_RESPONSE = true 				-- 打印http的返回
-- ZG_DEBUG_TEST_NET_REQUEST = true
-- ZG_DEBUG_TEST_SINGLE_LAYER = true

VERSION_BATCH_MELT = true 					-- 版本分支，增加批量熔炼
VERSION_REFIND = true 						-- 版本分支，洗练锁定

-- 原定义
WinSize = cc.Director:getInstance():getWinSize()
BallSize = cc.size(64, 64)
GroundSize = cc.size(3500, 2000)

CommonSize = cc.size(640,960)
COMMON_SCALE = math.min(WinSize.width/640, WinSize.height/960)

scheduler = cc.Director:getInstance():getScheduler()

NetWorkLock = false	--当前是否已经发送出消息还没回

--字体路径
local fontNameConfig = {
	EN = "ccb/ccbResources/ttf/WQY.ttf",
	TW = "Helvetica",
}
DefaultFontName = fontNameConfig[GameConfig:GetLanguage()]

-- DefaultFontName = "ccb/ccbResources/ttf/MyriadPro-Cond.ttf"
-- DefaultFontName = "ccb/ccbResources/ttf/WQY.ttf"
-- WorldFontName = "Helvetica"

--字号大小
FontSize1 = 18
FontSize2 = 22
FontSize3 = 30
FontSize4 = 26
FontSize5 = 24    --tittle 字体大小
FontSize6 = 22    --button 字体大小

-- FNT 分类
-- FntTypeUserTitle = "ccb/ccbResources/fnt/fnt_btn_main_yellow-export.fnt"			-- 弹框类标题用fnt
-- FntTypeCommonBtn = "ccb/ccbResources/fnt/fnt_btn_control-export.fnt"				-- 大众按钮用字体
-- FntTypeCommonDisableGray = "ccb/ccbResources/fnt/fnt_teambattle_gray-export.fnt"	-- 通用灰色，不可用
-- FntTypeCommonYellow = "ccb/ccbResources/fnt/fnt_teambattle_yellow-export.fnt"		-- 通用黄色
-- FntTypeCommonGlowRed = "ccb/ccbResources/fnt/fnt_btn_glow_red-export.fnt"			-- 通用亮红色
-- FntTypeCommonGlowYellow = "ccb/ccbResources/fnt/fnt_btn_glow_yellow-export.fnt"		-- 通用亮黄色
-- FntTypePower = "ccb/ccbResources/fnt/fnt_power-export.fnt" 							-- Power字体
COLOR_FNT_UserTilte = cc.c3b(254, 212, 12)
COLOR_FNT_CommonBtn = cc.c3b(241, 239, 239)
COLOR_FNT_CommonDisableGray = cc.c3b(171, 171, 171)
COLOR_FNT_CommonYellow = cc.c3b(254, 217, 4)
COLOR_FNT_CommonGlowRed = cc.c3b(230, 320, 87)
COLOR_FNT_CommonGlowYellow = cc.c3b(212, 229, 94)
COLOR_FNT_Power = cc.c3b(213, 250, 120)

--显示层级
UI_TAG 		= 1		--界面层
MAIN_TAG    = 2     --主标签层
POPUP_TAG 	= 3		--弹窗层
POPUP_S_TAG = 4     --次级弹窗
NOTE_TAG 	= 5		--提示层

--优先级
UI_PRI      = 0
MAIN_PRI    = -1000
MID_PRI     = -2000
POPUP_PRI   = -3000
NET_PRI     = -4000

--颜色
COLOR_BLACK  = cc.c3b(0,0,0)
COLOR_WHITE  = cc.c3b(255,255,255)
COLOR_RED    = cc.c3b(255,  0,  0)
COLOR_GREEN  = cc.c3b(  0,255,  0)
-- COLOR_GREEN_BATTLE_STATE  = cc.c3b(10, 165, 10)
COLOR_CYAN   = cc.c3b(  0,255,255)
COLOR_BLUE   = cc.c3b(  0,  144,255)
COLOR_PURPLE = cc.c3b(78,  3,248)
COLOR_ORANGE = cc.c3b(255,169,  2)
COLOR_GRAY   = cc.c3b(100,100,100)
COLOR_YELLOW = cc.c3b(255,255,100)
COLOR_DIANQING = cc.c3b(0,234,255)

FRAME_ICON_ARR = {"frame_grey.png", "frame_green.png","frame_blue.png","frame_violet.png","frame_yellow.png","frame_yellow.png"}
EQUIP_COLOR_ARR = {cc.c3b(103,103,103), cc.c3b(27, 165,0),cc.c3b(0, 132, 255), cc.c3b(210, 0, 255), cc.c3b(255, 120, 0), cc.c3b(255, 120, 0)}
EQUIP_NAME_ARR  = {MultiLan("CD_equipColor_1"), MultiLan("CD_equipColor_2"),MultiLan("CD_equipColor_3"), MultiLan("CD_equipColor_4"),MultiLan("CD_equipColor_5")}
BOX_COLOR_ARR = {cc.c3b(0, 132, 255), cc.c3b(210, 0, 255), cc.c3b(255, 120, 0)}
BOX_NAME_ARR  = {MultiLan("CD_treasureBox_1"),MultiLan("CD_treasureBox_2"),MultiLan("CD_treasureBox_3")}
KEY_NAME_ARR  = {MultiLan("prop_name_100009"),MultiLan("prop_name_100010"),MultiLan("prop_name_100011")}
KEY_ID_ARR = {100009, 100010, 100011}
PILL_ID_ARR = {100304, 100303, 100302,100301}
SKILL_COUNT_LIMIT_LEVEL = {5, 15, 25 ,35}
TITLE_COLOR_TAG = {5,3,5,4,5,3,4,4,3,4,4,5}

--特殊道具
PROP_ID_CASH = 100001 
PROP_ID_GOLD = 100002
PROP_ID_JINGHUA = 100003
PROP_ID_HONOR = 110001 
PROP_ID_FUSION = 110002
PROP_ID_PRESTIGE = 110003
PROP_ID_COUPON   = 110004
PROP_ID_PILL = 100300
PROP_ID_BOOK = 100600

PROP_ID_BOSS_NUM = 100012
--道具类型
PROP_TYPE_MONEY     = 1 --特殊货币
PROP_TYPE_DRILL     = 2 --开孔
PROP_TYPE_KEY       = 3 --钥匙
PROP_TYPE_CHALLENGE = 4 --BOSS挑战劵
PROP_TYPE_GEMBAG    = 5 --宝石袋
PROP_TYPE_GEM       = 6 --宝石
PROP_TYPE_EQUIP     = 7 --装备
PROP_TYPE_JINHUA    = 8 --强化精华
PROP_TYPE_SUIPIAN   = 9 --神器碎片
--通用弹窗大小
POPUP_SIZE_MAX = cc.size(640,835)
POPUP_SIZE_BIG = cc.size(559,835)
POPUP_SIZE_MID = cc.size(560,656)
POPUP_SIZE_SML = cc.size(560,344)
CJSON_NULL = require("cjson").null

--黑色遮罩层透明度
COMMON_SWALLOW_OPACITY = 180

EQUIP_PLACE_MAX = 10
VIP_LEVEL_MAX = 15
STONE_LEVEL_MAX = 15 
EQUIP_STRENGTHEN_MAX = 15
HERO_STAR_MAX = 10

function IsPillId(id)
	-- print("IsPillId",id)
	for i=1,table.maxn(PILL_ID_ARR) do
		if PILL_ID_ARR[i] == id then
			return true
		end
	end
	
	if id == PROP_ID_PILL then
		return true
	else
		return false
	end
end

--贡献不足
function CommonContributionNeed(value)
	if value ~= nil then
		CommonNote(MultiLan("CD_propIsNotEnough_1")..value)
	else
		CommonNote(MultiLan("CD_propIsNotEnough_7"))
	end
end

--荣誉点不足
function CommonHonorNeed(value)
	if value ~= nil then
		CommonNote(MultiLan("CD_propIsNotEnough_2")..value)
	else
		CommonNote(MultiLan("CD_propIsNotEnough_8"))
	end
end

--银两不足
function CommonGoldNeed()
	CommonNote(MultiLan("CD_propIsNotEnough_3"))
end

--元宝不足
function CommonCashNeed()
	CommonNote(MultiLan("CD_propIsNotEnough_4"))
end

--熔炼值不足
function CommonMeltpointNeed()
	CommonNote(MultiLan("CD_propIsNotEnough_5"))
end

--声望不足
function CommonPrestigeNeed()
	CommonNote(MultiLan("CD_propIsNotEnough_6"))
end

--银票不足
function CommonCouponNeed()
	CreateSmallPopupWithPay("prompt", CreateCommonLabel(MultiLan("CD_couponIsNotEnough_7"), nil,FontSize3, nil,nil,cc.size(460,100)))
end

--次数不足
function CommonTodayLimit()
	CommonNote(MultiLan("CD_countIsNotEnough"))
end

--元宝消耗
function UseCash(num)
	-- print("UseCash", ACT_TYPE_DAILY, UserActiveInfo.daily_pay)
	if num ~= nil and ACT_TYPE_DAILY ~= 0 and UserActiveInfo.daily_pay~=nil then
		Activity_ActArr[ACT_TYPE_DAILY].info.accpay = Activity_ActArr[ACT_TYPE_DAILY].info.accpay + num
		Activity_ActArr[ACT_TYPE_DAILY].canReward = IsDailyCanReward(Activity_ActArr[ACT_TYPE_DAILY].info)    
		-- print("UseCash", Activity_ActArr[ACT_TYPE_DAILY].canReward)
	end
end

--function MultiLan(keyVal)
	--return Localization:getValueByKey(keyVal)
--end

local moveToY = nil
local showedNote = {}
local strY = nil
local disappearY = 0

--统一飘字处理 noteSteing为内容 noteType为方式
function CommonNote(noteString, color, callback,dt)
	if NOTE_LAYER == nil then
		return 
	end
	if type(noteString) == "table" then
		local num = 0
		local delayTime = 0.08
		if dt ~= nil then
			delayTime = dt
		end
		local function delayCommonNote()
			num = num + 1
			if type(color) == "table" then
				CommonNote(noteString[num], color[num],callback)
			else
				CommonNote(noteString[num], color, callback)
			end
		end
		for i=1,table.maxn(noteString) do
			NOTE_LAYER:runAction(cc.Sequence:create(cc.DelayTime:create((i-1)*delayTime), cc.CallFunc:create(delayCommonNote)))
		end
		
		return
	elseif type(noteString) == "string" then
		-- print("CommonNote", 1)
	else
		return
	end
	--print("CommonNote", type(noteString))
	if moveToY == nil then
		moveToY	= WinSize.height/2
	end
	if strY == nil then
		strY = WinSize.height/2
	end 

	local str = cc.Label:create(noteString, DefaultFontName, FontSize3)

	local scale = 1--27/30*COMMON_SCALE
	str:setScale(scale)
	strY = strY - str:getContentSize().height*1.2*scale
	--moveToY = moveToY + str:getContentSize().height*0.6*scale + disappearY
	moveToY = moveToY + str:getContentSize().height*0.6*scale + math.min(disappearY,320)
	if WinSize.height - strY - moveToY > COMMON_SCALE*280 then
		moveToY = WinSize.height - strY - COMMON_SCALE*280
	end

	disappearY = 0
	table.insert(showedNote, str)
	if color ~= nil then
		str:setColor(color)
	else
		str:setColor(COLOR_GREEN)
	end
	str:setAnchorPoint(cc.p(0.5,1))
	str:setPosition(cc.p(WinSize.width/2, strY))
	NOTE_LAYER:addChild(str)
	local function clearSelf(node)
		disappearY = disappearY + tolua.cast(node, "cc.Node"):getContentSize().height*0.6*scale
		removeSelf(node)
		removeFromTable(showedNote, str)
		
		if table.maxn(showedNote) == 0 then
			-- print("remove", strY)
			NOTE_LAYER:setPositionY(WinSize.height/2)
			strY = WinSize.height/2
			moveToY = WinSize.height/2
			disappearY = 0
		end
	end
	str:setScaleX(2)
	str:setScaleY(1)
	
	if table.maxn(showedNote) ~= 1 then
		str:setPositionY(str:getPositionY()-str:getContentSize().height*scale)
		if callback == nil then
			str:runAction(cc.Sequence:create(cc.Spawn:create(cc.ScaleTo:create(0.1,1,1), cc.MoveBy:create(0.1, cc.p(0, str:getContentSize().height*scale))), cc.DelayTime:create(2.5), cc.FadeOut:create(1.2), cc.CallFunc:create(clearSelf)))
		else
			str:runAction(cc.Sequence:create(cc.CallFunc:create(callback), cc.Spawn:create(cc.ScaleTo:create(0.1,1,1), cc.MoveBy:create(0.1, cc.p(0, str:getContentSize().height*scale))), cc.DelayTime:create(2.5), cc.FadeOut:create(1.2), cc.CallFunc:create(clearSelf)))
		end
	else
		if callback == nil then
		    str:runAction(cc.Sequence:create(cc.ScaleTo:create(0.1,1,1), cc.DelayTime:create(2.5), cc.FadeOut:create(1.2), cc.CallFunc:create(clearSelf)))
		else
			str:runAction(cc.Sequence:create(cc.CallFunc:create(callback), cc.ScaleTo:create(0.1,1,1), cc.DelayTime:create(2.5), cc.FadeOut:create(1.2), cc.CallFunc:create(clearSelf)))
		end
	end

	NOTE_LAYER:setPositionY(moveToY)
end

function GaiEffect(node)
	if node ~= nil then
		node:setScale(1.3)
		node:setVisible(true)
		node:runAction(cc.ScaleTo:create(0.1, 1))
	end
end

--创建装备显示
function CreateEquipByInfo(equipInfo, pos)
	local equip = CreateLayer(cc.size(BAG_ITEM_SIZE, BAG_ITEM_SIZE))
	equip:addChild(CreateCommonSprite("prop_" .. equipInfo.prop_id .. ".png", cc.p(BAG_ITEM_SIZE/2, BAG_ITEM_SIZE/2))) 
	equip:addChild(CreateCommonSprite(FRAME_ICON_ARR[EquipHelper:getEquipGrade(equipInfo)], cc.p(BAG_ITEM_SIZE/2, BAG_ITEM_SIZE/2))) 
	if equipInfo.strengthen > 0 then
		equip:addChild(CreateCommonLabel("+"..equipInfo.strengthen, cc.p(78, 70), FontSize1,nil,cc.p(1, 0.5))) 
	end
	equip:addChild(CreateCommonLabel("Lv"..EquipHelper:getStaticData(equipInfo).level, cc.p(BAG_ITEM_SIZE/2, 0), FontSize1))
	if equipInfo.slots > 0 then
		local stoneLayer = cc.Layer:create()
		stoneLayer:ignoreAnchorPointForPosition(false)
		stoneLayer:setAnchorPoint(0.5, 0.5)
		stoneLayer:setPosition(cc.p(BAG_ITEM_SIZE / 2, 10))
		SetEquipStone(stoneLayer, equipInfo.slots, equipInfo.stone)
		equip:addChild(stoneLayer)
	end
	
	SetEquipMasterEffect(equip, equipInfo)
	if pos ~= nil then
		equip:setPosition(pos)
	end	
	return equip
end

function CreateLayer(size ,scale, position, anchor, callback, color4B)
	-- print("CreateLayer",size,scale,position,anchor)
	local layer = nil
	if color4B == nil then
		layer = cc.Layer:create()
	else
		layer = cc.LayerColor:create(color4B)
	end
	layer:ignoreAnchorPointForPosition(false) 
	layer:setContentSize(size)
	if scale ~= nil then
		layer:setScale(scale)
	end
	if position ~= nil then
		layer:setPosition(position)
	end
	if anchor ~= nil then
		layer:setAnchorPoint(anchor)
	end

	if callback ~= nil then
		SetTouchEventForLayer(layer, callback)
		--layer:setTouchEnabled(true)
	end

	return  layer
end

--按比例取坐标
function Pos(Size,x ,y)
	--print("Pos",Size,x,y)
	local posx,posy = 0.5,0.5
	if x ~= nil then
		posx = x
	end
	if y ~= nil then
		posy = y
	end

	return cc.p(Size.width*posx, Size.height*posy)
end

--根据图片大小
function CreateLayerBackSprite(spriteName, layerSize, pos)
	local back = CreateCommonSprite(spriteName, pos)
	back:setScaleX(layerSize.width/back:getContentSize().width)
	back:setScaleY(layerSize.height/back:getContentSize().height)
	return back
end

--根据父节点大小创建富文本
function CreateRichtextByFather(father, textArr, bClean, bScroll)
	if bClean then
		father:removeAllChildren(true)
	end
	if textArr == nil then
		return
	end
	-- print("CreateRichtextByFather", table.maxn(textArr))
 	local richText = ccui.RichText:create()
	richText:ignoreContentAdaptWithSize(false)
	richText:setAnchorPoint(cc.p(0.5 , 0.5))
	local size = father:getContentSize()
	size.width = size.width - 10
	--richText:setContentSize(father:getContentSize())
	richText:setContentSize(size)
	richText:setPosition(Pos(father:getContentSize(),0.5,0.5))

	for i=1,table.maxn(textArr) do
		if textArr[i].color == nil then
			textArr[i].color = COLOR_WHITE
		end
		--print(i, textArr[i].size)
		if textArr[i].size ~= nil then
			--print(textArr[i].str)
			richText:pushBackElement(ccui.RichElementText:create(1, textArr[i].color, 255, textArr[i].str ,DefaultFontName,textArr[i].size))
		else
			richText:pushBackElement(ccui.RichElementNewLine:create())
		end
	end
	
	if bScroll or father:getContentSize().height < richText:getTextMaxHeight() then
		local textHeight = richText:getTextMaxHeight()
		-- print("bScroll", textHeight)
		local layer = cc.Layer:create()
		layer:setContentSize(cc.size(father:getContentSize().width, textHeight))
		richText:setPosition(cc.p(layer:getContentSize().width/2, textHeight - father:getContentSize().height/2))
		richText:formatText()
		layer:addChild(richText)
		local scrolView = CreateScrollViewByFather(father, layer, cc.p(0, father:getContentSize().height - richText:getTextMaxHeight()), kScrollViewDirectionVertical)
	else
		father:addChild(richText)
	end
end


--根据父节点大小创建多行内容
function CreateMultiTextByFather(father, textNode, bClean)
	if bClean then
		father:removeAllChildren(true)
	end
	if textNode == nil then
		return
	end
	-- print("CreateMultiTextByFather", table.maxn(textNode))
 	local height = father:getContentSize().height
	local width = father:getContentSize().width
	local count = table.maxn(textNode)
	for i=1, table.maxn(textNode) do
		textNode[i]:setAnchorPoint(cc.p(0,0.5))
		textNode[i]:setPosition(Pos(father:getContentSize(), 0, (count-i+0.5)/count))
		father:addChild(textNode[i])
	end
end

--根据父节点大小创建多行内容
function CreateMultiTextLine(textNode)
	if bClean then
		father:removeAllChildren(true)
	end
	if textNode == nil then
		return
	end
	-- print("CreateMultiTextLine", table.maxn(textNode))
	local layer = cc.Layer:create()
	layer:ignoreAnchorPointForPosition(false)

	local width = 0
	local count = table.maxn(textNode)
	for i=1, table.maxn(textNode) do
		textNode[i]:setPosition(cc.p(width, 50))
		textNode[i]:setAnchorPoint(cc.p(0,0.5))
		layer:addChild(textNode[i])
		width = width + textNode[i]:getContentSize().width
	end
	
	layer:setContentSize(cc.size(width, 100))
	
	return layer
end

--创建labelTTF
function CreateCommonLabel(str, labelPoint, fontSize, color, anchorPoint, demension)
	-- print("CreateCommonLabel",str, fontSize, DefaultFontName)
	local label = cc.Label:create(str, DefaultFontName, fontSize)
	if labelPoint ~= nil then
		label:setPosition(labelPoint)
	end
	if color ~= nil then
		label:setColor(color)
	end
	if anchorPoint ~= nil then
		label:setAnchorPoint(anchorPoint)
	end
	if demension ~= nil then
		label:setDimensions(demension.width, demension.height)
	end
	-- print("CreateCommonLabel_end")
	return label
end

-- 创建LabelFnt
function CreateCommonFntLabel( str, fntFilePath, labelPoint, color, anchorPoint )
	-- print("CreateCommonFntLabel",str, fntFilePath)
	local label = cc.LabelBMFont:create(str, fntFilePath)
	if labelPoint ~= nil then
		label:setPosition(labelPoint)
	end
	if color ~= nil then
		label:setColor(color)
	end
	if anchorPoint ~= nil then
		label:setAnchorPoint(anchorPoint)
	end
	-- print("CreateCommonFntLabel_end")
	return label
end

--创建图片
function CreateCommonSprite(spriteName, spritePoint, scale, scaleY, touming, bFlipX)
	local sprite = cc.Sprite:createWithSpriteFrameName(spriteName)
	if spritePoint ~= nil then
		sprite:setPosition(spritePoint)
	end

	if scale ~= nil then
		sprite:setScale(scale)
		if scaleY ~= nil then
			sprite:setScaleY(scaleY)
		end
	end
	
	if bFlipX then
		sprite:setFlippedX(true)
	end
	
	if touming ~= nil then
		sprite:setOpacity(touming)
	end

	return sprite
end

--创建按钮
function CreateCommonButton(spriteName, spritePoint, preferSize, callback, strTable, bFlipX)
	local button = nil 
	local pBackgroundButton = cc.Scale9Sprite:createWithSpriteFrameName(spriteName)

	if strTable ~= nil then
    	local pTitleButton = cc.Label:create(strTable.str, DefaultFontName, strTable.size)
		if strTable.color ~= nil then
			pTitleButton:setColor(strTable.color)
		end
    
    	button = cc.ControlButton:create(pTitleButton, pBackgroundButton)
	else
		button = cc.ControlButton:create(pBackgroundButton)
	end
	
	if bFlipX then
		button:setFlippedX(true)
	end
	

	button:setPreferredSize(preferSize)
	if spritePoint ~= nil then
		button:setPosition(spritePoint)
	end
	if callback ~= nil then
		--SetTouchEventForLayer(button, callback)
		--SetPriorityForButton(button, callback)
		button:registerControlEventHandler(callback, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE)
	end
	
	return button
end

--按钮换图
function SetCommonButtonDisabledSprite(button, spritName)
	tolua.cast(button, "cc.ControlButton"):setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(spritName), cc.CONTROL_STATE_DISABLED)
end
--按钮设置换图
function SetCommonButtonSprite(button, spritName)
	tolua.cast(button, "cc.ControlButton"):setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(spritName), cc.CONTROL_STATE_NORMAL)
	tolua.cast(button, "cc.ControlButton"):setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(spritName), cc.CONTROL_STATE_HIGH_LIGHTED)
end


--创建装备选择背景，比较大
function createEquipPopupBoard(tag)
	local layer = cc.Layer:create()
	layer:setContentSize(cc.size(640, 960))
	
	--swallowlayer
	local swallowLayer = cc.Layer:create()
	swallowLayer:setContentSize(cc.size(640, 960))
	swallowLayer:setPosition(cc.p(320, 480))
	swallowLayer:ignoreAnchorPointForPosition(false)
	swallowLayer:setAnchorPoint(cc.p(0.5, 0.5))
	swallowLayer:setTag(20)
    swallowLayer:setTouchEnabled(true)
	layer:addChild(swallowLayer,-1)
	
	local colorLayer = cc.LayerColor:create(cc.c4b(0,0,0,COMMON_SWALLOW_OPACITY))
	colorLayer:setContentSize(cc.size(640,960))
	layer:addChild(colorLayer)
	
	local spriteBack = cc.Sprite:createWithSpriteFrameName("board_big.png")
	spriteBack:setTag(1)
	spriteBack:setPosition(cc.p(320, 490))
	layer:addChild(spriteBack)
	
	local titleBg1 = cc.Sprite:createWithSpriteFrameName("title_boardall.png")
	titleBg1:setPosition(cc.p(280, 831))
	titleBg1:setTag(1)
	spriteBack:addChild(titleBg1)
	
	--[[
	local title = cc.Sprite:createWithSpriteFrameName("title_equipchoose.png")
	title:setPosition(cc.p(280, 831))
	title:setTag(1)
	spriteBack:addChild(title)
	]]
	-- local title = CreateCommonFntLabel(ZGMultiLan("title_equipchoose"), FntTypeUserTitle, cc.p(280, 831))
	local title = CreateCommonLabel(ZGMultiLan("title_equipchoose"), cc.p(280, 831), FontSize4, COLOR_FNT_UserTilte)
	spriteBack:addChild(title)

	local filterLayer = cc.Layer:create()
	filterLayer:setContentSize(cc.size(500, 680))
	filterLayer:setPosition(cc.p(280, 445))
	filterLayer:ignoreAnchorPointForPosition(false)
	filterLayer:setAnchorPoint(cc.p(0.5, 0.5))
	filterLayer:setTag(2)
	spriteBack:addChild(filterLayer)
	local pBackground = nil
	local pTitle = nil
	if tag == 1 then
		pBackground = cc.Scale9Sprite:createWithSpriteFrameName("button_red.png")
		pTitle = cc.Label:create(MultiLan("button_close"), DefaultFontName, FontSize3)
	elseif tag == 2 then
		pBackground = cc.Scale9Sprite:createWithSpriteFrameName("button_blue.png")
		pTitle = cc.Label:create(MultiLan("button_ok"), DefaultFontName, FontSize3)
	end
	
	local closeButton = cc.ControlButton:create(pTitle, pBackground)
	closeButton:setPosition(cc.p(280, 48))
	closeButton:setPreferredSize(cc.size(144, 50))
	closeButton:setTag(3)
	spriteBack:addChild(closeButton)
    
	return layer
end

--创建道具选择背景，中等大小
function createMiddleEquipPopupBoard(titleStr)
	local layer = cc.Layer:create()
	layer:setContentSize(cc.size(640, 960))
	local spriteBack = cc.Sprite:createWithSpriteFrameName("board_middle.png")
	spriteBack:setTag(1)
	spriteBack:setPosition(cc.p(320, 480))
	layer:addChild(spriteBack)

	-- add bg sprite
	local spBgSecond = cc.Scale9Sprite:createWithSpriteFrameName("ease.png")
	spBgSecond:setInsetLeft(7)
	spBgSecond:setInsetRight(7)
	spBgSecond:setInsetTop(7)
	spBgSecond:setInsetBottom(7)
	spBgSecond:setContentSize(cc.size(POPUP_SIZE_MID.width * 0.9, POPUP_SIZE_MID.height * 0.8))
	spBgSecond:setPosition(Pos(POPUP_SIZE_MID, 0.5, 0.55))
	spriteBack:addChild(spBgSecond)



    if titleStr ~= nil then
	    local titleBg = cc.Sprite:createWithSpriteFrameName("title_boardall.png")
	    titleBg:setPosition(cc.p(280, 650))
	    titleBg:setTag(1)
	    spriteBack:addChild(titleBg)

     --    local title = cc.Sprite:createWithSpriteFrameName(titleStr)
	    -- title:setPosition(cc.p(280, 650))
	    -- title:setTag(10)
	    -- spriteBack:addChild(title)
	    -- local title = CreateCommonFntLabel(ZGMultiLan(titleStr:gsub(".png", "")), FntTypeUserTitle, cc.p(280, 650))
	    local title = CreateCommonLabel(ZGMultiLan(titleStr:gsub(".png", "")), cc.p(280, 650), FontSize4, COLOR_FNT_UserTilte)
	    title:setTag(10)
	    spriteBack:addChild(title)
    end

	local filterLayer = cc.Layer:create()
	filterLayer:setContentSize(cc.size(500, 510))
	filterLayer:setPosition(cc.p(280, 360))
	filterLayer:ignoreAnchorPointForPosition(false)
	filterLayer:setAnchorPoint(cc.p(0.5, 0.5))
	filterLayer:setTag(2)
	spriteBack:addChild(filterLayer)

	local pBackground = cc.Scale9Sprite:createWithSpriteFrameName("button_red.png")
	local pTitle = cc.Label:create(MultiLan("button_close"), DefaultFontName, FontSize4)
	local closeButton = cc.ControlButton:create(pTitle, pBackground)
	closeButton:setPosition(cc.p(280, 48))
	closeButton:setPreferredSize(cc.size(144, 50))
	closeButton:setTag(3)
	spriteBack:addChild(closeButton)
	
	local chacha = CreateCommonButton("icon_close.png", cc.p(POPUP_SIZE_MID.width-10, POPUP_SIZE_MID.height-10), cc.size(50,50))
	spriteBack:addChild(chacha,0,4)
	
	
	return layer
end

--创建进度条
function CreateCommonBar(barSprite, barPosition)
	local bar = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrameName(barSprite)) 
	if barPosition ~= nil then
		bar:setPosition(barPosition)
	end
	bar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
	bar:setMidpoint(cc.p(0, 0))
	bar:setBarChangeRate(cc.p(1, 0))
		
	return bar
end

--设置layer响应时间 需要提供touchend的回调
function SetTouchEventForLayer(layer, touchCallback)
	local touchLayer = tolua.cast(layer, "cc.Layer")
	
	local function onTouchBegan(touch, event)
		local locationInNode = touchLayer:convertToNodeSpace(touch:getLocation())
		if cc.rectContainsPoint(cc.rect(0, 0, touchLayer:getContentSize().width, touchLayer:getContentSize().height), locationInNode) and getVisibleRecur(touchLayer) then
			return true
		end
		return false
	end
	local listener = cc.EventListenerTouchOneByOne:create()    
	listener:setSwallowTouches(true)
	listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
	listener:registerScriptHandler(touchCallback,cc.Handler.EVENT_TOUCH_ENDED )
	touchLayer:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, touchLayer)
end

--设置按钮优先级 必须提供按钮响应事件
function SetPriorityForButton(button, callback)
	local touchButton = tolua.cast(button, "cc.ControlButton")
	
	local function onTouchBegan(touch, event)
		local locationInNode = touchButton:convertToNodeSpace(touch:getLocation())
		if cc.rectContainsPoint(cc.rect(0, 0, touchButton:getContentSize().width, touchButton:getContentSize().height), locationInNode) and getVisibleRecur(touchButton) then
			return true
		end
		return false
	end

	local listener = cc.EventListenerTouchOneByOne:create() --cc.EventListenerFocus:create()
	listener:setSwallowTouches(true)
	listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN)
	listener:registerScriptHandler(callback,cc.Handler.EVENT_TOUCH_ENDED)
    touchButton:getEventDispatcher():addEventListenerWithSceneGraphPriority(eventListener, touchButton)
end

--创建scrollView 可视区域与父节点大小相同   
function CreateScrollViewByFather(fNode, contentLayer, offsetPoint, scrollType ,scrollEventCallback, bOnlyAdd)
	-- print("CreateScrollViewByFather", contentLayer)
	if bOnlyAdd == nil then
		fNode:removeAllChildren(true)
	end
	local scrollView = cc.ScrollView:create()
	scrollView:setViewSize(fNode:getContentSize())
	scrollView:setPosition(cc.p(0,0))
	scrollView:ignoreAnchorPointForPosition(true)
	if scrollType ~= nil then
		scrollView:setDirection(scrollType)
	else
		scrollView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
	end
	scrollView:setClippingToBounds(true)
	scrollView:setBounceable(true)
	scrollView:setDelegate()
	--if contentLayer ~= nil then
		scrollView:setContainer(contentLayer)
	--end
	scrollView:setContentOffset(offsetPoint, false)

	if scrollEventCallback ~= nil then
        scrollView:registerScriptHandler(scrollEventCallback, cc.SCROLLVIEW_SCRIPT_SCROLL)
	end
	scrollView:updateInset()
	fNode:addChild(scrollView)

	return scrollView
end

-- 把label转移到button下面下，相当于切换父子关系
function CommonMoveLabelUnderBtn( btn, lb ,storey)
	local x, y = lb:getPosition()
	local wdPos = lb:getParent():convertToWorldSpace(cc.p(x, y))
	local nodePos = btn:convertToNodeSpace(wdPos)
	lb:removeFromParent(false)
	lb:setPosition(nodePos)
	if storey == nil then
		btn:addChild(lb)
	else
		btn:addChild(lb ,storey)
	end
end

--按id从小到大排 
function SortTableById(a,b)
	if a.id < b.id then
		return true
	elseif a.id > b.id then
		return false
	else
		return a.prop_id < b.prop_id 
	end
end

function findValueFromTable(t,value)
	for k,v in pairs(t) do
		if v == value then
			return true
		end
	end
	
	return false
end

function printNode(node,name)
	print(name,node:getContentSize().width, node:getContentSize().height, node:getScaleX(), node:getScaleY(),node:getPositionX(),node:getPositionY(),node:getAnchorPoint().x, node:getAnchorPoint().y)
end