FlashSaleLayer = class("FlashSaleLayer")

--new
function FlashSaleLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function FlashSaleLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["FlashSaleLayer"] = self
	ccb["FlashSaleLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Event/FlashSaleLayer.ccbi", proxy, self)
	self.data = data
	self.mActPayBack.owner = self
	self:initUI()
	return self
end
function FlashSaleLayer:initUI(  )
	self.lbActFlashTitle:setString(ZGMultiLan("act_title_flashsale"))
	self.lbTimeDesc:setString(MultiLan("GAL_flashsale_desc1"))
	self.lbTimeName:setString(MultiLan("GAL_flashsale_desc2"))
end
function FlashSaleLayer:onActPayBack(sender)
	self.owner.data.resetActLayer()
	self.owner.topNode:setVisible(false)
end
function FlashSaleLayer:onActHelpClick(sender)
	HelpPopup("actiflashsale")
end




