GameCompensateLayer = class("GameCompensateLayer")
GameCompensateLayer.__index = GameCompensateLayer

GameCompensateLayer.topNode = nil
GameCompensateLayer.filterScroll = nil
GameCompensateLayer.userMailInfoList = {}
GameCompensateLayer.selectMailInfo = {}

ccb["GameCompensateLayer"] = GameCompensateLayer
GameCompensateLayerOwner = GameCompensateLayerOwner or {}
ccb["GameCompensateLayerOwner"] = GameCompensateLayerOwner

function onGameCompensateLayerClose()
	GameCompensateLayer:GameCompensateLayerExit()
	-- setMailNote(false)
end

function GameCompensateLayer:GameCompensateLayerRefresh(UserCompensateInfo)
	local scrollLayer = GameCompensateLayerOwner["mGameMailChoose"]
    local layer = cc.Layer:create()
    local count = 0
    if UserCompensateInfo.user ~= nil then
    	count = count + 1
    end
    if UserCompensateInfo.pays ~= nil then
    	count = count + #UserCompensateInfo.pays
    end

    if count == 0 then
    	XiaLayerOwner["lyHomeCompensateBtn"]:removeFromParent()
    	self:GameCompensateLayerExit()
    	return
    end	
	local y = count * 120  
    local cellSize = CompensateCell.getCellSize()
    layer:setContentSize(cc.size(cellSize.width, y ))

	
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	y = y - 120
	if UserCompensateInfo.user ~= nil then
		local compensatecell = CompensateCell:new()
		compensatecell:create({
			mytype = 1,
			UserCompensateInfo = UserCompensateInfo,
			compensatecellInfo = UserCompensateInfo.user,
			})
		local cellNode = compensatecell.topNode 
		cellNode:setPositionY(y)   
		layer:addChild(cellNode)
		y = y - 120
	end
	if UserCompensateInfo.pays ~= nil then
		for i = 1, #UserCompensateInfo.pays do
			local compensatecell = CompensateCell:new()
	    	compensatecell:create({
	    		mytype = 2,
	    		compensatecellInfo = UserCompensateInfo.pays,
	    		UserCompensateInfo = UserCompensateInfo,
	    		tag = i,
	    		})
	   		local cellNode = compensatecell.topNode 
	    	cellNode:setPositionY(y)   
			layer:addChild(cellNode)
			y = y - 120
		end
	end
end

function GameCompensateLayer:GameCompensateLayerEnter(UserCompensateInfo)
    
    if self.topNode ~= nil then
        return
    end

	local proxy = cc.CCBProxy:create()
	self.topNode = CCBReaderLoad("ccb/GameCompensateLayer.ccbi",proxy,GameCompensateLayerOwner)
	POPUP_LAYER:addChild(self.topNode)
	GameCompensateLayerOwner["mMailDesc"]:setString(MultiLan("compensate_desc"))
	GameCompensateLayerOwner["mButtonClose"]:setTitleForState(MultiLan("button_close"), 1)
	GameCompensateLayerOwner["mTitleGameEmail"]:setString(ZGMultiLan("title_compensate"))
	local function onGameMailSwallowTouch(touch, event)
		return true
	end
	SetTouchEventForLayer(GameCompensateLayerOwner["mGameMailLayerSwallowLayer"], onGameMailSwallowTouch)	
	self:GameCompensateLayerRefresh(UserCompensateInfo)
end

function GameCompensateLayer:GameCompensateLayerExit()
	self.topNode:removeFromParent()
	self.topNode = nil
end
function onGameCompensateLayerHelp()
	HelpPopup("compensate")
end
-----
GameCompensateLayer["onGameCompensateLayerClose"] = onGameCompensateLayerClose
GameCompensateLayer["onGameCompensateLayerHelp"] = onGameCompensateLayerHelp



