
local bFamilyInited = false
bUserHasFamily = false
UserFamilyInfo = nil
UserFamilyBattleInfo = nil
INSPIRE_CASH = 20
local adviceFamilyInfo = {}
local famillyListInfo = {}
local familyExpBar = nil
local bossHpBar = nil
local FamilyBossData = nil
local FamilyNameEditBox = nil
local FamalyTimerId = 0
local WarTeamChange = false
local button1,button2,button3 = nil
local mytag = 1

local function sortMember(a, b)
	if a.position < b.position then
		return true
	elseif a.position > b.position then
		return false
	else
		if a.power > b.power then
			return true
		elseif a.power < b.power then
			return false
		else
			return a.uid < b.uid 
		end
	end
end

local function getSecondHostCount()
	local count = 0
	for i=1,table.maxn(UserFamilyInfo.member) do
		if UserFamilyInfo.member[i].position == 10 then
			count = count + 1
		end
	end
	return count
end

function getMyMemberInfo()
	-- print("getMyMemberInfo")
	if UserFamilyInfo == nil then
		return nil
	end
	for i=1, table.maxn(UserFamilyInfo.member) do
		if UserFamilyInfo.member[i].uid == UserSelfInfo.uid then
			return UserFamilyInfo.member[i]
		end
	end
end

local STATE_NOT_OPEN = 0 --未开启
local STATE_NOT_JOIN = 1 --未加入
local STATE_IS_JOIN  = 2 --已加入

--设置Boss战相关数据
local function SetBossInfo(bInit)
	-- print("SetBossInfo", bInit)
	local FamilyBossInfo = UserFamilyInfo.boss
	FamilyBossData = GameData:getFamilyBoss(FamilyBossInfo.id)
	
	if FamilyBossInfo.status == STATE_NOT_OPEN then
		XiaLayerOwner["mBossState1"]:setVisible(true)
		XiaLayerOwner["mBossState2"]:setVisible(false)
		
		XiaLayerOwner["mBossLevel"]:setString("Lv."..FamilyBossData.level.." "..MultiLan("GFL_master"))
		XiaLayerOwner["mBossLevel"]:enableOutline(cc.c3b(0,0,0),1)
		XiaLayerOwner["mBossExp"]:setString(MultiLan("GFL_masterExp").." "..FamilyBossData.contribution)
		XiaLayerOwner["mBossExp"]:enableOutline(cc.c3b(0,0,0),1)

	else
		XiaLayerOwner["mBossState1"]:setVisible(false)
		XiaLayerOwner["mBossState2"]:setVisible(true)
		
		bossHpBar:setPercentage(FamilyBossInfo.hp*100/FamilyBossData.hp)
		
		XiaLayerOwner["mBossDesc1"]:setString(MultiLan("GFL_inspire_1"))
		XiaLayerOwner["mBossDesc1"]:enableOutline(cc.c3b(0,0,0),1)
		XiaLayerOwner["mBossDesc2"]:setString(FamilyBossInfo.inspire.."%")
		XiaLayerOwner["mBossDesc2"]:enableOutline(cc.c3b(0,0,0),1)
		XiaLayerOwner["mBossDesc2"]:setPositionX(XiaLayerOwner["mBossDesc1"]:getPositionX()+XiaLayerOwner["mBossDesc1"]:getContentSize().width)
		XiaLayerOwner["mBossDesc3"]:setString(string.format(MultiLan("GFL_inspire_2"),20,20))
		XiaLayerOwner["mBossDesc3"]:enableOutline(cc.c3b(0,0,0),1)
		
		--statechange1
		local function statechange1()
			FamilyBossInfo.type = 2
			FamilyBossInfo.count = 7200
			SetBossInfo(true)
		end
		
		local function statechange2()
			FamilyBossInfo.status = STATE_NOT_OPEN
			SetBossInfo()
		end
		
		FamalyTimerId = TimeDown:register(FamalyTimerId)
		if FamilyBossInfo.type == 1 then
			XiaLayerOwner["lbBossCountDown"]:setVisible(true)
			-- XiaLayerOwner["lbBossCountDown"]:setSpriteFrame("pic_guildgotime.png")
			XiaLayerOwner["lbBossCountDown"]:setString(ZGMultiLan("lbBossCountDown_start"))
			if bInit then
				-- print(FamalyTimerId, FamilyBossInfo.count)
				TimeDown:setTimeInfo(FamalyTimerId, FamilyBossInfo.count, XiaLayerOwner["mBossCountDown"], statechange1, TimeDown.HH_MM_SS) 
				SetDownTimeForLabel(XiaLayerOwner["mBossCountDown"], FamilyBossInfo.count, TimeDown.HH_MM_SS)
			end
		elseif FamilyBossInfo.type == 2 then
			XiaLayerOwner["lbBossCountDown"]:setVisible(true)
			-- XiaLayerOwner["lbBossCountDown"]:setSpriteFrame("pic_bossfallback.png")
			XiaLayerOwner["lbBossCountDown"]:setString(ZGMultiLan("lbBossCountDown_retreat"))
			if bInit then
				TimeDown:setTimeInfo(FamalyTimerId, FamilyBossInfo.count, XiaLayerOwner["mBossCountDown"], statechange2, TimeDown.HH_MM_SS) 
				SetDownTimeForLabel(XiaLayerOwner["mBossCountDown"], FamilyBossInfo.count, TimeDown.HH_MM_SS)
			end
		else
			XiaLayerOwner["lbBossCountDown"]:setVisible(false)
		end
		-- print("111111111",table.maxn(TimeDown.timerIdArr))
		
		if FamilyBossInfo.status == STATE_NOT_JOIN then
			XiaLayerOwner["mFamilyBossList2"]:setVisible(false)
			XiaLayerOwner["mFamilyBossJoin"]:setVisible(true)
			XiaLayerOwner["mFamilyBossAdd"]:setVisible(false)
		elseif FamilyBossInfo.status == STATE_IS_JOIN then
			XiaLayerOwner["mFamilyBossList2"]:setVisible(true)
			XiaLayerOwner["mFamilyBossJoin"]:setVisible(false)
			XiaLayerOwner["mFamilyBossAdd"]:setVisible(true)
		end
	end
end

local function SetFamilyInfo()
	XiaLayerOwner["mFamilyName"]:setString("Lv."..UserFamilyInfo.info.level.." "..UserFamilyInfo.info.name)
	XiaLayerOwner["mFamilyExp"]:setString(MultiLan("GFL_unionInfo_1")..UserFamilyInfo.info.exp.."/"..GameData:getGameDataTable().union[UserFamilyInfo.info.level].exp)
	XiaLayerOwner["mFamilyId"]:setString(MultiLan("GFL_unionInfo_2")..UserFamilyInfo.info.id)
	XiaLayerOwner["mFamilyPeople"]:setString(MultiLan("GFL_unionInfo_3")..UserFamilyInfo.info.count.."/"..GameData:getGameDataTable().union[UserFamilyInfo.info.level].num_max)
	--UserFamilyInfo.info.exp = 1000
	familyExpBar:setPercentage(UserFamilyInfo.info.exp * 100 / GameData:getGameDataTable().union[UserFamilyInfo.info.level].exp)
	XiaLayerOwner["mFamilyNotice"]:setString(UserFamilyInfo.info.announcement)
end
	
--刷新推荐帮会列表
local function UpdateFamilyList()
	-- print("UpdateFamilyList")
	local layer = cc.Layer:create()
	local line = table.maxn(adviceFamilyInfo)

	--加入点击
	local function joinClick(node)
		local tag= tolua.cast(node, "cc.Node"):getTag()
		
		local function familyListCallback(jsonDataTable)
			if jsonDataTable.ret ~= 0 then
				-- cclog("familyInfoCallback failed %d", jsonDataTable.ret)
				return 
			end
			if jsonDataTable.data.status == 1 then
				CommonNote(MultiLan("GFL_exitUnion"), COLOR_RED)
				return
			end
			
			UserFamilyInfo = jsonDataTable.data
			UserSelfInfo.union = UserFamilyInfo.info.id
			bUserHasFamily = true
			FamilyEnter()
			CommonNote(MultiLan("GFL_enterSucceed"))
		end
		
		local function sendJoinFamlily()
			HttpSend("union/request", {"id="..adviceFamilyInfo[tag].id}, familyListCallback)
		end
		
		local richText = ccui.RichText:create()
		richText:ignoreContentAdaptWithSize(false)
		richText:setContentSize(cc.size(460, 70))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GFL_enterUnion_1"),DefaultFontName, FontSize3))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , adviceFamilyInfo[tag].id,DefaultFontName, FontSize3))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GFL_enterUnion_2"),DefaultFontName, FontSize3))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_GREEN, 255 , adviceFamilyInfo[tag].name,DefaultFontName, FontSize3))
		richText:pushBackElement(ccui.RichElementText:create(1, COLOR_WHITE, 255 ,MultiLan("GFL_enterUnion_3"),DefaultFontName, FontSize3))
		
		CreateSmallPopupWithCancel("joinguild", richText, sendJoinFamlily)
	end
	
	local y = 60 * line - 45
	local x=300
	for i=1,line do
		layer:addChild(CreateCommonSprite("board_memberinfo.png", cc.p(300, y)))
		layer:addChild(CreateCommonLabel("Lv."..adviceFamilyInfo[i].level, cc.p(x-280, y), FontSize4, nil, cc.p(0,0.5)))
		layer:addChild(CreateCommonLabel(adviceFamilyInfo[i].name, cc.p(x-80, y), FontSize4, COLOR_GREEN))
		layer:addChild(CreateCommonLabel(adviceFamilyInfo[i].count.."/"..GameData:getGameDataTable().union[adviceFamilyInfo[i].level].num_max, cc.p(x+80, y), FontSize4))
			
		local joinButton = CreateCommonButton("button_blue.png", cc.p(x+230, y), cc.size(144, 50), joinClick, {str=MultiLan("GFL_enter"), size = FontSize6})
		joinButton:setScale(0.7)
		joinButton:setTag(i)
		joinButton:setSwallowTouch(false)
		layer:addChild(joinButton)
		y = y- 60
	end

	layer:setContentSize(cc.size(600, math.max(580, 60*line-10)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mFamilyAdviceList"], layer, cc.p(0, 580-(60*line-10)), kScrollViewDirectionVertical)
	if 60  * line - 10 < 580 then
		scrolView:setTouchEnabled(false)
	end
end

local function FamilyLayerInit()
	-- print("FamilyLayerInit")
	XiaLayerOwner["mFamilyButton4"]:setVisible(true)
	XiaLayerOwner["lbBtnGuildList"]:setVisible(true)
	XiaLayerOwner["mFamilyButton8"]:setVisible(true)
	XiaLayerOwner["mGuildWarLayer"]:setVisible(false)
	-- XiaLayerOwner["mGuildWarReport"]:setVisible(false)
	-- XiaLayerOwner["mGuildWarGroupLayer"]:setVisible(false)
	-- XiaLayerOwner["mGuildWarGroupManagerLayer"]:setVisible(false)


	if bFamilyInited then
		return
	end
	bFamilyInited = true
	--文字
	XiaLayerOwner["mFamilyDesc1"]:setString(MultiLan("GFL_unionList"))
	-- XiaLayerOwner["mFamilyDesc1"]:setColor(EQUIP_COLOR_ARR[5])
	-- XiaLayerOwner["mFamilyExp"]:setColor(COLOR_YELLOW)
	-- XiaLayerOwner["mFamilyId"]:setColor(COLOR_CYAN)
	-- XiaLayerOwner["mFamilyPeople"]:setColor(COLOR_GREEN)
	familyExpBar = CreateCommonBar("pic_equiptiao02.png", Pos(XiaLayerOwner["mFamilyExpBack"]:getContentSize())) 
	familyExpBar:setPercentage(0)
	XiaLayerOwner["mFamilyExpBack"]:addChild(familyExpBar)
	
	--boss
	XiaLayerOwner["mFamilyBossOpen"]:setTitleForState(MultiLan("GFL_unionBoss_1"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mFamilyBossList1"]:setTitleForState(MultiLan("GFL_unionBoss_2"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mFamilyBossList2"]:setTitleForState(MultiLan("GFL_unionBoss_3"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mFamilyBossJoin"]:setTitleForState(MultiLan("GFL_enter"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mFamilyBossAdd"]:setTitleForState(MultiLan("GFL_unionBoss_4"), cc.CONTROL_STATE_NORMAL)
	-- XiaLayerOwner["mBossLevel"]:setColor(COLOR_RED)
	
	-- XiaLayerOwner["mBossDesc2"]:setColor(COLOR_CYAN)
	-- XiaLayerOwner["mBossDesc3"]:setColor(COLOR_CYAN)
	XiaLayerOwner["mBossHp"]:setString(MultiLan("GFL_unionBoss_5"))
	--XiaLayerOwner["mGuildAct2"]:setTitleForState(MultiLan("GAL_pleaseWait"))
	-- XiaLayerOwner["mGuildAct3"]:setTitleForState(MultiLan("GAL_pleaseWait"))
	bossHpBar =  CreateCommonBar("pic_bossblood2.png", Pos(XiaLayerOwner["mBossBlood"]:getContentSize())) 
	bossHpBar:setPercentage(0)
	XiaLayerOwner["mBossBlood"]:addChild(bossHpBar)
	XiaLayerOwner["lb_family_vip_auto"]:setString(MultiLan("family_vip_auto"))
	XiaLayerOwner["lb_family_vip_auto"]:enableOutline(cc.c3b(0,0,0),1)
	-- XiaLayerOwner["mUnionBossLayer"]:addChild(CreateCommonLabel(MultiLan("family_vip_auto"),Pos(XiaLayerOwner["mUnionBossLayer"]:getContentSize(),0.5,0),FontSize2,COLOR_YELLOW,cc.p(0.5,0.9)))
end

function FamilyEnter()
	FamilyLayerInit()
	if UserFamilyInfo.signin == 1 then
		GameGuide:setButtonNote(XiaLayerOwner["mFamilyButton5"], false)
	else
		GameGuide:setButtonNote(XiaLayerOwner["mFamilyButton5"], true)
	end

	if bUserHasFamily then
		UserSelfInfo.union = UserFamilyInfo.info.id
		XiaLayerOwner["mFamilyGuideLayer"]:setVisible(false)
		XiaLayerOwner["mFamilySceneLayer"]:setVisible(true)
		SetFamilyInfo()
		SetBossInfo(true)
		table.sort(UserFamilyInfo.member, sortMember)
	else
		UserSelfInfo.union = 0
		XiaLayerOwner["mFamilyGuideLayer"]:setVisible(true)
		XiaLayerOwner["mFamilySceneLayer"]:setVisible(false)
		-- print("adviceFamilyInfo")
		adviceFamilyInfo = UserFamilyInfo.recommend
		-- print(table.maxn(adviceFamilyInfo))
		UpdateFamilyList()
	end
end

function FamilyExit()
	TimeDown:unregister(FamalyTimerId)
	if XiaLayerOwner["mGuildWarLayer"]:getChildByTag(1) ~= nil then
		if guildWarLayer ~= nil then
			scheduler:unscheduleScriptEntry(guildWarLayer.daojishi)
			XiaLayerOwner["mGuildWarLayer"]:removeAllChildren(true)
		end
	end
end
function showGuildRankList(data)
	
	local roleListInfo = data.zg_list
	-- print("#------------"..#roleListInfo)
	local roleType = 1
    
	local ranklayer = RankLayer:new()
	if data.rank ~= 0 then
		mytoptitle = MultiLan("union_battle_24")..data.rank
	else
		mytoptitle = MultiLan("union_battle_25")
	end
    ranklayer:create({roleType = 5,title = mytoptitle})
    local layerNode = ranklayer.topNode   
	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode)  

	--内容
    local scrollLayer = ranklayer.scrollLayer
    local layer = cc.Layer:create()
    local count = table.maxn(roleListInfo)
    local cellSize = Rankcell.getCellSize()
    local y = count * cellSize.height
    layer:setContentSize(cc.size(cellSize.width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
    for i = 1, count do
    	-- cclog(i)
    		local rankcell = Rankcell:new()
            rankcell:create({
            	isGuildRank = true,
            	rank = i,
            	name = roleListInfo[i].name, 
            	family = roleListInfo[i].power,
            	ranks = roleListInfo[i].idx,
            	power = roleListInfo[i].total_power,
            	sign = roleListInfo[i].sign,
            	sex = roleListInfo[i].sex,
                head = roleListInfo[i].role,
                leavel = roleListInfo[i].level,
                uid = roleListInfo[i].uid,
            	})
            local cellNode = rankcell.topNode 
            cellNode:setPositionY(y - i * cellSize.height)   
	        layer:addChild(cellNode)
    end
end
-- 	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
-- 	local scrollLayer  = CreateLayer(cc.size(600,640), 1, Pos(POPUP_SIZE_MAX,0.5,0.505))--nil,nil,cc.c4b(0,255,0,255))
-- 	scrollLayer:setScale(0.98)
-- 	popupContent:addChild(scrollLayer)
	
-- 	--ÄÚÈÝ
-- 	local layer = cc.Layer:create()
-- 	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0,0), kScrollViewDirectionVertical)
-- 	local scrollWorldPos = scrollLayer:convertToWorldSpace(cc.p(scrolView:getPosition()))
-- 	local scrollViewSize = scrolView:getViewSize()
-- 	local count = table.maxn(roleListInfo)
-- 	print("count", count)
-- 	local y = count*140-80
-- 	for i=1, count do
-- 		local back = nil
-- 		local speNums = {"pic_pvpfirst.png", "pic_pvpsecond.png", "pic_pvpthird.png"}
-- 		if i<=3 then
-- 			back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
-- 			back:addChild(CreateCommonSprite(speNums[i], cc.p(522, 72)))
-- 		else
-- 			back = CreateCommonSprite("board_overmap.png", cc.p(300, y))
-- 			back:addChild(CreateCommonSprite("pic_pvpnumber.png", cc.p(522, 64)))
-- 			back:addChild(CreateCommonLabel(i, cc.p(522,64), FontSize3)) 
-- 		end
-- 		local clickButton = CreateCommonButton("pic_suiyiaaa.png", cc.p(291, 64), cc.size(582,128), onPlayerDetailClick)
-- 		clickButton:setSwallowTouch(false)
-- 		clickButton:setName(roleListInfo[i].uid)
-- 		--clickButton:setScrollViewRect(cc.rect(scrollWorldPos.x, scrollWorldPos.y, scrollViewSize.width, scrollViewSize.height))
-- 		back:addChild(clickButton, 0, roleListInfo[i].uid)
		
-- 		layer:addChild(back)
		
-- 		local nameLayer = CreateCommonSprite("board_skill01.png", cc.p(291, 96))
-- 		back:addChild(nameLayer)
-- 		setFamilyAndScore(nameLayer, roleListInfo[i].name, roleListInfo[i].power)
			
-- 		local listLayer = CreateCommonSprite("board_skill02.png", cc.p(291, 41))
-- 		back:addChild(listLayer)

-- 		setListAndMaster(listLayer ,roleListInfo[i].idx, roleListInfo[i].power, roleListInfo[i].sign)
-- 		--Í·Ïñ
-- 		local head = CreateCommonSprite("board_skill02.png", cc.p(60, 64))
-- 		setUserHead(head, roleListInfo[i].role)
-- 		back:addChild(head)
-- 		back:addChild(CreateCommonSprite("school_icon_"..roleListInfo[i].role..".png", cc.p(30, 110)))
-- 		back:addChild(CreateCommonLabel("Lv."..roleListInfo[i].level, cc.p(70, 18), FontSize2))
		
-- 		y = y - 140
-- 	end


-- 	layer:setContentSize(cc.size(600, math.max(640, 140*count-10)))
-- 	scrolView:setContentOffset(cc.p(0, 640-(140*count-10)))
-- 	if 140*count-10 < 630 then
-- 		scrolView:setTouchEnabled(false)
-- 	end
	
-- 	--ËµÃ÷
-- 	local ruleBack = CreateCommonSprite("board_skill01.png", Pos(POPUP_SIZE_MAX,0.5,0.91))
-- 	ruleBack:setScaleX(1.6)
-- 	popupContent:addChild(ruleBack)
-- 	if data.rank ~= 0 then
-- 		popupContent:addChild(CreateCommonLabel(MultiLan("union_battle_24")..data.rank,Pos(POPUP_SIZE_MAX,0.5,0.91), FontSize3))
-- 	else
-- 		popupContent:addChild(CreateCommonLabel(MultiLan("union_battle_25"),Pos(POPUP_SIZE_MAX,0.5,0.91), FontSize3))
-- 	end	
-- 	local popupRoot = CommonCreatePopupMax("bhphang", popupContent)
-- 	--¹Ø±Õ
-- 	local function closeFunc()
-- 		removeSelf(popupRoot)
-- 	end
-- 	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), closeFunc, {str = MultiLan("button_close"), size = FontSize6}))
-- end

function onGuildRankList()
	local function rankInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end

		showGuildRankList(jsonDataTable.data)
	end

	HttpSend("union/battlerank", {}, rankInfoCallback)
end
--帮会成员

local function utfstrlen(str)
	local len = #str;
	local left = len;
	local cnt = 0;
	local arr={0,0xc0,0xe0,0xf0,0xf8,0xfc};
	local basecount = 1
	while left ~= 0 do
		local tmp=string.byte(str,-left);
		local i=#arr;
		basecount = 1
		while arr[i] do
			if tmp>=arr[i] then 
				left=left-i;
				if i ~= 1 then
					basecount = 2
				end
				break;
			end
			i=i-1;
		end
		cnt=cnt+basecount;
	 end
	 return cnt;
end
	
local function GetStateByOnlineTime(t)
	-- print("t",t)
	local str = MultiLan("GFL_onlineTime_1")
	local color = COLOR_WHITE
	if t > 3600 then
		color = EQUIP_COLOR_ARR[1]
	end
	
	
	if t > 3600 and t < 3600*24 then
		str = math.floor(t/3600)..MultiLan("GFL_onlineTime_2")
	elseif t > 3600*24 and t < 3600*72 then
		str = MultiLan("GFL_onlineTime_3")
	elseif t > 3600*24 and t < 3600*48 then
		str = MultiLan("GFL_onlineTime_4")
	elseif t > 3600*72 then
		str = MultiLan("GFL_onlineTime_5")
	end
	
	return str,color
end

local function onFamilyMember()
	-- print("onFamilyMember", getSecondHostCount())
	local positionArr = {p0=MultiLan("GFL_unionMember_1"), p10=MultiLan("GFL_unionMember_2"), p100=MultiLan("GFL_unionMember_3")}
	local positionColor = {p0=EQUIP_COLOR_ARR[5], p10=EQUIP_COLOR_ARR[4], p100=COLOR_WHITE}

	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,600), 1, Pos(POPUP_SIZE_MAX,0.5,0.46))--nil,nil,cc.c4b(0,255,0,255))
	popupContent:addChild(scrollLayer)
	--说明
	popupContent:addChild(CreateCommonSprite("board_guildlevel.png",Pos(POPUP_SIZE_MAX,0.5,0.91)))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_4")..UserFamilyInfo.info.level, Pos(POPUP_SIZE_MAX, 0.22, 0.926),FontSize4, nil, cc.p(0,0.5)))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_5")..UserFamilyInfo.info.count.."/"..GameData:getGameDataTable().union[UserFamilyInfo.info.level].num_max, Pos(POPUP_SIZE_MAX, 0.78, 0.926),FontSize4, nil, cc.p(1,0.5)))
	popupContent:addChild(CreateCommonSprite("board_guildthings.png", Pos(POPUP_SIZE_MAX,0.5,0.847)))
	--等级 角色名 战力 职位 状态
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_6"), Pos(POPUP_SIZE_MAX, 0.1, 0.847),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_7"), Pos(POPUP_SIZE_MAX, 0.28, 0.847),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_8"), Pos(POPUP_SIZE_MAX, 0.51, 0.847),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_9"), Pos(POPUP_SIZE_MAX, 0.7, 0.847),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_10"), Pos(POPUP_SIZE_MAX, 0.87, 0.847),FontSize2, COLOR_ORANGE))
	
	local root1 = CommonCreatePopupMax("guildmember", popupContent, true)
	
	--帮会成员点击
	local function onMemberClick(node)
		local tag= tolua.cast(node, "cc.Node"):getTag()
		local memberInfo = UserFamilyInfo.member[tag]
		local myInfo = getMyMemberInfo()
		
		local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
		local head = SetMyHead(memberInfo.role,memberInfo.sex,2)
		popupContet:addChild(CreateCommonSprite(head, Pos(POPUP_SIZE_SML,0.16,0.56)))
		if memberInfo.uid == UserSelfInfo.uid then
			popupContet:addChild(CreateCommonLabel("Lv."..UserSelfInfo.level, Pos(POPUP_SIZE_SML,0.28,0.76), FontSize2, nil, cc.p(0,0.5)))
			popupContet:addChild(CreateCommonLabel(UserAttr:getFightNum(), Pos(POPUP_SIZE_SML,0.4,0.54), FontSize2, EQUIP_COLOR_ARR[3], cc.p(0,0.5)))
		else
			popupContet:addChild(CreateCommonLabel("Lv."..memberInfo.level, Pos(POPUP_SIZE_SML,0.28,0.76), FontSize2, nil, cc.p(0,0.5)))
			popupContet:addChild(CreateCommonLabel(memberInfo.power, Pos(POPUP_SIZE_SML,0.4,0.54), FontSize2, EQUIP_COLOR_ARR[3], cc.p(0,0.5)))
		end
		popupContet:addChild(CreateCommonLabel(memberInfo.name, Pos(POPUP_SIZE_SML,0.4,0.76), FontSize2, nil, cc.p(0,0.6)))
		popupContet:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_9"), Pos(POPUP_SIZE_SML,0.28,0.65), FontSize2, nil, cc.p(0,0.5)))
		popupContet:addChild(CreateCommonLabel(positionArr["p"..memberInfo.position], Pos(POPUP_SIZE_SML,0.4,0.65), FontSize2, positionColor[memberInfo.position+1], cc.p(0,0.5)))
		popupContet:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_8"), Pos(POPUP_SIZE_SML,0.28,0.54), FontSize2, nil, cc.p(0,0.5)))
		
		popupContet:addChild(CreateCommonLabel(MultiLan("CP_contribution"), Pos(POPUP_SIZE_SML,0.28,0.43), FontSize2, nil, cc.p(0,0.5)))
		popupContet:addChild(CreateCommonLabel(memberInfo.total_contribution, Pos(POPUP_SIZE_SML,0.4,0.43), FontSize2, EQUIP_COLOR_ARR[2], cc.p(0,0.5)))
		
		local root2 = CommonCreatePopupSmall("memberaction", popupContet, true)
		--[[ 查看自己同级和高级的都是关闭
		查看比自己低级的 分为 1 会长查看副会长   解除副帮主  转让帮会
							  2 会长查看会员     踢出帮会    任命副帮主
							  3 副帮主查看帮众   踢出帮会    任命副帮主	
		]]
		--关闭
		local function closeFunc()  
			removeSelf(root2) 
		end
		--踢出帮会
		local function kickOutFunc()
			local function kickOutCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					for i=1, table.maxn(UserFamilyInfo.member) do
						-- print(i,UserFamilyInfo.member[i].uid, jsonDataTable.data.del)
						if UserFamilyInfo.member[i].uid == jsonDataTable.data.del then
							table.remove(UserFamilyInfo.member, i)
							break
						end
					end
					UserFamilyInfo.info.count = UserFamilyInfo.info.count - 1
					CommonNote(MultiLan("GFL_unionManger_1"))
					removeSelf(root2)
					removeSelf(root1)
					SetFamilyInfo()
					onFamilyMember()
				end
			end
			local function sendKickOut()
				HttpSend("union/del", {"del="..memberInfo.uid}, kickOutCallback)
			end
			
			CreateSmallPopupWithCancel("kickguild", CreateCommonLabel(MultiLan("GFL_unionManger_2"), nil, FontSize3), sendKickOut)
		end
		--任命副帮主
		local function setSecondHost()
			-- print("setSecondHost")
			local function setSecondCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					-- print("setSecondCallback")
					for i=1, table.maxn(UserFamilyInfo.member) do
						if UserFamilyInfo.member[i].uid == jsonDataTable.data.touid then
							UserFamilyInfo.member[i].position = jsonDataTable.data.position
						end
					end
					-- print(1)
					CommonNote(MultiLan("GFL_unionManger_3"))
					-- print(2)
					removeSelf(root2)
					removeSelf(root1)
					onFamilyMember()
				end
			end
			
			local secondHost = getSecondHostCount()
			if myInfo.position ~= 0 then
				CommonNote(MultiLan("GFL_unionManger_4"))
			elseif secondHost >= UserFamilyInfo.info.level then
				CommonNote(string.format(MultiLan("GFL_unionManger_5"),tostring(secondHost),tostring(secondHost)))
			else
				HttpSend("union/assign", {"touid="..memberInfo.uid, "pos=10"},setSecondCallback)
			end
		end
		--解除副帮主
		local function unsetSecondHost()
			local function unsetSecondCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					for i=1, table.maxn(UserFamilyInfo.member) do
						if UserFamilyInfo.member[i].uid == jsonDataTable.data.touid then
							UserFamilyInfo.member[i].position = jsonDataTable.data.position
						end
					end
					
					CommonNote(MultiLan("GFL_unionManger_6"))
					removeSelf(root2)
					removeSelf(root1)
					onFamilyMember()
				end
			end
			
			HttpSend("union/assign", {"touid="..memberInfo.uid, "pos=100"},unsetSecondCallback)
		end
		--转让帮会
		local function exchangeHost()
			local function exchangeHostCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					myInfo.position = 10
					for i=1, table.maxn(UserFamilyInfo.member) do
						if UserFamilyInfo.member[i].uid == jsonDataTable.data.touid then
							UserFamilyInfo.member[i].position = 0
						end
					end
					table.sort(UserFamilyInfo.member, sortMember)
					CommonNote(MultiLan("GFL_unionManger_7"))
					removeSelf(root2)
					removeSelf(root1)
					onFamilyMember()
				end
			end
			local function sendExchange()
				HttpSend("union/transfer", {"touid="..memberInfo.uid}, exchangeHostCallback)
			end
			
			CreateSmallPopupWithCancel("buyguild", CreateCommonLabel(MultiLan("GFL_unionManger_8"), nil, FontSize3), sendExchange)
		end
		
		if myInfo.position >= memberInfo.position then
			popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.5, 0.15), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
		else
			if myInfo.position == 0 and memberInfo.position == 10 then
				popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.15), cc.size(144,50), unsetSecondHost, {str=MultiLan("GFL_unionManger_9"), size = FontSize6}))
				popupContet:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_SML, 0.7, 0.15), cc.size(144,50), exchangeHost, {str=MultiLan("GFL_unionManger_10"), size = FontSize6}))
			else
				popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.15), cc.size(144,50), kickOutFunc, {str=MultiLan("GFL_unionManger_11"), size = FontSize6}))
				popupContet:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_SML, 0.7, 0.15), cc.size(144,50), setSecondHost, {str=MultiLan("GFL_unionManger_12"), size = FontSize6}))
			end
		end
	end
	
	--滚动列表
	local layer = cc.Layer:create()
	local count = table.maxn(UserFamilyInfo.member)
	local y = count*50-30
	for i=1, count do
		local memberInfo = UserFamilyInfo.member[i]
		local clickButton = CreateCommonButton("pic_suiyiaaa.png", cc.p(300, y),cc.size(600,44),onMemberClick)
		clickButton:setSwallowTouch(false)
		layer:addChild(clickButton,0,i)
	
		layer:addChild(CreateCommonSprite("board_memberinfo.png", cc.p(300, y)))
		layer:addChild(CreateCommonLabel(memberInfo.name, cc.p(160, y),FontSize2, positionColor["p"..memberInfo.position]))
		if memberInfo.uid == UserSelfInfo.uid then
			layer:addChild(CreateCommonLabel("Lv."..UserSelfInfo.level, cc.p(44, y),FontSize2, positionColor["p"..memberInfo.position]))
			layer:addChild(CreateCommonLabel(UserAttr:getFightNum(), cc.p(305, y),FontSize2, positionColor["p"..memberInfo.position]))
		else
			layer:addChild(CreateCommonLabel("Lv."..memberInfo.level, cc.p(44, y),FontSize2, positionColor["p"..memberInfo.position]))
			layer:addChild(CreateCommonLabel(memberInfo.power, cc.p(305, y),FontSize2, positionColor["p"..memberInfo.position]))
		end
		
		layer:addChild(CreateCommonLabel(positionArr["p"..memberInfo.position], cc.p(428, y),FontSize2, positionColor["p"..memberInfo.position]))
		local stateDesc,stateColor = GetStateByOnlineTime(memberInfo.online)
		layer:addChild(CreateCommonLabel(stateDesc, cc.p(534, y), FontSize2, stateColor))

		y = y - 50
	end
	layer:setContentSize(cc.size(600, math.max(600, 50*count-5)))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 600-(50*count-10)), kScrollViewDirectionVertical)
	if 50*count-10 < 600 then
		scrolView:setTouchEnabled(false)
	end

	--退出帮会
	local function quitCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("quitCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserSelfInfo.union = 0
		removeSelf(root1)
		--切换到主页
		local node = cc.Node:create()
		node:setTag(1)
		ShowNew(node)
		
		CommonNote(MultiLan("GFL_exitUnion_1"))
	end
	
	local function sendQuit()
		local myMemberInfo = getMyMemberInfo()
		if myMemberInfo.position == 0 and table.maxn(UserFamilyInfo.member) > 1 then
			CommonNote(MultiLan("GFL_exitUnion_2"))
			return
		end

		HttpSend("union/quit", {}, quitCallback)
	end
	
	local function quitFunc()
        local content = cc.Label:create(MultiLan("GFL_exitUnion_3"), DefaultFontName, FontSize3,cc.size(460,160),0,1)
		CreateSmallPopupWithCancel("outguild", content, sendQuit)
	end
	
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.3,0.05), cc.size(144,50), quitFunc, {str=MultiLan("GFL_exitUnion_4"), size = FontSize6}))
	
	--帮会管理
    local powerLimitLable  = nil
    local familyAnnounceLable  = nil
	local function setFunc()
		local setLayer = CreateLayer(POPUP_SIZE_MID, 1, Pos(POPUP_SIZE_MID))
		local setRoot = CommonCreatePopupMid("guildmanage", setLayer, true)
		setLayer:addChild(CreateCommonLabel(MultiLan("GFL_unionMangerLay_1"), Pos(POPUP_SIZE_MID,0.5,0.87), FontSize4 ))

		--设置入帮条件
		local function setPowerFunc()
			if getMyMemberInfo().position ~= 0 then
				CommonNote(MultiLan("GFL_unionMangerLay_2"))
				return
			end
            ----pop editbox begin
            local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	        popupContet:addChild(CreateCommonLabel(MultiLan("GFL_unionMangerLay_3"), Pos(POPUP_SIZE_SML, 0.5,0.75), FontSize2, COLOR_GREEN))
            popupContet:addChild(CreateCommonLabel(MultiLan("GFL_unionMangerLay_4"), Pos(POPUP_SIZE_SML, 0.5,0.65), FontSize2, COLOR_WHITE))
	        local popupRoot = CommonCreatePopupSmall("guilcondition", popupContet)
	
	        local function closeFunc() removeSelf(popupRoot) end
	        popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.13), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
	
            local powerLimitEditBox = nil
            local function setPowerCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					CommonNote(MultiLan("GFL_unionMangerLay_5"))
					tolua.cast(powerLimitLable, "cc.Label"):setString(string.format(MultiLan("GFL_unionMangerLay_6"),tostring(jsonDataTable.data.power)))
                    removeSelf(popupRoot)
				end
			end

 			local function sendSetPower()
				-- print("sendSetPower")
                 local singature = tostring(tolua.cast(powerLimitEditBox,"cc.EditBox"):getText())
                 powerValue = tonumber(singature)
				 -- print(singature, powerValue)
                 if powerValue == nil then
                    powerValue = 0
                 end
                 if powerValue < 0 or powerValue > 999999 then
                    CommonNote(MultiLan("GFL_unionMangerLay_7"))
                    return
                 end
                
				HttpSend("union/power", {"power="..powerValue}, setPowerCallback)
			end
	        popupContet:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_SML, 0.7, 0.13), cc.size(144,50), sendSetPower, {str=MultiLan("button_ok"), size = FontSize6}))

            powerLimitEditBox = cc.EditBox:create(cc.size(460, 60), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	        popupContet:addChild(powerLimitEditBox)
		    powerLimitEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
			powerLimitEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	        powerLimitEditBox:setPlaceHolder(MultiLan("GFL_unionMangerLay_8"))
            --powerLimitEditBox:setInputMode(cc.kEditBoxInputModeNumeric)
	        powerLimitEditBox:setPosition(cc.p(popupContet:getContentSize().width / 2, popupContet:getContentSize().height / 2))
		end
		--设置公告
		local function setFamilyAnnounce()
			if getMyMemberInfo().position ~= 0 then
				CommonNote(MultiLan("GFL_unionMangerLay_9"))
				return
			end
            ----pop editbox begin
            local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	        popupContet:addChild(CreateCommonLabel(MultiLan("GFL_unionMangerLay_10"), Pos(POPUP_SIZE_SML, 0.5,0.7), FontSize2, COLOR_GREEN))
 	        local popupRoot = CommonCreatePopupSmall("guildnotice", popupContet)
	
	        local function closeFunc() removeSelf(popupRoot) end
	        popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.13), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
	
            local annouceEditBox = nil
            local function setAnnouceCallback(jsonDataTable)
				if jsonDataTable.ret == 0 then
					CommonNote(MultiLan("GFL_unionMangerLay_11"))
					tolua.cast(familyAnnounceLable, "cc.Label"):setString(tostring(tolua.cast(annouceEditBox,"cc.EditBox"):getText()))
                    UserFamilyInfo.info.announcement = tostring(tolua.cast(annouceEditBox,"cc.EditBox"):getText())
                    SetFamilyInfo()
                    removeSelf(popupRoot)
				end
			end

 			local function sendAnnouce()
                 local singature = tostring(tolua.cast(annouceEditBox,"cc.EditBox"):getText())
                 local announcementSize =  utfstrlen(singature)
                 if announcementSize < 1 or announcementSize > 80 then
                    CommonNote(MultiLan("GFL_unionMangerLay_12"))
                    return
                 end
                
				HttpSend("union/announcement", {"s="..singature}, setAnnouceCallback)
			end
	        popupContet:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_SML, 0.7, 0.13), cc.size(144,50), sendAnnouce, {str=MultiLan("button_ok"), size = FontSize6}))

            annouceEditBox = cc.EditBox:create(cc.size(460, 60), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	        popupContet:addChild(annouceEditBox)
		    annouceEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
			annouceEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	        annouceEditBox:setPlaceHolder(MultiLan("GFL_unionMangerLay_13"))
	        annouceEditBox:setPosition(cc.p(popupContet:getContentSize().width / 2, popupContet:getContentSize().height / 2))
		end	

        --------入会条件 begin
		local back = CreateCommonSprite("board_equip.png", Pos(POPUP_SIZE_MID,0.5,0.67))
		back:setScaleX(0.7)
		back:setScaleY(0.3)
		setLayer:addChild(back)
		setLayer:addChild(CreateCommonLabel(MultiLan("GFL_unionMangerLay_14"), Pos(POPUP_SIZE_MID,0.16,0.72), FontSize4,nil, cc.p(0,0.5)))
        powerLimitLable  = CreateCommonLabel(string.format(MultiLan("GFL_unionMangerLay_6"),tostring(UserFamilyInfo.info.power)), Pos(POPUP_SIZE_MID,0.16,0.65), FontSize4, COLOR_GREEN, cc.p(0,0.5))
		setLayer:addChild(powerLimitLable)
		local setButton = CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MID,0.7,0.65), cc.size(144,50), setPowerFunc, {str=MultiLan("button_setting"), size = FontSize6})
		setButton:setScale(0.9)
		setLayer:addChild(setButton)
        
        --------帮会公告 begin
		local backAnnounce = CreateCommonSprite("board_equip.png", Pos(POPUP_SIZE_MID,0.5,0.35))
		backAnnounce:setScaleX(0.7)
		backAnnounce:setScaleY(0.42)
		setLayer:addChild(backAnnounce)
		setLayer:addChild(CreateCommonLabel(MultiLan("GFL_unionMangerLay_15"), Pos(POPUP_SIZE_MID,0.16,0.48), FontSize4,nil, cc.p(0,0.5)))

        familyAnnounceLable  = cc.Label:create(UserFamilyInfo.info.announcement, DefaultFontName, FontSize4,cc.size(260,300),0,0)
        familyAnnounceLable:setColor(COLOR_GREEN)
        familyAnnounceLable:setPosition(Pos(POPUP_SIZE_MID,0.35,0.20))		
        setLayer:addChild(familyAnnounceLable)
		setButton = CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MID,0.7,0.35), cc.size(144,50), setFamilyAnnounce, {str=MultiLan("button_edit"), size = FontSize6})
		setLayer:addChild(setButton)
     
	end

	popupContent:addChild(CreateCommonButton("button_blue.png", Pos(POPUP_SIZE_MAX,0.7,0.05), cc.size(144,50), setFunc, {str=MultiLan("GFL_unionMangerLay_16"), size = FontSize6}))
end

--刷新帮会排行
local function FamilyList()
	local layer = cc.Layer:create()
	local count = 20--table.maxn(famillyListInfo)
	-- print("count", count)
	local y = count*50-30
	for i=1, count do
		layer:addChild(CreateCommonLabel(i, cc.p(44 , y),FontSize2))
		layer:addChild(CreateCommonLabel(famillyListInfo[i].id,   cc.p(111,y),FontSize2))
		layer:addChild(CreateCommonLabel("Lv."..famillyListInfo[i].level, cc.p(190,y),FontSize2))
		layer:addChild(CreateCommonLabel(famillyListInfo[i].name, cc.p(345,y),FontSize2))
		layer:addChild(CreateCommonLabel(famillyListInfo[i].name, cc.p(490,y),FontSize2))
		y = y - 50
	end

	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,600), 1, Pos(POPUP_SIZE_MAX,0.5,0.485))--nil,nil,cc.c4b(0,255,0,255))
	popupContent:addChild(scrollLayer)
	layer:setContentSize(cc.size(600, math.max(600, 50*count-5)))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 600-(50*count-10)), kScrollViewDirectionVertical)
	if 50*count-10 < 600 then
		scrolView:setTouchEnabled(false)
	end
	
	--说明
	if bUserHasFamily then
		popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionRank_1").." ",Pos(POPUP_SIZE_MAX,0.075,0.912), FontSize4, COLOR_GREEN, cc.p(0,0.5)))
	end
	popupContent:addChild(CreateCommonSprite("board_guildthings.png", Pos(POPUP_SIZE_MAX,0.5,0.872)))
	--排名 id 等级 名称 会长
	popupContent:addChild(CreateCommonLabel(MultiLan("lan_rank"), Pos(POPUP_SIZE_MAX,0.1,0.872),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("lan_id"),   Pos(POPUP_SIZE_MAX,0.2,0.872),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("lan_level"), Pos(POPUP_SIZE_MAX,0.33,0.872),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionRank_2"), Pos(POPUP_SIZE_MAX,0.57,0.872),FontSize2, COLOR_ORANGE))
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_1"), Pos(POPUP_SIZE_MAX,0.8,0.872),FontSize2, COLOR_ORANGE))
	
	local popupRoot = CommonCreatePopupMax("guildranking", popupContent,true)
end

--帮会排行
local function onFamilyList()
	local function familyListCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("familyListCallback failed %d", jsonDataTable.ret)
			return 
		end
		
		famillyListInfo = jsonDataTable.data
		FamilyList()
	end
	
	--HttpSend("union/rank", {}, familyListCallback)
	CommonNote(MultiLan("GFL_unionRank_3"))
end

--创建帮会



local function onFamilyCreate()
	local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	popupContet:addChild(CreateCommonLabel(MultiLan("GFL_creatUnionNeed"), Pos(POPUP_SIZE_SML, 0.5,0.7), FontSize2, COLOR_GREEN))
	
	local popupRoot = CommonCreatePopupSmall("newguild", popupContet)
	
	local function closeFunc() removeSelf(popupRoot) end
	popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.13), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
	
    local FamilyNameEditBox = nil
    local function creatFamilyCallback(jsonDataTable)
    	if jsonDataTable.ret ~= 0 then
			return 
		end

        if jsonDataTable.data ~= CJSON_NULL then
            UserFamilyInfo = jsonDataTable.data
			UserSelfInfo.union = UserFamilyInfo.info.id
            bUserHasFamily = true
			FamilyEnter()
            UserInfo:setCash(UserInfo:getCash() - 300)
            XiaLayer:SetHomeUserInfo()
        end
        
        removeSelf(popupRoot)
    end

	local function creatFamilyFunc()
        local familyName = tostring(tolua.cast(FamilyNameEditBox,"cc.EditBox"):getText())
        local nameLen = utfstrlen(familyName)
        if nameLen < 4 or nameLen > 14 then
           CommonNote(MultiLan("GFL_creatUnion_1"))
           return
        end
		
		if UserSelfInfo.cash < 300 then
			CommonCashNeed()
			return
		end
        HttpSend("union/create", {"name="..familyName}, creatFamilyCallback)
	end

	popupContet:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_SML, 0.7, 0.13), cc.size(144,50), creatFamilyFunc, {str=MultiLan("GFL_creatUnion_2"), size = FontSize6}))

    FamilyNameEditBox = cc.EditBox:create(cc.size(460, 60), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	popupContet:addChild(FamilyNameEditBox)
	FamilyNameEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
	FamilyNameEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	FamilyNameEditBox:setPlaceHolder(MultiLan("GFL_creatUnion_3"))
	FamilyNameEditBox:setPosition(cc.p(popupContet:getContentSize().width / 2, popupContet:getContentSize().height / 2))

end

--刷新
local function onFamilyRefresh()
	local function familyRefreshCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("familyRefreshCallback failed %d", jsonDataTable.ret)
			return 
		end
		adviceFamilyInfo = jsonDataTable.data.recommend
		if table.maxn(adviceFamilyInfo) > 0 then
			UpdateFamilyList()
		else
			CommonNote(MultiLan("GFL_creatUnion_4"))
			CommonNote(MultiLan("GFL_creatUnion_5"))
		end
	end
	
	HttpSend("union/refresh", {}, familyRefreshCallback)
end

--搜索帮会
local function onFamilySearch()
	-- print("onFamilySearch")
    ----pop editbox begin
    local popupContet = CreateLayer(POPUP_SIZE_SML, 1, Pos(POPUP_SIZE_SML))
	popupContet:addChild(CreateCommonLabel(MultiLan("GFL_unionInfo_2"), Pos(POPUP_SIZE_SML, 0.25,0.76), FontSize4, COLOR_GREEN))
    popupContet:addChild(CreateCommonLabel(MultiLan("GFL_searchUnion_1"), Pos(POPUP_SIZE_SML, 0.5,0.65), FontSize2, COLOR_WHITE))
	local popupRoot = CommonCreatePopupSmall("searchguild", popupContet)
	-- print(1)
	local function closeFunc() removeSelf(popupRoot) end
	popupContet:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_SML, 0.3, 0.13), cc.size(144,50), closeFunc, {str=MultiLan("button_cancel"), size = FontSize6}))
	
    local familySearchEditBox = nil
    local function familySearchCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if jsonDataTable.data == CJSON_NULL then
				CommonNote(MultiLan("GFL_searchUnion_2"))
			else
				adviceFamilyInfo = {}
				table.insert(adviceFamilyInfo, jsonDataTable.data)
				UpdateFamilyList()
			end
		end
	end

 	local function sendFamilySearch()
        local familyIdStr = tostring(tolua.cast(familySearchEditBox,"cc.EditBox"):getText())
        local familyId = tonumber(familyIdStr)
        if familyId == nil then
            CommonNote(MultiLan("GFL_searchUnion_2"))
            return
        end
		HttpSend("union/search", {"id="..familyId}, familySearchCallback)
        removeSelf(popupRoot)
	end
	popupContet:addChild(CreateCommonButton("button_green.png", Pos(POPUP_SIZE_SML, 0.7, 0.13), cc.size(144,50), sendFamilySearch, {str=MultiLan("GFL_searchUnion_3"), size = FontSize6}))
    familySearchEditBox = cc.EditBox:create(cc.size(460, 60), cc.Scale9Sprite:createWithSpriteFrameName("board_account01.png"))
	popupContet:addChild(familySearchEditBox)
	familySearchEditBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
	familySearchEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	familySearchEditBox:setPlaceHolder(MultiLan("GFL_searchUnion_4"))
    familySearchEditBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	familySearchEditBox:setPosition(cc.p(popupContet:getContentSize().width / 2, popupContet:getContentSize().height / 2))
end

local function onFamilySign()
	local function signCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			UserFamilyInfo.info.level = jsonDataTable.data.level
			UserFamilyInfo.info.exp   = jsonDataTable.data.exp
			local myMemberInfo = getMyMemberInfo()
			myMemberInfo.contribution = myMemberInfo.contribution + jsonDataTable.data.contribution
			myMemberInfo.total_contribution = myMemberInfo.total_contribution + jsonDataTable.data.contribution
			
			UserFamilyInfo.signin = 1
			UserInfo:addProp(jsonDataTable.data.prop)
			CommonNote({MultiLan("GFL_sign_1"), 
						MultiLan("GFL_sign_2")..jsonDataTable.data.contribution,
						MultiLan("GFL_sign_3")..jsonDataTable.data.prop[1].num,
						" ",
						MultiLan("GFL_sign_4")..jsonDataTable.data.addexp})
			GameGuide:setButtonNote(XiaLayerOwner["mFamilyButton5"], false)
			SetFamilyInfo()
		end
	end
	
	if UserFamilyInfo.signin == 0 then
		HttpSend("union/signin",{},signCallback)
	else
		CommonNote(MultiLan("GFL_sign_5"))
	end
end

local function onFamilyShop()
	local function arenaShopCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("arenaInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		CommonShopInfo = jsonDataTable.data
		CommonCreateShopPopup(SHOP_TYPE_FAMILY)
	end

	HttpSend("shop/info", {"id="..SHOP_TYPE_FAMILY}, arenaShopCallback)
end

--鼓舞
local function onFamilyBossAdd()
	if UserFamilyInfo.boss.status ~= STATE_IS_JOIN then
		return
	end
	
	if UserFamilyInfo.boss.inspire >= 200 then
		CommonNote(MultiLan("GFL_inspire_3"))
		return
	end
	
	if UserSelfInfo.cash <= INSPIRE_CASH then
		CommonCashNeed()
		return
	end
	
	local function inspireCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			UserFamilyInfo.boss.inspire = UserFamilyInfo.boss.inspire + jsonDataTable.data.add
			--扣钱
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
			UseCash(jsonDataTable.data.cash)
			CommonNote(MultiLan("GFL_inspire_4"))
			CommonNote(MultiLan("GFL_inspire_5"))
			SetBossInfo()
		end 
	end
	
	HttpSend("union/inspire", {}, inspireCallback)
end

local function onFamilyBossOpen()
	if getMyMemberInfo().position > 10 then
		CommonNote(MultiLan("GFL_openBoss_1"))
		return
	end
	
	local cost = 0
	if UserFamilyInfo.boss.num >= 1 then
		cost = 500 * UserFamilyInfo.boss.num
	end
	
	local function bossOpenCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			UserFamilyInfo.boss = jsonDataTable.data.boss
			--扣钱
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
			UseCash(jsonDataTable.data.cash)

			SetBossInfo(true)
			CommonNote(MultiLan("GFL_openBoss_2"))
		end 
	end
	
	local function sendOpenBoss()
		if UserSelfInfo.cash < cost then
			CommonCashNeed(cost)
		else
			HttpSend("union/openboss", {}, bossOpenCallback)
		end
	end
	
	local desc = MultiLan("GFL_openBoss_3")
	if cost > 0 then
		desc = desc..string.format(MultiLan("GFL_openBoss_4"),tostring(cost),tostring(MultiLan("prop_name_100001")))
	else
		desc = desc..MultiLan("GFL_openBoss_5")
	end
	desc = desc..string.format(MultiLan("GFL_openBoss_6"),tostring(math.max(0,1-UserFamilyInfo.boss.num)))
    local content = cc.Label:create(desc, DefaultFontName, FontSize3,cc.size(460,160),0,1)
	CreateSmallPopupWithCancel("startboss", content, sendOpenBoss)

end

local function onFamilyBossJoin()
	if UserFamilyInfo.boss.status ~= STATE_NOT_JOIN then
		return
	end
	
	local function bossJoinCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if jsonDataTable.data.join_status == 1 then
				CommonNote(MultiLan("GFL_openBoss_7"), COLOR_RED)
				return
			end
		
			UserFamilyInfo.boss = jsonDataTable.data
			SetBossInfo(true)
			CommonNote(MultiLan("GFL_openBoss_8"))
		end 
	end

	HttpSend("union/joinboss", {}, bossJoinCallback)
end

local function showDamageList(listTable)
	local layer = cc.Layer:create()
	local count = table.maxn(listTable)
	-- print("count", count)
	local y = count*50-30
	local myRank = 0
	local myDamage = 0
	for i=1, count do
		layer:addChild(CreateCommonSprite("board_memberinfo.png", cc.p(300, y)))
		layer:addChild(CreateCommonLabel(i, cc.p(44 , y),FontSize2))
		layer:addChild(CreateCommonLabel(listTable[i].name,   cc.p(180,y),FontSize2))
		layer:addChild(CreateCommonLabel(listTable[i].damage, cc.p(400,y),FontSize2))
		layer:addChild(CreateCommonLabel(string.format("%.1f", math.ceil(listTable[i].damage*1000/FamilyBossData.hp)/10).."%", cc.p(530,y),FontSize2))
		y = y - 50
		if UserSelfInfo.uid == listTable[i].id then
			myRank = i
			myDamage = listTable[i].damage
		end
	end

	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,600), 1, Pos(POPUP_SIZE_MAX,0.5,0.485))--nil,nil,cc.c4b(0,255,0,255))
	popupContent:addChild(scrollLayer)
	layer:setContentSize(cc.size(600, math.max(600, 50*count-5)))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, 600-(50*count-10)), kScrollViewDirectionVertical)
	if 50*count-10 < 600 then
		scrolView:setTouchEnabled(false)
	end
	
	--说明
	if myRank == 0 then
		popupContent:addChild(CreateCommonLabel(MultiLan("GFL_bossRank_1"),Pos(POPUP_SIZE_MAX,0.075,0.912), FontSize4, COLOR_GREEN, cc.p(0,0.5)))
		popupContent:addChild(CreateCommonLabel(MultiLan("GFL_bossRank_2"),Pos(POPUP_SIZE_MAX,0.925,0.912), FontSize4, COLOR_GREEN, cc.p(1,0.5)))
	else
		popupContent:addChild(CreateCommonLabel(MultiLan("GFL_bossRank_3")..myRank,Pos(POPUP_SIZE_MAX,0.075,0.912), FontSize4, COLOR_GREEN, cc.p(0,0.5)))
		popupContent:addChild(CreateCommonLabel(MultiLan("GFL_bossRank_4")..myDamage,Pos(POPUP_SIZE_MAX,0.925,0.912), FontSize4, COLOR_GREEN, cc.p(1,0.5)))
		
	end
	popupContent:addChild(CreateCommonSprite("board_guildthings.png", Pos(POPUP_SIZE_MAX,0.5,0.872)))
	--排名 id 等级 名称 会长
	popupContent:addChild(CreateCommonLabel(MultiLan("GFL_bossRank_5"), Pos(POPUP_SIZE_MAX,0.5,0.872),FontSize2, COLOR_YELLOW))

	
	local popupRoot = CommonCreatePopupMax("bossdamage", popupContent, true)
	
	local function closeFunc()
		removeSelf(popupRoot)
	end
	popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"), size = FontSize6}))
end

local function onFamilyBossList()
	-- print(debug.traceback("1", "---------"))
--[[
showDamageList({{name="ca",damage=10232,uid=111},
{name="dsad",damage=3232,uid=1000110008},
{name="dsad",damage=500,uid=1000110007}

})
--]]
	if UserFamilyInfo.status == STATE_NOT_OPEN or (UserFamilyInfo.status == STATE_IS_JOIN and UserFamilyInfo.boss.type == 1) then
		CommonNote(MultiLan("GFL_bossRank_6"))
		return
	end
	
	local function getDamageCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			local function sortByDamage(a,b)
				if a.damage > b.damage then
					return true
				elseif a.damage < b.damage then
					return false
				else
					return a.level > b.level
				end
			end
			
			if table.maxn(jsonDataTable.data) > 0 then
				table.sort(jsonDataTable.data,sortByDamage)
			end
			showDamageList(jsonDataTable.data)
		end 
	end
	
	HttpSend("union/damage", {}, getDamageCallback)
end



function initGuildWar( jsonDataTable)
	if jsonDataTable.ret ~= 0 then return end
	-- ccdump(jsonDataTable,"jsonDataTable")
	if jsonDataTable.data.info.current_battle == 999 then 
		CommonNote(MultiLan("guild_war_desc1"))
		return 
	end
    UserFamilyBattleInfo = jsonDataTable.data
	CommonTitleLayer:setVisible(false)
	XiaLayerOwner["mGuildWarLayer"]:setVisible(true)
	XiaLayerOwner["mFamilySceneLayer"]:setVisible(false)

	guildWarLayer = GuildWarLayer:new()
	guildWarLayer:create({
		jsonDataTable = jsonDataTable,
		})
	local layerNode = guildWarLayer.topNode
	XiaLayerOwner["mGuildWarLayer"]:addChild(layerNode,0,1)
	XiaLayerOwner["mHelpIcon"]:setVisible(false)
	
end
function onGuildWar( ... )
	
	HttpSend("union/zgbattleinfo", {}, initGuildWar)
	
end
function onCloseGuildWar( ... )
	CommonTitleLayer:setVisible(true)
	XiaLayerOwner["mFamilySceneLayer"]:setVisible(true)
	XiaLayerOwner["mGuildWarLayer"]:setVisible(false)
	XiaLayerOwner["mHelpIcon"]:setVisible(true)
	XiaLayerOwner["mGuildWarLayer"]:removeAllChildren(true)
end


--无帮会
XiaLayer["onFamilyRefresh"]      = onFamilyRefresh
XiaLayer["onFamilySearch"]       = onFamilySearch
XiaLayer["onFamilyCreate"]       = onFamilyCreate
--有帮会
XiaLayer["onFamilySign"]         = onFamilySign
XiaLayer["onFamilyShop"]         = onFamilyShop
XiaLayer["onFamilyMember"]       = onFamilyMember
XiaLayer["onFamilyList"]         = onGuildRankList
--boss
XiaLayer["onFamilyBossOpen"]     = onFamilyBossOpen
XiaLayer["onFamilyBossJoin"]     = onFamilyBossJoin
XiaLayer["onFamilyBossAdd"]      = onFamilyBossAdd
XiaLayer["onFamilyBossList"]     = onFamilyBossList

XiaLayer["onGuildAct1"]       = onGuildWar




