
local bGroupInited = false
local GroupTimerId = 0
UserGroupInfo = nil

local USER_STATE_INIT = 0 -- 0 未加入 1匹配中 2 已加入 3 已创建
local USER_STATE_MATCH = 1
local USER_STATE_MEMBER = 2
local USER_STATE_LEADER = 3


local GROUP_STATE_END = 0 -- 0 已结束 1 已开始
local GROUP_STATE_BEGIN = 1

--是否可以报名
function IsGroupCanBaomin()
	if UserGroupInfo ~= nil and UserGroupInfo.fight_status == GROUP_STATE_END and UserGroupInfo.user_status ~= nil and UserGroupInfo.user_status == USER_STATE_INIT then
		return true
	else
		return false
	end
end

local function shansini(node)
	local value = {0,0,0}
	local add = {7,13,19}
	local arr = {1,1,1}
	local begin = 32
	local en = 192
	node:setColor(cc.c3b(begin,begin,begin))
	node:setOpacity(255)
	local function colorChange(n)
		local change = math.random(os.clock()*10^6)%18 -7
		for i=1,3 do
			if arr[i] == 1 then
				value[i] = value[i] + add[i] + change --*(0.5+0.5*math.sin(math.abs(value[i]-128)*360/192))
			else
				value[i] = value[i] - add[i] + change
			end
			if value[i] > en then
				arr[i] = 0
			elseif value[i] < begin then
				arr[i] = 1
			end
		end

		n:setColor(cc.c3b(begin+value[1],begin+value[2],begin+value[3]))
	end
	
	node:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.1), cc.CallFunc:create(colorChange))))
	--node:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.ScaleTo:create(1,0.97),cc.ScaleTo:create(1,1))))
		--node:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeTo:create(1,96),cc.FadeTo:create(1,255))))
end

--某一轮战报
function ShowGroupFight(fightInfo, bTeamFight)
	if fightInfo.status == nil or fightInfo.status == 2 then
		return
	end
	local team = {fightInfo.self_log, fightInfo.vs_log}
	local function sortTeam(a,b)
		if a.kill > b.kill then
			return true
		elseif a.kill < b.kill then
			return false
		else
			return a.score > b.score 
		end
	end
	table.sort(team[1], sortTeam)
	table.sort(team[2], sortTeam)
	--查看战报
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(580,640), 1, Pos(POPUP_SIZE_MAX,0.5,0.505))
	popupContent:addChild(scrollLayer)
	
	popupContent:addChild(CreateCommonSprite("board_guildthings.png", Pos(POPUP_SIZE_MAX,0.5,0.915)))
	popupContent:addChild(CreateCommonSprite("pic_vspic.png", Pos(POPUP_SIZE_MAX,0.5,0.915)))
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("GGL_team"),UserSelfInfo.name), Pos(POPUP_SIZE_MAX,0.3,0.915),FontSize2))
	popupContent:addChild(CreateCommonLabel(string.format(MultiLan("GGL_team"),fightInfo.vs), Pos(POPUP_SIZE_MAX,0.7,0.915),FontSize2))
	if fightInfo.status == 1 then
		-- popupContent:addChild(CreateCommonSprite("pic_dbvictory.png", Pos(POPUP_SIZE_MAX,0.11,0.915)))
		-- popupContent:addChild(CreateCommonSprite("pic_dblose.png", Pos(POPUP_SIZE_MAX,0.89,0.915)))
		-- popupContent:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_win"), FntTypeCommonYellow, Pos(POPUP_SIZE_MAX, 0.11, 0.915)))
		-- popupContent:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_lose"), FntTypeCommonDisableGray, Pos(POPUP_SIZE_MAX, 0.89, 0.915)))
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_win"), Pos(POPUP_SIZE_MAX, 0.11, 0.915), FontSize4, COLOR_FNT_CommonYellow))
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_lose"), Pos(POPUP_SIZE_MAX, 0.89, 0.915), FontSize4, COLOR_FNT_CommonDisableGray))
	elseif fightInfo.status == 0 then
		-- popupContent:addChild(CreateCommonSprite("pic_dbvictory.png", Pos(POPUP_SIZE_MAX,0.89,0.915)))
		-- popupContent:addChild(CreateCommonSprite("pic_dblose.png", Pos(POPUP_SIZE_MAX,0.11,0.915)))
		-- popupContent:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_win"), FntTypeCommonYellow, Pos(POPUP_SIZE_MAX, 0.89, 0.915)))
		-- popupContent:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_lose"), FntTypeCommonDisableGray, Pos(POPUP_SIZE_MAX, 0.11, 0.915)))
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_win"), Pos(POPUP_SIZE_MAX, 0.89, 0.915), FontSize4, COLOR_FNT_CommonYellow))
		popupContent:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_lose"), Pos(POPUP_SIZE_MAX, 0.11, 0.915), FontSize4, COLOR_FNT_CommonDisableGray))
	end

	local height = 80
	local width = 280
	local count = math.max(table.maxn(team[1]),table.maxn(team[2]))
	local y = (count - 0.5)*height
	local x = width/2
	local layer = cc.Layer:create()
	local backArr = {"board_dbteammb.png", "board_dbenemymb.png"}
	if fightInfo.status == 0 then
		backArr = {"board_dbenemymb.png", "board_dbteammb.png"}
	end
	for i=1, 2 do
		y = math.max(640-0.5*height,(count - 0.5)*height)
		for j=1,count do
			
			local player = team[i][j]
			-- print(i,j,player)
			if player ~= nil then
				local back = CreateCommonSprite(backArr[i], cc.p(x,y))
				if player.uid ~= nil and player.uid ~= 0 then
					
					local clickButton = CreateCommonButton("pic_suiyiaaa.png", Pos(back:getContentSize()), cc.size(272,76) , onPlayerDetailClick)
					clickButton:setSwallowTouch(false)
					back:addChild(clickButton, 0, player.uid)
					clickButton:setName(player.uid)
					if bTeamFight ~= nil then
						clickButton:setEnable(false)
					end
				end
				
				-- print(backArr[i])
				back:addChild(CreateCommonLabel(MultiLan("GGL_score")..player.score, Pos(back:getContentSize(),0.02,0.28),FontSize5, COLOR_GREEN,cc.p(0,0.5)))
				back:addChild(CreateCommonLabel(MultiLan("GGL_kill")..player.kill, Pos(back:getContentSize(),0.6,0.72),FontSize5, COLOR_RED,cc.p(0,0.5)))
				-- print(i, j, player.name, player.uid)
				local name = nil
				if player.uid ~= nil and player.uid == 0 then
					name = CreateCommonLabel(MultiLan(player.name), Pos(back:getContentSize(),0.02,0.72),FontSize5, nil,cc.p(0,0.5))
				else
					name = CreateCommonLabel(player.name, Pos(back:getContentSize(),0.02,0.72),FontSize5, nil,cc.p(0,0.5))
				end
				back:addChild(name)
				if player.name == UserSelfInfo.name then
					back:setOpacity(128)
					name:setColor(COLOR_YELLOW)
				end
				layer:addChild(back)
			end
			
			y = y - height
		end
		x = x + width
	end

	
	layer:setContentSize(cc.size(580, math.max(640, count*height)))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, math.min(0,640-count*height)), kScrollViewDirectionVertical)
	
	local root1 = CommonCreatePopupMax("checkresult", popupContent, true)
	
	local function closeFunc()
		removeSelf(root1)
	end
	popupContent:addChild(CreateCommonButton("button_red.png",Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"),size=FontSize6}))
end

function ShowGroupBattleResult(result)
	local popupContent = CreateLayer(POPUP_SIZE_MAX, 1, Pos(POPUP_SIZE_MAX))
	local scrollLayer  = CreateLayer(cc.size(600,680), 1, Pos(POPUP_SIZE_MAX,0.5,0.53))--, nil,nil,cc.c4b(0,255,0,255))
	popupContent:addChild(scrollLayer)
	--[[
	result = {log_list={}}
	for i=1,15 do
		table.insert(result.log_list,{vs="兔兔兔",status=i%3,round=i,self_log={name="wocao",kill=(i+5)%7,score = i*i*i},vs_log={name="cc",kill=(i+4)%6,score = i*i*i}})
	end
	--]]
	local function seeRoundInfo(node)
		ShowGroupFight(result.log_list[node:getTag()])
	end
	if result.log_list == CJSON_NULL then
		result.log_list = {}
	end
	local height = 120
	local count = table.maxn(result.log_list)
	local y = math.max(680-0.5*height,(count - 0.5)*height)
	local layer = cc.Layer:create()
	for i=1, count do
		local roundInfo = result.log_list[i]
		layer:addChild(CreateCommonSprite("board_dbresult.png", cc.p(300,y)))
		layer:addChild(CreateCommonLabel(string.format(MultiLan("GGL_round"), roundInfo.round),cc.p(28,y+33), FontSize3, COLOR_GREEN,cc.p(0,0.5)))
		layer:addChild(CreateCommonLabel(string.format(MultiLan("GGL_team"),UserSelfInfo.name), cc.p(120,y), FontSize2))
		layer:addChild(CreateCommonSprite("pic_vspic.png", cc.p(240,y+28)))
		if roundInfo.status == 2 then
			layer:addChild(CreateCommonLabel(MultiLan("GGL_bye"), cc.p(351,y), FontSize3,EQUIP_COLOR_ARR[1]))
		else
			layer:addChild(CreateCommonLabel(string.format(MultiLan("GGL_team"),roundInfo.vs), cc.p(351,y), FontSize2))
			local seeButton = CreateCommonButton("button_blue.png", cc.p(520,y), cc.size(144,50), seeRoundInfo, {str=MultiLan("button_look"), size = FontSize6})
			seeButton:setSwallowTouch(false)
			seeButton:setScale(0.75)
			layer:addChild(seeButton, 0 , i)
			if roundInfo.status == 1 then
				-- layer:addChild(CreateCommonSprite("pic_dbvictory.png", cc.p(240,y-20)))
				-- layer:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_win"), FntTypeCommonYellow, cc.p(240,y-20)))
				layer:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_win"), cc.p(240,y-20), FontSize4, COLOR_FNT_CommonYellow))
			elseif roundInfo.status == 0 then
				-- layer:addChild(CreateCommonSprite("pic_dblose.png", cc.p(240,y-20)))
				-- layer:addChild(CreateCommonFntLabel(ZGMultiLan("game_war_result_lose"), FntTypeCommonDisableGray, cc.p(240,y-20)))
				layer:addChild(CreateCommonLabel(ZGMultiLan("game_war_result_lose"), cc.p(240,y-20), FontSize4, COLOR_FNT_CommonDisableGray))
			end
		end
		y = y - height
	end
	layer:setContentSize(cc.size(600, math.max(680, count*height)))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, math.min(0,680-count*height)), kScrollViewDirectionVertical)
	
	local root1 = CommonCreatePopupMax("battleresult", popupContent, true)
	
	local function closeFunc()
		removeSelf(root1)
	end
	popupContent:addChild(CreateCommonButton("button_red.png",Pos(POPUP_SIZE_MAX,0.5,0.05), cc.size(144,50), closeFunc, {str=MultiLan("button_close"),size=FontSize6}))
end

--查看团战战报
function GetGroupBattleInfo(logid,matchId)
	local function deleteMailCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			ShowGroupBattleResult(jsonDataTable.data.log)
		end
	end
    HttpSend("group/log", {"logid=" .. logid, "match="..matchId}, deleteMailCallback)
end

--团战消息错误处理
local function GroupError(serverInfo)
	if serverInfo == CJSON_NULL then
		return false
	end

	if serverInfo.status == 1 then
		UserGroupInfo = serverInfo.info
		setGroupInfoLayer(true)
		CommonNote(MultiLan("GGL_dataIsRefreshed"))
		return true
	else
		return false
	end
end

--设置请等待提示
local function setGroupWaitLabel(note)
	if note == nil then
		XiaLayerOwner["mGroupWaitLabel"]:stopAllActions()
		XiaLayerOwner["mGroupWaitLabel"]:setVisible(false)
		XiaLayerOwner["mGroupWaitLabel"]:setOpacity(255)
	else
		if XiaLayerOwner["mGroupWaitLabel"]:isVisible() then
			XiaLayerOwner["mGroupWaitLabel"]:setString(note)
		else
			XiaLayerOwner["mGroupWaitLabel"]:setVisible(true)
			XiaLayerOwner["mGroupWaitLabel"]:setString(note)
			
			--action
			shansini(XiaLayerOwner["mGroupWaitLabel"])
		end
	end
end

--设置团战倒计时
local function setGroupCountdown(bInit)
	local function groupTimeup()

		UserGroupInfo.fight_status = GROUP_STATE_BEGIN
		UserGroupInfo.round = 1
		if CommonGroupLayer:isVisible() then
			setGroupInfoLayer()
		elseif CommonHomeLayer:isVisible() then
			GameGuide:setGroupButtonNote()
		end
	end
		
	GroupTimerId = TimeDown:register(GroupTimerId)
	if UserGroupInfo.fight_status == GROUP_STATE_END then
		XiaLayerOwner["mGroupCountdownLabel"]:setVisible(true)
		XiaLayerOwner["mGroupRoundDesc"]:setVisible(false)
		if bInit then
			TimeDown:setTimeInfo(GroupTimerId, UserGroupInfo.countdown, XiaLayerOwner["mGroupCountdownLabel"], groupTimeup, TimeDown.HH_MM_SS) 
			SetDownTimeForLabel(XiaLayerOwner["mGroupCountdownLabel"], UserGroupInfo.countdown, TimeDown.HH_MM_SS)
		end
		
		-- XiaLayerOwner["mGroupStateSprite"]:setSpriteFrame("title_nextbattle.png")
		XiaLayerOwner["mTitleWarState"]:setString(ZGMultiLan("mTitleWarStateWillStart"))
	elseif UserGroupInfo.fight_status == GROUP_STATE_BEGIN then
		XiaLayerOwner["mGroupCountdownLabel"]:setVisible(false)
		XiaLayerOwner["mGroupRoundDesc"]:setVisible(true)
		XiaLayerOwner["mGroupRoundDesc"]:setString(string.format(MultiLan("GGL_roundRunning"), UserGroupInfo.round))
		TimeDown:unregister(GroupTimerId)
		
		-- XiaLayerOwner["mGroupStateSprite"]:setSpriteFrame("title_nowbattle.png")
		XiaLayerOwner["mTitleWarState"]:setString(ZGMultiLan("mTitleWarStateBattling"))
	else
		XiaLayerOwner["mGroupCountdownLabel"]:setVisible(false)
		XiaLayerOwner["mGroupRoundDesc"]:setVisible(false)
		TimeDown:unregister(GroupTimerId)
	end
end

--设置按钮显示
local function setGroupButton()
	-- print("setGroupButton", UserGroupInfo.fight_status,UserGroupInfo.user_status)
	XiaLayerOwner["mGroupButtonCreate"]:setVisible(false)
	XiaLayerOwner["mGroupButtonJoin"]:setVisible(false)
	XiaLayerOwner["mGroupButtonCancel"]:setVisible(false)
	XiaLayerOwner["mGroupButtonTeam"]:setVisible(false)
	XiaLayerOwner["mGroupButtonRefresh"]:setVisible(false)
	if UserGroupInfo.fight_status == GROUP_STATE_END then
		if UserGroupInfo.user_status == USER_STATE_INIT then
			XiaLayerOwner["mGroupButtonJoin"]:setVisible(true)
			XiaLayerOwner["mGroupButtonCreate"]:setVisible(true)
			setGroupWaitLabel(nil)
		elseif UserGroupInfo.user_status == USER_STATE_MATCH then
			XiaLayerOwner["mGroupButtonCancel"]:setVisible(true)
			setGroupWaitLabel(MultiLan("GGL_groupBttn_1"))
		elseif UserGroupInfo.user_status == USER_STATE_MEMBER then
			XiaLayerOwner["mGroupButtonTeam"]:setTitleForState(MultiLan("GGL_groupBttn_2"), cc.CONTROL_STATE_NORMAL)
			XiaLayerOwner["mGroupButtonTeam"]:setVisible(true)
			setGroupWaitLabel(MultiLan("GGL_groupBttn_3"))
		elseif UserGroupInfo.user_status == USER_STATE_LEADER then
			XiaLayerOwner["mGroupButtonTeam"]:setTitleForState(MultiLan("GGL_groupBttn_4"), cc.CONTROL_STATE_NORMAL)
			XiaLayerOwner["mGroupButtonTeam"]:setVisible(true)
			XiaLayerOwner["mGroupButtonRefresh"]:setVisible(true)
			setGroupWaitLabel(MultiLan("GGL_groupBttn_5"))
		end
	elseif UserGroupInfo.fight_status == GROUP_STATE_BEGIN then
		setGroupWaitLabel(nil)
	end
	
	if XiaLayerOwner["mGroupInfoLayer"]:isVisible() == false and XiaLayerOwner["mGroupTeamLayer"]:isVisible() then
		if UserGroupInfo.user_status == USER_STATE_LEADER then
			setGroupWaitLabel(MultiLan("GGL_groupBttn_6"))
		else
			setGroupWaitLabel(nil)
		end
	end
end

--设置团战信息界面
function setGroupInfoLayer(bInit)
	XiaLayerOwner["mGroupInfoLayer"]:setVisible(true)
	XiaLayerOwner["mGroupTeamLayer"]:setVisible(false)
	
	--设置倒计时
	setGroupCountdown(bInit)
	
	--设置按钮
	setGroupButton()
end


local function kickMemberFunc(node)
	--local uid = tolua.cast(node, "cc.Node"):getTag()
	local uid = tolua.cast(node, "cc.Node"):getName()
	local function kickMemberCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if GroupError(jsonDataTable.data) then
				return
			end
			local kickName = ""
			for i=1,table.maxn(UserGroupInfo.member) do
				if UserGroupInfo.member[i].uid == jsonDataTable.data.kick then
					kickName = UserGroupInfo.member[i].name
					table.remove(UserGroupInfo.member, i)
					break
				end
			end
			
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
			UseCash(jsonDataTable.data.cash)
			UserGroupInfo.limit = jsonDataTable.data.limit
			refreshTeam()
			CommonNote(string.format(MultiLan("GGL_kick_1"),tostring(kickName)), COLOR_RED)
		end 
	end
	local cost = 10 * (UserGroupInfo.limit+1)
	local function sendKickMember()
		if UserSelfInfo.cash < cost then
			CommonCashNeed()
		else
			HttpSend("group/kick",{"del="..uid},kickMemberCallback)
			--kickMemberCallback({ret=0, data={id=uid,cash=cost,kick = UserGroupInfo.kick +1}})
		end
	end
	
	CreateSmallPopupWithCancel("changeboy",CreateCommonLabel(string.format(MultiLan("GGL_kick_2"), cost),nil,FontSize3), sendKickMember)
end

--刷新队伍显示
function refreshTeam()
	XiaLayerOwner["mGroupTeamFightnum"]:setString(CalGroupTotalFightnum(UserGroupInfo.member))
	XiaLayerOwner["mGroupTeamCount"]:setString(table.maxn(UserGroupInfo.member).."/10")

	cc.SpriteFrameCache:getInstance():addSpriteFrames("ccb/ccbResources/SkillIcon.plist")
	local teamInfo = UserGroupInfo.member

	--排序
	local function sortMember(a,b)
		if a.lead > b.lead then
			return true
		elseif a.lead < b.lead then
			return false
		else
			if a.uid == UserSelfInfo.uid and b.uid ~= UserSelfInfo.uid then
				return true
			elseif a.uid ~= UserSelfInfo.uid and b.uid == UserSelfInfo.uid then
				return false
			else
				if a.power > b.power then
					return false
				elseif a.power < b.power then
					return true
				else
					return a.level > b.level 
				end
			end
		end
	end
	table.sort(teamInfo, sortMember)

	--内容
	local layer = cc.Layer:create()
	local count = table.maxn(teamInfo)
	local y = count*130-65
	for i=1, count do
		layer:addChild(CreateCommonSprite("board_overmap.png", cc.p(300, y)))
		layer:addChild(CreateCommonSprite("board_skill01.png", cc.p(291, y+32)))
		local skillBack = CreateCommonSprite("board_skill02.png", cc.p(291, y-23))
		layer:addChild(skillBack)

		--头像
		local headButton = CreateDetailButton(teamInfo[i].role, teamInfo[i].sex, teamInfo[i].uid)
		headButton:setPosition(cc.p(65, y))
		headButton:setSwallowTouch(false)
		layer:addChild(headButton)
		layer:addChild(GetSchoolIconByRole(teamInfo[i].role, cc.p(30, y+45)))
		if teamInfo[i].uid ~= UserSelfInfo.uid then
			layer:addChild(GetLevelLabel(teamInfo[i].level, cc.p(70, y-47), FontSize2))
		else
			layer:addChild(GetLevelLabel(UserSelfInfo.level, cc.p(70, y-47), FontSize2))
		end

		layer:addChild(CreateCommonLabel(teamInfo[i].name, cc.p(120, y+32), FontSize2, nil,cc.p(0,0.5)))
		if teamInfo[i].uid ~= UserSelfInfo.uid then
			layer:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_8")..":"..teamInfo[i].power, cc.p(460, y+32), FontSize2, COLOR_GREEN,cc.p(1,0.5)))
		else
			layer:addChild(CreateCommonLabel(MultiLan("GFL_unionMember_8")..":"..UserAttr:getFightNum(), cc.p(460, y+32), FontSize2, COLOR_GREEN,cc.p(1,0.5)))
			teamInfo[i].skill = UserSelfInfo.pvp_skill
		end
		if teamInfo[i].skill ~= nil then
			for j=1, 4 do
				if teamInfo[i].skill[j] ~= nil then
					skillBack:addChild(CreateCommonSprite("skill_"..teamInfo[i].skill[j]..".png", cc.p(-20+70*j, 30), 0.5))
				end
			end
		end
		--队长
		if teamInfo[i].lead == 1 then
			-- layer:addChild(CreateCommonSprite("pic_captainall.png", cc.p(530, y)))
			-- layer:addChild(CreateCommonFntLabel(ZGMultiLan("lbGroupLeader"), FntTypeUserTitle, cc.p(530, y)))
			layer:addChild(CreateCommonLabel(ZGMultiLan("lbGroupLeader"), cc.p(530, y), FontSize4, COLOR_FNT_UserTilte))
		else
			if UserGroupInfo.user_status == USER_STATE_LEADER then
				local kickButton = CreateCommonButton("button_red.png", cc.p(530, y), cc.size(144,50), kickMemberFunc, {str=MultiLan("GGL_kick_3"), size = FontSize6})
				kickButton:setTag(teamInfo[i].uid)
				kickButton:setName(teamInfo[i].uid)
				kickButton:setSwallowTouch(false)
				kickButton:setScale(0.75)
				layer:addChild(kickButton)
			end
		end

		y = y - 130
	end
	
	layer:setContentSize(cc.size(600, math.max(460,count*130)))
	local scrollview = CreateScrollViewByFather(XiaLayerOwner["mGroupTeam"], layer , cc.p(0, 460-count*130 + 65), kScrollViewDirectionVertical)
	if count*130 < 460 then
		scrollview:setTouchEnabled(false)
	end
end

--计算总战力
function CalGroupTotalFightnum(t)
	local totle = 0
	for i=1,table.maxn(t) do
		if t[i].uid ~= UserSelfInfo.uid then
			totle = totle + t[i].power
		else
			totle = totle + UserAttr:getFightNum()
		end
	end
	return totle
end

--设置团战队伍界面
local function setGroupTeamLayer()
	XiaLayerOwner["mGroupInfoLayer"]:setVisible(false)
	XiaLayerOwner["mGroupTeamLayer"]:setVisible(true)
	
	--小队名
	XiaLayerOwner["mGroupTeamTitle"]:setString(string.format(MultiLan("GGL_team"),tostring(UserSelfInfo.name)))
	
	refreshTeam()
	setGroupButton()
end

local function GroupLayerInit()
	if bGroupInited then
		return
	end
	bGroupInited = true

	--玩法说明
	local size = XiaLayerOwner["mGroupDescLayer"]:getContentSize()
	XiaLayerOwner["mGroupDescLayer"]:removeAllChildren(true)
	XiaLayerOwner["mGroupDescLayer"]:addChild(CreateCommonLabel(MultiLan("GGL_declare_1"),Pos(size,0.02,0.85),FontSize1, COLOR_CYAN, cc.p(0,0.5)))
	XiaLayerOwner["mGroupDescLayer"]:addChild(CreateCommonLabel(MultiLan("GGL_declare_2"),Pos(size,0.02,0.613),FontSize1, nil, cc.p(0,0.5)))
	XiaLayerOwner["mGroupDescLayer"]:addChild(CreateCommonLabel(MultiLan("GGL_declare_3"),Pos(size,0.02,0.397),FontSize1, nil, cc.p(0,0.5)))
	XiaLayerOwner["mGroupDescLayer"]:addChild(CreateCommonLabel(MultiLan("GGL_declare_4"),Pos(size,0.02,0.15),FontSize1, nil, cc.p(0,0.5)))
	
	--颜色
	XiaLayerOwner["mGroupRoundDesc"]:setColor(COLOR_GREEN)
	XiaLayerOwner["mGroupRoundDesc"]:setScale(1.1)
	XiaLayerOwner["mGroupCountdownLabel"]:setScale(1.4)
	XiaLayerOwner["mGroupRewardDesc1"]:setColor(COLOR_ORANGE)
	XiaLayerOwner["mGroupRewardDesc2"]:setColor(COLOR_YELLOW)
	XiaLayerOwner["mGroupRewardDesc3"]:setColor(COLOR_ORANGE)
	XiaLayerOwner["mGroupRewardDesc4"]:setColor(COLOR_YELLOW)
	XiaLayerOwner["mGroupTeamFightnum"]:setColor(COLOR_GREEN)
	XiaLayerOwner["mGroupTeamCount"]:setColor(COLOR_CYAN)
	
	--文字
	XiaLayerOwner["mGroupDesc1"]:setString(MultiLan("GGL_declare_5"))
	XiaLayerOwner["mGroupDesc2"]:setString(MultiLan("GGL_declare_6"))
	XiaLayerOwner["mGroupRewardDesc1"]:setString(MultiLan("GGL_declare_7"))
	XiaLayerOwner["mGroupRewardDesc2"]:setString(MultiLan("GGL_declare_8"))
	XiaLayerOwner["mGroupRewardDesc3"]:setString(MultiLan("GGL_declare_9"))
	XiaLayerOwner["mGroupRewardDesc4"]:setString(MultiLan("GGL_declare_10"))
	
	--按钮
	XiaLayerOwner["mGroupButtonCreate"]:setTitleForState(MultiLan("GGL_declare_11"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mGroupButtonJoin"]:setTitleForState(MultiLan("GGL_declare_12"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mGroupButtonCancel"]:setTitleForState(MultiLan("GGL_declare_13"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mGroupButtonTeam"]:setTitleForState(MultiLan("GGL_groupBttn_2"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mGroupButtonRefresh"]:setTitleForState(MultiLan("GGL_declare_14"), cc.CONTROL_STATE_NORMAL)
	
	XiaLayerOwner["mGroupWaitLabel"]:setVisible(false)
end

function GroupEnter()
	-- print("GroupEnter")

	XiaLayerOwner["mPvpLayer"]:setVisible(true)
	XiaLayerOwner["mPvpMain"]:setVisible(false)
	TimeDown:unregister(GroupTimerId)
	GroupLayerInit()
	setGroupInfoLayer(true)
	--[[
	UserGroupInfo.member = {
						{uid=1, power = 1234, lead=0,level=45,name="sdasd",skill = {103,102},role=1},
						{uid=2, power = 12345, lead=0,level=43,name="sdasd",skill = {103,102},role=2},
						{uid=3, power = 1245, lead=0,level=41,name="sdasd",skill = {103,102},role=3},
						{uid=4, power = 12345, lead=0,level=47,name="sdasd",skill = {103,102},role=1},
						{uid=1000110008, power = 12345, lead=1,level=59,name="sdasd",skill = {103,102},role=2},
						{uid=1, power = 123345, lead=0,level=45,name="sdasd",skill = {103,102},role=3},
						{uid=5, power = 12545, lead=0,level=56,name="sdasd",skill = {103,102},role=3},
						{uid=1, power = 124345, lead=0,level=44,name="sdasd",skill = {103,102},role=3},
						{uid=1, power = 123545, lead=0,level=42,name="sdasd",skill = {103,102},role=3},
						{uid=1, power = 1235, lead=0,level=55,name="sdasd",skill = {103,102},role=1}
				     }
					 ]]
end

function GroupExit()
	--TimeDown:unregister(GroupTimerId)
	setGroupWaitLabel(nil)
end

--刷新队伍
local function onGroupRefresh()
	if UserGroupInfo.fight_status ~= GROUP_STATE_END or XiaLayerOwner["mGroupTeamLayer"]:isVisible() == false or UserGroupInfo.user_status ~= USER_STATE_LEADER then
		return
	end
	
	local function groupRefreshCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if GroupError(jsonDataTable.data) then
				return
			end
			--[[
		UserGroupInfo.member = {
							{uid=1, power = 1234, lead=0,level=45,name="sdasd",skill = {103,102},role=1},
							{uid=2, power = 12345, lead=0,level=43,name="sdasd",skill = {103,102},role=2},
							{uid=3, power = 1245, lead=0,level=41,name="sdasd",skill = {103,102},role=3},
							{uid=4, power = 12345, lead=0,level=47,name="sdasd",skill = {103,102},role=1},
							{uid=1000110008, power = 12345, lead=1,level=59,name="sdasd",skill = {103,102},role=2},
							{uid=1, power = 123345, lead=0,level=45,name="sdasd",skill = {103,102},role=3},
							{uid=5, power = 12545, lead=0,level=56,name="sdasd",skill = {103,102},role=3},
							{uid=1, power = 124345, lead=0,level=44,name="sdasd",skill = {103,102},role=3},
							{uid=1, power = 123545, lead=0,level=42,name="sdasd",skill = {103,102},role=3},
							{uid=1, power = 1235, lead=0,level=55,name="sdasd",skill = {103,102},role=1}
						 }
			]]
			refreshTeam()
		end 
	end
	
	HttpSend("group/refresh", {}, groupRefreshCallback)
end

--查看队伍
local function onGroupTeam()
	setGroupTeamLayer()
end

--取消报名
local function onGroupCancel()
	if UserGroupInfo.fight_status ~= GROUP_STATE_END or UserGroupInfo.user_status ~= USER_STATE_MATCH then
		return
	end
	
	local function groupCancelCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if GroupError(jsonDataTable.data) then
				return
			end
			UserGroupInfo.user_status = USER_STATE_INIT
			setGroupInfoLayer()
		end 
	end
	
	HttpSend("group/cancel", {}, groupCancelCallback)
	--groupCancelCallback({ret=0})
end

--加入队伍
local function onGroupJoin()
	if UserGroupInfo.fight_status ~= GROUP_STATE_END or UserGroupInfo.user_status ~= USER_STATE_INIT then
		return
	end
	
	local function groupJoinCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if GroupError(jsonDataTable.data) then
				return
			end
			UserGroupInfo.user_status = jsonDataTable.data.user_status
			setGroupInfoLayer()
			CommonNote(MultiLan("GFL_openBoss_8"))
		end 
	end
	
	HttpSend("group/join", {}, groupJoinCallback)
	--groupJoinCallback({ret=0})
end

--创建队伍
local function onGroupCreate()
	if UserGroupInfo.fight_status ~= GROUP_STATE_END or UserGroupInfo.user_status ~= USER_STATE_INIT then
		return
	end
	
	local function groupCreateCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			if GroupError(jsonDataTable.data) then
				return
			end
			UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cash
			UseCash(jsonDataTable.data.cash)
			UserGroupInfo = jsonDataTable.data.info
			setGroupInfoLayer(true)
			CommonNote(MultiLan("GGL_creatTeam_1"))
		end 
	end
	
	local function sendCreateTeam()
		if UserSelfInfo.cash < 50 then
			CommonCashNeed()
		else
			HttpSend("group/create", {}, groupCreateCallback)
			--groupCreateCallback({ret=0})
		end
	end
	
	CreateSmallPopupWithCancel("creatdw",CreateCommonLabel(string.format(MultiLan("GGL_creatTeam_2"), 50),nil,FontSize3), sendCreateTeam)
end
local function onClickGroupClose()
	PvpLayerInit()
	PvpSetMain()
	resetPvpLayer()
	CommonTitleLayer:setVisible(false)
end


XiaLayer["onClickGroupClose"]    = onClickGroupClose
XiaLayer["onGroupCreate"]        = onGroupCreate
XiaLayer["onGroupJoin"]          = onGroupJoin
XiaLayer["onGroupCancel"]        = onGroupCancel
XiaLayer["onGroupTeam"]          = onGroupTeam
XiaLayer["onGroupRefresh"]       = onGroupRefresh