GameListLayer = class("GameListLayer")
GameListLayer.__index = GameListLayer

GameListLayer.topNode = nil
GameListLayer.editbox = nil

GameListLayer.loginRegionShowLayer = nil
GameListLayer.filterLayer = nil	
GameListLayer.filterScroll = nil	--ÏÂÃæµÄ¹ö¶¯²ã
GameListLayer.RegionInfo = nil
GameListLayer.LoginRegion = 1 
GameListLayer.selectRegionTitle = nil
GameListLayer.curGameVersion = ""



function sendRoleList(node)
	local id = node:getTag()
	local function rankinfoCallback(jsonDataTable)
		if jsonDataTable.ret == 0 then
			GameListLayer:roleList(jsonDataTable.data, id)
		end
	end
	HttpSend("rank/info",{"id="..id},rankinfoCallback)
end

--×Ü°ñ
function GameListLayer:roleList(roleListInfo, roleType)
	cclog("roleList")
    local ranklayer = RankLayer:new()
    ranklayer:create({roleType = roleType})
    local layerNode = ranklayer.topNode   
	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode)  

	--内容
    local scrollLayer = ranklayer.scrollLayer
    local layer = cc.Layer:create()
    local count = table.maxn(roleListInfo)
    local cellSize = Rankcell.getCellSize()
    local y = count * cellSize.height
    layer:setContentSize(cc.size(cellSize.width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
    for i = 1, count do
    		local rankcell = Rankcell:new()
            rankcell:create({
            	rank = i,
            	name=roleListInfo[i].name, 
            	family=roleListInfo[i].union_name,
            	ranks=roleListInfo[i].idx,
            	power=roleListInfo[i].power,
            	sign=roleListInfo[i].sign,
                head=roleListInfo[i].role,
                sex = roleListInfo[i].sex,
                leavel=roleListInfo[i].level,
                uid = roleListInfo[i].uid,
            	})
            local cellNode = rankcell.topNode 
            cellNode:setPositionY(y - i * cellSize.height)   
	        layer:addChild(cellNode)
    end
end


function GameListLayer:totleList(TotleListInfo)
    local rankhomelayer = RankHomeLayer:new()
    rankhomelayer:create()
    local layerNode = rankhomelayer.topNode 
    if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode) 

	local scrollLayer = rankhomelayer.scrollLayer
    local layer = cc.Layer:create()
    local count = 4--table.maxn(playerInfo)
	if TotleListInfo.union_battle == nil then
		count = count -1 
	end
	local y = (count+2)*140  
    local cellSize = RankHomeCell.getCellSize()
    layer:setContentSize(cc.size(cellSize.width, y ))

	local scrolView = CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	y = y - 140
    local rankhomecell = RankHomeCell:new()
    rankhomecell:create({
    	style = 5,
    	playerInfo = TotleListInfo.arena,
    	spriteArr = "pic_guildbw.png",
    	})
    local cellNode = rankhomecell.topNode 
    cellNode:setPositionY(y)   
	layer:addChild(cellNode)
    y = y - 140
    if TotleListInfo.zg_union_battle ~= nil then

    	local rankhomecell = RankHomeCell:new()
    	rankhomecell:create({
    		style = 6,
    		playerInfo = TotleListInfo.zg_union_battle,
    		spriteArr = "pic_guildcharts.png",
    		})
   		local cellNode = rankhomecell.topNode 
    	cellNode:setPositionY(y)   
		layer:addChild(cellNode)
		y = y - 140
	end
	for i=1 , 4 do
	    local spriteArr = {"pic_guildsl.png","pic_guildwd.png","pic_guildtm.png", "pic_levelwd.png"} 
		local playerInfo = TotleListInfo.power[i]
		if playerInfo.uid ~= 0 then
			local rankhomecell = RankHomeCell:new()
	        rankhomecell:create({
	        	style = i,
	        	playerInfo = playerInfo,
	        	spriteArr = spriteArr[i],

	        	})
	        local cellNode = rankhomecell.topNode 
	        cellNode:setPositionY(y)   
		    layer:addChild(cellNode)
		    y = y - 140
		end
	end

end



	-- local back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
	-- layer:addChild(back)
	-- back:addChild(CreateCommonSprite("pic_guildbw.png", cc.p(50, 64)))
	-- -- back:addChild(CreateCommonLabel(ZGMultiLan("game_info_rank_family"), cc.p(50, 64), FontSize3, nil, cc.p(0.5, 0.5)))
	-- back:addChild(CreateCommonFntLabel(ZGMultiLan("game_info_rank_pvp"), FntTypeUserTitle, cc.p(50, 64)))
	-- local button = CreateCommonButton("actor_icon_"..TotleListInfo.arena.role..".png", cc.p(150, 64), cc.size(95, 95), onPlayerDetailClick)
	-- button:setName(TotleListInfo.arena.uid)
	-- back:addChild(button,0,TotleListInfo.arena.uid)
	-- local nameBack = CreateCommonSprite("board_skill01.png", cc.p(341, 91))
	-- nameBack:setScaleX(0.7)
	-- back:addChild(nameBack)
	-- local nameLayer = CreateLayer(cc.size(351*0.7, 39), 1, cc.p(341, 91))
	-- back:addChild(nameLayer)
	-- setNameAndFamily(nameLayer, MultiLan("list_first0")..TotleListInfo.arena.name)
	-- back:addChild(CreateCommonSprite("wordboard_power.png", cc.p(341, 41)))
	-- back:addChild(CreateCommonFntLabel(ZGMultiLan("equip_battle_value_title"), FntTypePower, cc.p(265, 41)))
	-- back:addChild(CreateCommonLabel(TotleListInfo.arena.power, cc.p(310, 44),FontSize4,COLOR_YELLOW,cc.p(0,0.5)))
	-- back:addChild(CreateCommonButton("pic_moreman.png", cc.p(520, 64), cc.size(92, 100), onArenaList))
	-- y = y - 140
 --    if TotleListInfo.union_battle ~= nil then
	-- 	local back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
	-- 	layer:addChild(back)
	-- 	back:addChild(CreateCommonSprite("pic_guildcharts.png", cc.p(50, 64)))
	-- 	-- back:addChild(CreateCommonLabel("gh", cc.p(50, 64), FontSize3, nil, cc.p(0.5, 0.5)))
	-- 	back:addChild(CreateCommonFntLabel(ZGMultiLan("game_info_rank_family"), FntTypeUserTitle, cc.p(50, 64)))
	-- 	local button = CreateCommonButton("actor_icon_"..TotleListInfo.union_battle.role..".png", cc.p(150, 64), cc.size(95, 95), onPlayerDetailClick)
	-- 	button:setName(TotleListInfo.union_battle.uid)
	-- 	back:addChild(button,0,TotleListInfo.union_battle.uid)
	-- 	local nameBack = CreateCommonSprite("board_skill01.png", cc.p(341, 91))
	-- 	nameBack:setScaleX(0.7)
	-- 	back:addChild(nameBack)
	-- 	local nameLayer = CreateLayer(cc.size(351*0.7, 39), 1, cc.p(341, 91))
	-- 	back:addChild(nameLayer)
	-- 	setNameAndFamily(nameLayer, MultiLan("list_first5")..TotleListInfo.union_battle.name)
	-- 	local scorelable = CreateCommonSprite("board_skill01.png", cc.p(341, 41))
	-- 	scorelable:setScaleX(0.7)
	-- 	back:addChild(scorelable)
	-- 	back:addChild(CreateCommonLabel(MultiLan("union_battle_13")..TotleListInfo.union_battle.power, cc.p(245, 44),FontSize4,COLOR_YELLOW,cc.p(0,0.5)))
	-- 	back:addChild(CreateCommonButton("pic_moreman.png", cc.p(520, 64), cc.size(92, 100), onGuildRankList))
	-- 	y = y - 140
	-- end
	-- local spriteArr = {"pic_guildsl.png","pic_guildwd.png","pic_guildtm.png", "pic_levelwd.png"}
	-- for i=1, 4 do
	-- 	print(2,i)
	-- 	local back = CreateCommonSprite("board_challengemap.png", cc.p(300, y))
	-- 	layer:addChild(back)
	-- 	back:addChild(CreateCommonSprite(spriteArr[i], cc.p(50, 64)))
	-- 	if spriteArr[i] == "pic_levelwd.png" then
	-- 		back:addChild(CreateCommonFntLabel(ZGMultiLan("game_info_rank_level"), FntTypeUserTitle, cc.p(50, 64)))
	-- 	end
		
	-- 	local playerInfo = TotleListInfo.power[i]

	-- 	if playerInfo ~= nil then
	-- 		--Í·Ïñ
	-- 		local powerButton = CreateCommonButton("actor_icon_"..TotleListInfo.power[i].role..".png", cc.p(150, 64), cc.size(95, 95), onPlayerDetailClick)
	-- 		powerButton:setName(playerInfo.uid)
	-- 		back:addChild(powerButton,0,playerInfo.uid)
	-- 		--back:addChild(CreateCommonSprite("school_icon_"..i..".png", cc.p(30, 110)))
	-- 		--back:addChild(CreateCommonLabel("Lv."..playerInfo[i].level, cc.p(70, 18), FontSize2))
			
	-- 		local nameBack = CreateCommonSprite("board_skill01.png", cc.p(341, 91))
	-- 		nameBack:setScaleX(0.7)
	-- 		back:addChild(nameBack)
	-- 		local nameLayer = CreateLayer(cc.size(351*0.7, 39), 1, cc.p(341, 91))
	-- 		back:addChild(nameLayer)
	-- 		setNameAndFamily(nameLayer, MultiLan("list_first"..i)..playerInfo.name)
				
	-- 		back:addChild(CreateCommonSprite("wordboard_power.png", cc.p(341, 41)))
	-- 		back:addChild(CreateCommonFntLabel(ZGMultiLan("equip_battle_value_title"), FntTypePower, cc.p(265, 41)))
	-- 		back:addChild(CreateCommonLabel(playerInfo.power, cc.p(310, 44),FontSize4,COLOR_YELLOW,cc.p(0,0.5)))

	-- 		--²é¿´¸ü¶à
	-- 		back:addChild(CreateCommonButton("pic_moreman.png", cc.p(520, 64), cc.size(92, 100), sendRoleList), 0 ,i)
	-- 	end
		
	-- 	y = y - 140
	-- end
	

	


	-- layer:setContentSize(cc.size(600, math.max(height, 140*(count+2)-10)))
	-- scrolView:setContentOffset(cc.p(0, height-(140*(count+2)-10)))
	-- if 140*(count + 2) < height then
	-- 	scrolView:setTouchEnabled(false)
	-- end
	
	-- local popupRoot = CommonCreatePopupMax("phblist", popupContent)
	-- --¹Ø±Õ
	-- local function closeFunc()
	-- 	removeSelf(popupRoot)
	-- end
	-- popupContent:addChild(CreateCommonButton("button_red.png", Pos(POPUP_SIZE_MAX,0.5,0.06), cc.size(158,67), closeFunc, {str = MultiLan("button_close"), size = FontSize6}))
	
-- end
