
local bPvpInited = false
local PVP_MAIN_COUNT = 4  --ÍÅÕ½Ö÷½çÃæÏÔÊ¾µÄÀàÐÍÊýÁ¿

local function onGroupClick()
	local function groupInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("groupInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserGroupInfo = jsonDataTable.data.info
		
		local node = cc.Node:create()
		node:setTag(GroupLayerTag)
		ShowNew(node)
	end
	HttpSend("group/info", {}, groupInfoCallback)
end

local function onTeamClick()
	local function teamInfoCallback(jsonDataTable)
		if jsonDataTable.ret ~= 0 then
			-- cclog("groupInfoCallback failed %d", jsonDataTable.ret)
			return 
		end
		UserTeamInfo = jsonDataTable.data
		
		local node = cc.Node:create()
		node:setTag(TeamLayerTag)
		ShowNew(node)
	end
	
	if CheckTeam() then
		HttpSend("herogroup/info", {}, teamInfoCallback)
	else
		TeamNotOpen()
	end
	

	--teamInfoCallback({ret=0,data={countdown=60,reset=0,inspire=50}})
end

--Ë¢ÐÂÖ÷½çÃæ
function PvpSetMain()
	local height = 170
	local count = PVP_MAIN_COUNT
	local fatherHeight = XiaLayerOwner["mPvpMainScroll"]:getContentSize().height
	local y = math.max(fatherHeight-0.5*height, (count - 0.5)*height)
	local layer = cc.Layer:create()
	
	-- print("PvpSetMain")
	local function ShowWait()
		CommonNote(MultiLan("GAL_pleaseWait"), EQUIP_COLOR_ARR[5])
	end
	
	local pvpArr = {{back="pic_zuduidb.png", title=MultiLan("PVP_groupTitle_1"), titleDesc=MultiLan("PVP_groupBattle_1"), callback=onGroupClick, bNote=IsNeedGroupNote(),},
					{back="pic_hfqunzhan.png", title=MultiLan("PVP_groupTitle_2"), titleDesc=MultiLan("PVP_groupBattle_2"), callback=onTeamClick},}

	for i=1,count do
		if pvpArr[i] ~= nil then
			local button = CreateCommonButton(pvpArr[i].back, cc.p(320,y), cc.size(541,127), pvpArr[i].callback)
			button:setSwallowTouch(false)
			layer:addChild(button)
			button:addChild(CreateCommonLabel(pvpArr[i].titleDesc, cc.p(500,15), FontSize3, nil, cc.p(1,0)))
			button:addChild(CreateCommonLabel(pvpArr[i].title, cc.p(50,70), 33, cc.c3b(255,255,0),cc.p(0,0)))
			if pvpArr[i].bNote then
				GameGuide:setButtonNote(button, true, cc.p(525, 116), 1.5)
			end
		else
			-- local button = CreateCommonButton("board_closedact.png", cc.p(320,y), cc.size(568,168), ShowWait)
			local button = CreateCommonButton("pic_suiyiaaa.png", cc.p(320,y), cc.size(568,168), ShowWait)
			button:setSwallowTouch(false)
			layer:addChild(button)
			local sp = CreateCommonSprite("board_closedact.png", Pos(button:getContentSize(), 0.5, 0.5))
			sp:setScaleX(0.95)
			sp:setScaleY(0.80)
			button:addChild(sp)
			button:addChild(CreateCommonSprite("board_actpic.png", cc.p(284,84)))
			-- button:addChild(CreateCommonSprite("pic_waitww.png", cc.p(284,84)))
			-- button:addChild(CreateCommonFntLabel(ZGMultiLan("game_info_teambattle_waiting"), FntTypeCommonDisableGray, cc.p(284,84)))
			button:addChild(CreateCommonLabel(ZGMultiLan("game_info_teambattle_waiting"), cc.p(284,84), FontSize4, COLOR_FNT_CommonDisableGray))
		end
		
		y = y - height
	end

	layer:setContentSize(cc.size(640, math.max(fatherHeight, count*height)))
	local scrolView = CreateScrollViewByFather(XiaLayerOwner["mPvpMainScroll"], layer, cc.p(0, math.min(0,fatherHeight-count*height)), kScrollViewDirectionVertical)
end

--ÖØÖÃ½çÃæÏÔÊ¾
function resetPvpLayer()
	XiaLayerOwner["mPvpMain"]:setVisible(true)
	XiaLayerOwner["mGroupLayer"]:setVisible(false)
	XiaLayerOwner["mTeamLayer"]:setVisible(false)
end

--½çÃæ³õÊ¼»¯
function PvpLayerInit()
	-- print("PvpLayerInit")
	if bPvpInited then
		return
	end
	bPvpInited = true
	--[[
	--ÐÂÊÖ»î¶¯
	CreateRichtextByFather(XiaLayerOwner["mActNewDesc"], 
							{{str=MultiLan("GAL_actDescDetail_1"), size=FontSize4},
							 {str=MultiLan("GAL_actDescDetail_2"), size=FontSize4, color=COLOR_CYAN},
							 })
							 
	XiaLayerOwner["mActLiveBlack"]:setOpacity(190)				 
	XiaLayerOwner["mActNewDesc2"]:setPositionY(165)
	--Á¬Ðø³äÖµ
	XiaLayerOwner["mActConPay"]:setTitleForState(MultiLan("GAL_actDescDetail_3"), cc.CONTROL_STATE_NORMAL)
	
	--vip
	CreateRichtextByFather(XiaLayerOwner["mActVipDesc"], 
										{{str=MultiLan("GAL_actDescDetail_4"), size=FontSize4},
										 {size=nil},
										{str=MultiLan("GAL_actDescDetail_5"), size=FontSize4}}, true)
	
	XiaLayerOwner["mActVipPay"]:setTitleForState(MultiLan("button_charge"), cc.CONTROL_STATE_NORMAL)
	XiaLayerOwner["mActVipReward"]:setTitleForState(MultiLan("button_collect"), cc.CONTROL_STATE_NORMAL)
	
	--ÀÛ¼Æ³äÖµ
	XiaLayerOwner["mActPayPay"]:setTitleForState(MultiLan("GAL_actDescDetail_3"), cc.CONTROL_STATE_NORMAL)
	]]
end

function PvpEnter(enterType)
	-- print("PvpEnter", enterType)
	if enterType == nil then
		PvpLayerInit()
		PvpSetMain()
		resetPvpLayer()
	end
end

function PvpExit()

end
