RankHomeLayer = class("RankHomeLayer")

function RankHomeLayer.getCellSize(  )
	return cc.size(640, 960)
end

--new
function RankHomeLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function RankHomeLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["RankHomeLayer"] = self
	ccb["RankHomeLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/RankHomeLayer.ccbi", proxy, self)
	self.data = data

	-- set button onlick
	self.mButtonClose.owner = self

	self:initUI()
	return self
end
function RankHomeLayer:initUI(  )
	self.mButtonClose:setTitleForState(MultiLan("button_close"),1)
	self.lbRank:setString(ZGMultiLan("title_phblist"))
	SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
end
function RankHomeLayer:onCloseClick(sender)
	removeSelf(self.owner.topNode)
end