SkillChangeLayer = class("SkillChangeLayer")

--new
function SkillChangeLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function SkillChangeLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["SkillChangeLayer"] = self
	ccb["SkillChangeLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/SkillChangeLayer.ccbi", proxy, self)
	self.data = data

	-- set button onlick
	self.mButtonClose.owner = self
    self.buttonSave.owner = self
	self:initUI()
	return self
end
function SkillChangeLayer:initUI(  )
	self.leRankTittle:setString(ZGMultiLan("title_skillchange"))
	self.leRankTop:setString(string.format(MultiLan("skill_desc6"), UserSelfInfo.level, math.min(4,math.floor((UserSelfInfo.level+5)/10))))
	self.buttonSave:setTitleForState(MultiLan("button_save"),1)
	self.mButtonClose:setTitleForState(MultiLan("button_cancel"),1)
	SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
end
function SkillChangeLayer:onCloseClick ( sender )
	removeSelf(self.owner.topNode)
end
function SkillChangeLayer:onSaveClick( sender )
    self.owner.data.saveFunc()
 	removeSelf(self.owner.topNode)
 end 