function SkillMasteryLayer:exchangeInit()
	self.btLv2:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(2))),1)
	self.btLv3:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(3))),1)
	self.btLv4:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(4))),1)
	self.btLv5:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(5))),1)
	local amount = 0
	if UserInfo:getPropByPropid(110005) == nil then
		amount = 0
	else
		amount = UserInfo:getPropByPropid(110005).amount
	end
    self.lbExchangeDesc:setString(MultiLan("skill_desc39")..amount)
	self.btLv2:setEnabled(false)
	self.btLv3:setEnabled(true)
	self.btLv4:setEnabled(true)
	self.btLv5:setEnabled(true)
	self:changeBookLevel(2)
end
function SkillMasteryLayer:onClickLv2( sender )
	self.owner.btLv2:setEnabled(false)
	self.owner.btLv3:setEnabled(true)
	self.owner.btLv4:setEnabled(true)
	self.owner.btLv5:setEnabled(true)
	self.owner:changeBookLevel(2)
end
function SkillMasteryLayer:onClickLv3( sender )
	self.owner.btLv2:setEnabled(true)
	self.owner.btLv3:setEnabled(false)
	self.owner.btLv4:setEnabled(true)
	self.owner.btLv5:setEnabled(true)
	self.owner:changeBookLevel(3)
end
function SkillMasteryLayer:onClickLv4( sender )
	self.owner.btLv2:setEnabled(true)
	self.owner.btLv3:setEnabled(true)
	self.owner.btLv4:setEnabled(false)
	self.owner.btLv5:setEnabled(true)
	self.owner:changeBookLevel(4)
end
function SkillMasteryLayer:onClickLv5( sender )
	self.owner.btLv2:setEnabled(true)
	self.owner.btLv3:setEnabled(true)
	self.owner.btLv4:setEnabled(true)
	self.owner.btLv5:setEnabled(false)
	self.owner:changeBookLevel(5)
end

function SkillMasteryLayer:changeBookLevel(m)
	self.scrollLayer:removeAllChildren(true)
	local BookMakeLevel = m
	local skillData = GameData:getGameDataTable().prop
	local scrollLayer = self.scrollLayer
	local layer = cc.Layer:create()
	local count = 0
	for i=1,table.maxn(skillData) do 
		if skillData[i].ptype == 16 and skillData[i].role == UserSelfInfo.role and skillData[i].level == BookMakeLevel then 
			count = count + 1 
		end 
	end
	local y = count * 140
	layer:setContentSize(cc.size(582, 140*count-10))
	CreateScrollViewByFather(scrollLayer, layer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	y = y - 140
	local function setBookDesc(  )
		local amount = 0
		if UserInfo:getPropByPropid(110005) == nil then
			amount = 0
		else
			amount = UserInfo:getPropByPropid(110005).amount
		end
		self.lbExchangeDesc:setString(MultiLan("skill_desc39")..amount)
	end
	for i=1, table.maxn(skillData) do
		-- cclog("asdf" .. i)
		if skillData[i].ptype == 16 and skillData[i].role == UserSelfInfo.role and skillData[i].level == BookMakeLevel then
			-- cclog("if" .. i)
			local skillexchangecell = SkillExchangeCell:new()
			skillexchangecell:create({
				skillData = skillData[i],
				setBookDesc = setBookDesc,
				})
			local cellNode = skillexchangecell.topNode 
			cellNode:setPositionY(y)   
			layer:addChild(cellNode)
			y = y - 140
		end
	end
end


