function SkillMasteryLayer:mergerInit()
	self.btMergeLv1:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(1))),1)
	self.btMergeLv2:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(2))),1)
	self.btMergeLv3:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(3))),1)
	self.btMergeLv4:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(4))),1)
	self.btMergeLv5:setTitleForState((string.format(MultiLan("skill_desc29"),tostring(5))),1)
    self.btMergeLv1:setEnabled(false)
	self.btMergeLv2:setEnabled(true)
	self.btMergeLv3:setEnabled(true)
	self.btMergeLv4:setEnabled(true)
	self.btMergeLv5:setEnabled(true)
	self.btMergeLv1.owner = self
	self.btMergeLv2.owner = self
	self.btMergeLv3.owner = self
	self.btMergeLv4.owner = self
	self.btMergeLv5.owner = self
	self.btSprite1.owner = self
	self.btSprite2.owner = self
	self.btSprite3.owner = self
	self.btSprite4.owner = self
	self.btSprite5.owner = self
	
	self.btCancel02.owner = self
	self.btOk02.owner = self
	self.btFuse.owner = self
	self.bookIcoArr = {self.bookSprite1,
						self.bookSprite2,
						self.bookSprite3,
						self.bookSprite4,
						self.bookSprite5,
					}
	self.bookLbArr = {self.lbSprite1,
						self.lbSprite2,
						self.lbSprite3,
						self.lbSprite4,
						self.lbSprite5,
					}				
    self.merge_count = 0
    self.lbTitle02:setString(ZGMultiLan("title_prompt"))
	self.btCancel02:setTitleForState(MultiLan("button_cancel"),1)
	self.btOk02:setTitleForState(MultiLan("button_ok"),1)
	self.lbDesc02:setString(MultiLan("skill_desc31"))
	self.btFuse:setTitleForState(MultiLan("skill_desc30"), 1)
	SetTouchEventForLayer(self.swallowLayerSmall02, TouchSwallow)
	self:changeBookLevel_merge(1)
end
function SkillMasteryLayer:onClickMergeLv1( sender )
	self.owner.btMergeLv1:setEnabled(false)
	self.owner.btMergeLv2:setEnabled(true)
	self.owner.btMergeLv3:setEnabled(true)
	self.owner.btMergeLv4:setEnabled(true)
	self.owner.btMergeLv5:setEnabled(true)
	self.owner:changeBookLevel_merge(1)
end
function SkillMasteryLayer:onClickMergeLv2( sender )
	self.owner.btMergeLv1:setEnabled(true)
	self.owner.btMergeLv2:setEnabled(false)
	self.owner.btMergeLv3:setEnabled(true)
	self.owner.btMergeLv4:setEnabled(true)
	self.owner.btMergeLv5:setEnabled(true)
	self.owner:changeBookLevel_merge(2)
end
function SkillMasteryLayer:onClickMergeLv3( sender )
	self.owner.btMergeLv1:setEnabled(true)
	self.owner.btMergeLv2:setEnabled(true)
	self.owner.btMergeLv3:setEnabled(false)
	self.owner.btMergeLv4:setEnabled(true)
	self.owner.btMergeLv5:setEnabled(true)
	self.owner:changeBookLevel_merge(3)
end
function SkillMasteryLayer:onClickMergeLv4( sender )
	self.owner.btMergeLv1:setEnabled(true)
	self.owner.btMergeLv2:setEnabled(true)
	self.owner.btMergeLv3:setEnabled(true)
	self.owner.btMergeLv4:setEnabled(false)
	self.owner.btMergeLv5:setEnabled(true)
	self.owner:changeBookLevel_merge(4)
end
function SkillMasteryLayer:onClickMergeLv5( sender )
	self.owner.btMergeLv1:setEnabled(true)
	self.owner.btMergeLv2:setEnabled(true)
	self.owner.btMergeLv3:setEnabled(true)
	self.owner.btMergeLv4:setEnabled(true)
	self.owner.btMergeLv5:setEnabled(false)
	self.owner:changeBookLevel_merge(5)
end
function SkillMasteryLayer:changeBookLevel_merge(m)
	local function removeAllBook()
		self.bookSprite1:setVisible(false)
		self.bookSprite2:setVisible(false)
		self.bookSprite3:setVisible(false)
		self.bookSprite4:setVisible(false)
		self.bookSprite5:setVisible(false)
	end
	self.BookLevel = m
	self.imBack:stopAllActions()
	removeAllBook()
	self.imBack:setRotation(0)
	self.bookData = UserInfo:getBookList(m)
	self.merge_count = 0
	for i=1, 5 do
		if self.bookData[i] ~= nil then
			self.bookIcoArr[i]:setVisible(true)
			self.bookLbArr[i]:setString(MultiLan(self.bookData[i].sData.name))
			tolua.cast(self.bookIcoArr[i], "cc.Sprite"):setSpriteFrame("prop_"..self.bookData[i].prop_id..".png")
			self.merge_count = self.merge_count + 1
			
		end
	end
	if m == 5 then
		self.lbMergeDesc:setString(MultiLan("skill_desc34")..(200*self.merge_count))
	else
		self.lbMergeDesc:setString(MultiLan("skill_desc33")..(20*self.merge_count).."%")
	end
end
function SkillMasteryLayer:onClickBtFuse( sender )
	if self.owner.merge_count == 0 then
		CommonNote(MultiLan("skill_desc32"))
		return
	end
	local function checkBookMerge(bookInfo)
		local bFind = false
		local skillTable = UserInfo:getUserInfo().data.skill
		for i=1, table.maxn(skillTable) do
			if skillTable[i].id == bookInfo.attr_value then
				bFind = true
				if bookInfo.role == UserSelfInfo.role and skillTable[i].master < skillTable[i].level then	
					return false
				end
			end
		end
		
		if bFind == false and bookInfo.role == UserSelfInfo.role then
			return false
		end
		
		return true
	end
	local bCheck = false

	for i=1, self.owner.merge_count do
		if self.owner.bookIcoArr[i]:isVisible() and checkBookMerge(self.owner.bookData[i].sData) == false then
			bCheck = true
			break
		end
	end
	if bCheck then
		self.owner.tanLayer02:setVisible(true)
	else
		self.owner:sendBookMerge()
	end
end
function SkillMasteryLayer:sendBookMerge()
	local function bookMergeCallback(jsonDataTable)
		cclog("------lalalal_______")
		if jsonDataTable.ret == 0 then
			self.imBack:stopAllActions()
			self.imBack:setRotation(0)
			
			--数据
			for i=1, table.maxn(jsonDataTable.data.use_prop) do
				UserInfo:removepropByPropId(jsonDataTable.data.use_prop[i].prop_id,jsonDataTable.data.use_prop[i].num)
			end
			UserInfo:addProp(jsonDataTable.data.item)
			
			if jsonDataTable.data.success == 1 then
				self.effectLayer:setVisible(true)
				self.lbEffectTitle:setString(MultiLan("skill_desc36"))
				tolua.cast(self.imEffectIco, "cc.Sprite"):setSpriteFrame("prop_"..jsonDataTable.data.item[1].prop_id..".png")   
				self.lbEffectName:setString(MultiLan(GameData:getPropDataTable(jsonDataTable.data.item[1].prop_id).name))
				self.effectLayer:setScale(1.2)
				local that = self
				self.effectLayer:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(2), cc.CallFunc:create(function ()
																																		that.effectLayer:setVisible(false)
																																	end)))
				-- noteFunc(MultiLan("skill_desc36"), "prop_"..jsonDataTable.data.item[1].prop_id..".png", MultiLan(GameData:getPropDataTable(jsonDataTable.data.item[1].prop_id).name))
			else
				self.effectLayer:setVisible(true)
				self.lbEffectTitle:setString(MultiLan("skill_desc37"))
				tolua.cast(self.imEffectIco, "cc.Sprite"):setSpriteFrame("prop_"..jsonDataTable.data.item[1].prop_id..".png")   
				self.lbEffectName:setString(MultiLan("skill_desc38")..jsonDataTable.data.item[1].num)
				self.effectLayer:setScale(1.2)
				local that = self
				self.effectLayer:runAction(cc.Sequence:create(cc.ScaleTo:create(0.15, 1), cc.DelayTime:create(2), cc.CallFunc:create(function ()
																																		that.effectLayer:setVisible(false)
																																	end)))
				-- noteFunc(MultiLan("skill_desc37"), "prop_"..jsonDataTable.data.item[1].prop_id..".png", MultiLan("skill_desc38")..jsonDataTable.data.item[1].num)
			end
			
			self:changeBookLevel_merge(self.BookLevel)
		end
	end
	local desc = "ids="
	local bFirst = true
	for i=1, self.merge_count do
		if self.bookIcoArr[i]:isVisible() then
			if bFirst then
				desc = desc..self.bookData[i].prop_id
				bFirst = false
			else	
				desc = desc..","..self.bookData[i].prop_id
			end
		end
	end
	
	local function trueSendMerge()
		HttpSend("skill/fusion", {desc}, bookMergeCallback)
	end
	
	self.imBack:runAction(cc.Sequence:create(cc.RotateBy:create(0.1, 180),
											 cc.RotateBy:create(0.2,540),
											 cc.RotateBy:create(0.2,720),
											 cc.CallFunc:create(trueSendMerge),
											 cc.RotateBy:create(2,7200)))
	
end
function SkillMasteryLayer:onClickCancel02( sender )
-- cclog("-------close--------")
	self.owner.tanLayer02:setVisible(false)
end
function SkillMasteryLayer:onClickOk02( sender )
	self.owner.tanLayer02:setVisible(false)
	self.owner:sendBookMerge()
end
function SkillMasteryLayer:onClickBtSprite1( sender )
	cclog("onClickBtSprite1")
	self.owner.bookIcoArr[1]:setVisible(false)
	self.owner.merge_count = self.owner.merge_count - 1
	if self.owner.BookLevel == 5 then
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc34")..(200*self.owner.merge_count))
	else
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc33")..(20*self.owner.merge_count).."%")
	end
end
function SkillMasteryLayer:onClickBtSprite2( sender )
	cclog("onClickBtSprite2")
	self.owner.bookIcoArr[2]:setVisible(false)
	self.owner.merge_count = self.owner.merge_count - 1
	if self.owner.BookLevel == 5 then
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc34")..(200*self.owner.merge_count))
	else
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc33")..(20*self.owner.merge_count).."%")
	end
end
function SkillMasteryLayer:onClickBtSprite3( sender )
	cclog("onClickBtSprite3")
	self.owner.bookIcoArr[3]:setVisible(false)
	self.owner.merge_count = self.owner.merge_count - 1
	if self.owner.BookLevel == 5 then
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc34")..(200*self.owner.merge_count))
	else
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc33")..(20*self.owner.merge_count).."%")
	end
end
function SkillMasteryLayer:onClickBtSprite4( sender )
	cclog("onClickBtSprite4")
	self.owner.bookIcoArr[4]:setVisible(false)
	self.owner.merge_count = self.owner.merge_count - 1
	if self.owner.BookLevel == 5 then
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc34")..(200*self.owner.merge_count))
	else
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc33")..(20*self.owner.merge_count).."%")
	end
end
function SkillMasteryLayer:onClickBtSprite5( sender )
	cclog("onClickBtSprite5")
	self.owner.bookIcoArr[5]:setVisible(false)
	self.owner.merge_count = self.owner.merge_count - 1
	if self.owner.BookLevel == 5 then
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc34")..(200*self.owner.merge_count))
	else
		self.owner.lbMergeDesc:setString(MultiLan("skill_desc33")..(20*self.owner.merge_count).."%")
	end
end










