AwardCell = class("AwardCell")

function AwardCell.getCellSize(  )
	return cc.size(580, 150)
end

--new
function AwardCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function AwardCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["AwardCell"] = self
	ccb["AwardCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/Lingqujiangli.ccbi", proxy, self, AwardCell.getCellSize())
	self.data = data
	self.buttonclike.owner = self
	self:initUI()
	return self
end
function AwardCell:initUI()
	local itemLayerTable = {self.itemLayer1, self.itemLayer2, self.itemLayer3, self.itemLayer4, }
	local moneyTable = {1.99,9.99,19.99,59.99,99.99}
	self.lbPurchases:setString(string.format(MultiLan("awardcelldesc"),tostring(moneyTable[self.data.tag])))
	if self.data.isChongzhi == 1 then
		if self.data.firstpay_extra["10"..(6 - self.data.tag)] == 1 then
			self.buttonclike:setTitleForState(MultiLan("award_cell_button2"),1)
			self.buttonclike:setEnabled(false)
		else
			self.buttonclike:setTitleForState(MultiLan("award_cell_button2"),1)
			self.buttonclike:setEnabled(true)
		end
	else
		self.buttonclike:setTitleForState(MultiLan("award_cell_button1"),1)
		self.buttonclike:setEnabled(false)
	end
	for i = 1,4 do
		if self.data.itemTable[i] ~= nil then
			local bagItem = CreateBagItem()
			bagItem:setItemType(BAG_ITEM_TYPE_GET_AWARD)
			bagItem:setItemInfoTable(self.data.itemTable[i])
			bagItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			itemLayerTable[i]:addChild(bagItem)
		end
	end
end
function AwardCell:onClickButton(sender)
	-- cclog("onClickButton")
	local function GetAwardCallback(jsonDataTable)
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.data.firstpay_extra["10"..(6 - self.owner.data.tag)] = 1
			self.owner.buttonclike:setEnabled(false)
			UserInfo:addProp(jsonDataTable.data.items)
			UserInfo:addPropNote(jsonDataTable.data.items)
			Activity_ActArr[ACT_TYPE_FIRST].canReward = IsShouchongCanReward()
			if Activity_ActArr[ACT_TYPE_FIRST].canReward == false and Activity_ActArr[ACT_TYPE_FIRST].noteNode ~= nil then
					removeSelf(Activity_ActArr[ACT_TYPE_FIRST].noteNode)
			end
		end
	end
	HttpSend("activity/rewardFirstPay", {"itemid=10"..(6 - self.owner.data.tag)}, GetAwardCallback)
end

