GuildWarCell = class("GuildWarCell")

function GuildWarCell.getCellSize(  )
	return cc.size(554, 43)
end

--new
function GuildWarCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function GuildWarCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["GuildWarCell"] = self
	ccb["GuildWarCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/GuildWarCell.ccbi", proxy, self, GuildWarCell.getCellSize())
	self.data = data
	self:initUI()
	return self
end
function GuildWarCell:initUI()
	self.lbranknum:setString(self.data.rank)
	self.lbguildname:setString(self.data.name)
	self.lbguildpower:setString(self.data.power)
	if self.data.lastPos == 0 or self.data.lastPos > 8 then
		self.lbShangciPaiming:setVisible(false)
	else
		self.lbShangciPaiming:setString(MultiLan("guild_war_cell_desc_"..self.data.lastPos))
	end
	if self.data.name == UserFamilyInfo.info.name then
		self.lbranknum:setColor(cc.c3b(255,255,0))
		self.lbguildname:setColor(cc.c3b(255,255,0))
		self.lbguildpower:setColor(cc.c3b(255,255,0))
	else
		self.lbEffect:setVisible(false)
	end
end