RankHomeCell = class("RankHomeCell")

function RankHomeCell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function RankHomeCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function RankHomeCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["RankHomeCell"] = self
	ccb["RankHomeCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/RankHomeCell.ccbi", proxy, self, RankHomeCell.getCellSize())
	self.data = data
	self:initUI()
	self.buttonclike.owner = self
	self.buttonHear.owner = self

	self.buttonclike:setTitleForState(ZGMultiLan("lbMainBtnMoreTtitle"), cc.CONTROL_STATE_NORMAL)

	return self
end
function RankHomeCell:initUI(  )
	if self.data.playerInfo == nil then
		return
	end
    tolua.cast(self.spriteArr, "cc.Sprite"):setSpriteFrame(self.data.spriteArr)
    local head = SetMyHead(self.data.playerInfo.role,self.data.playerInfo.sex,2)
    tolua.cast(self.imHead, "cc.Sprite"):setSpriteFrame(head)

	if self.data.style <= 4 then 
		-- if self.data.style <= 3 then 
		-- 	self.lbBiaoti:setVisible(false)
		-- end
		self.lbBiaoti:setString(ZGMultiLan("game_info_rank_"..self.data.style))
		self.layerInte:setVisible(false)
		self.layerPower:setVisible(true)
		self.lbnum:setString(MultiLan("list_first"..self.data.style)..self.data.playerInfo.name)
		self.lbPower:setString(ZGMultiLan("equip_battle_value_title"))
		self.lbPowernum:setString(self.data.playerInfo.power)
	end	
	if self.data.style == 5 then 
		self.lbBiaoti:setString(ZGMultiLan("game_info_rank_pvp"))
		self.layerInte:setVisible(false)
		self.layerPower:setVisible(true)
		self.lbnum:setString(MultiLan("list_first0")..self.data.playerInfo.name)
		self.lbPower:setString(ZGMultiLan("equip_battle_value_title"))
		self.lbPowernum:setString(self.data.playerInfo.power)

	end
	if self.data.style == 6 then 
		self.lbBiaoti:setString(ZGMultiLan("game_info_rank_family"))
		self.layerInte:setVisible(true)
		self.layerPower:setVisible(false)
		self.lbnum:setString(MultiLan("list_first5")..self.data.playerInfo.name)
		self.lbPowernum1:setString(MultiLan("union_battle_13")..self.data.playerInfo.total_power)		
	end
	self.buttonHear:setName(self.data.playerInfo.uid)

end
function RankHomeCell:onClickRButton( sender )	
	if self.owner.data.style <= 4 then
		self.owner.buttonHear:setTag(self.owner.data.style)
		sendRoleList(self.owner.buttonHear)
	elseif self.owner.data.style == 5 then
		onArenaList()
	elseif self.owner.data.style == 6 then
		onGuildRankList()
	end
end
function RankHomeCell:onClickButtonHear( sender )
	onPlayerDetailClick(self.owner.buttonHear)
end


