skillUpCell = class("skillUpCell")

function skillUpCell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function skillUpCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function skillUpCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["skillUpCell"] = self
	ccb["skillUpCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/skillUodateCell.ccbi", proxy, self, skillUpCell.getCellSize())
	self.data = data
	self:initUI()
	self.btUpdate.owner = self
	self.btSkillHead.owner = self
	return self
end
function skillUpCell:initUI( )
	self.lbLevel:setString("Lv.1")
	self.lbName:setString(GetSkillName(self.data.skilldatamean))
	self.lbHp:setString(MultiLan("skill_desc4")..self.data.skilldatamean.mp)
	if self.data.skilldatamean.levelup == 1 then
		self.layerUp:setVisible(true)
		self.lbCannotUp:setVisible(false)
	else
		self.layerUp:setVisible(false)
		self.lbCannotUp:setVisible(true)
		self.lbCannotUp:setString(MultiLan("skill_desc10"))
	end
	self.btUpdate:setTitleForState(MultiLan("lan_levelup"),1)
    self.btSkillHead:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("skill_"..self.data.skilldatamean.id..".png"), cc.CONTROL_STATE_NORMAL)
	self.btSkillHead:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName("skill_"..self.data.skilldatamean.id..".png"), cc.CONTROL_STATE_HIGH_LIGHTED)
	self:update()
end
function skillUpCell:update( )
	local dynamicLevel = GetSkillLevel(self.data.skilldatamean.id)
	local staticInfo = FindFirstByKey(self.data.skilldata, "id", self.data.skilldatamean.id)
	self.lbLevel:setString("Lv."..dynamicLevel)
	self.lbMiaoShu:setString(GetSkillDesc(staticInfo, dynamicLevel))
	self.lbShengyu:setString(GameData:getGameDataTable().skill_upgrade[dynamicLevel].num)
	local bookData = UserInfo:getPropByPropid(PROP_ID_BOOK)
	if bookData == nil or bookData.amount < GameData:getGameDataTable().skill_upgrade[dynamicLevel].num then
		self.lbShengyu:setColor(COLOR_RED)
	else
		self.lbShengyu:setColor(COLOR_WHITE)
	end
end
function skillUpCell:onUpdateClike( sender )
	self.owner.data.func(self.owner.data.skilldatamean.id)
end
function skillUpCell:onClickHead ( sender )
    --点击技能图标是调用
end

