skillChangeCell = class("skillChangeCell")

function skillChangeCell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function skillChangeCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function skillChangeCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["skillChangeCell"] = self
	ccb["skillChangeCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/skillChangeCell.ccbi", proxy, self, skillChangeCell.getCellSize())
	self.data = data
	self:initUI()
	self.btChoose.owner = self
	return self
end
function skillChangeCell:initUI( )
	local backArr = {"board_overmap.png", "board_challengemap.png"}
	tolua.cast(self.imBg, "cc.Sprite"):setSpriteFrame(backArr[self.data.skillShowType])
	tolua.cast(self.inSkillHead, "cc.Sprite"):setSpriteFrame("skill_"..self.data.skilldataself.id..".png")
	self.lbLevel:setString("Lv."..GetSkillLevel(self.data.skilldataself.id))
	self.lbDesc:setString(GetSkillDesc(self.data.skilldataself))
	self.lbName:setString(GetSkillName(self.data.skilldataself))
	if self.data.skilldataself.level <= self.data.UserSelfInfo.level then
		self.lbHp:setString(MultiLan("skill_desc4")..self.data.skilldataself.mp)
		self.lbHp:setColor(COLOR_CYAN)
		self.layerButton:setVisible(true)
		self.imLock:setVisible(false)
		local bFind = false
		for j=1, table.maxn(self.data.skillTable) do
			if self.data.skillTable[j] == self.data.skilldataself.id then
				self.imChoose:setVisible(true)
				bFind = true
				break
			end
		end
				
		if bFind == false and table.maxn(self.data.skillTable) == self.data.skillCountLimit then
			self.imDisable:setVisible(true)
		end
	else
		self.lbHp:setString(string.format(MultiLan("skill_desc5"),tostring(self.data.skilldataself.level)))
		self.lbHp:setColor(COLOR_RED)
		self.layerButton:setVisible(false)
		self.imLock:setVisible(true)
	end
end
function skillChangeCell:onClickChoose ( sender )
    if self.owner.imDisable:isVisible() then
		return 
	end
	self.owner.imChoose:setVisible(not self.owner.imChoose:isVisible())
	self.owner.data.changeOthers()
end