skillHomeCell = class("skillHomeCell")

function skillHomeCell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function skillHomeCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function skillHomeCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["skillHomeCell"] = self
	ccb["skillHomeCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/skillHomeCell.ccbi", proxy, self, skillHomeCell.getCellSize())
	self.data = data
	self:initUI()
	self.btBg.owner = self
	self.btUp.owner = self
	return self
end
function skillHomeCell:initUI( )
	if self.data.type == 1 then
		self.layerLock:setVisible(true)
        self.layerSkill:setVisible(false)
        self.layerUnlock:setVisible(false)
        self.lbLock:setString(string.format(MultiLan("skill_desc7"),tostring(self.data.level1)))
	elseif self.data.type == 2 then
		self.layerLock:setVisible(false)
        self.layerSkill:setVisible(true)
        self.layerUnlock:setVisible(false)
        self.btSkillBg:setEnabled(false)
        self.btSkillBg:setSwallowTouch(false)
        tolua.cast(self.imSkillHead, "cc.Sprite"):setSpriteFrame(self.data.head)
        self.lbLevel:setString(self.data.level)
        self.lbName:setString(self.data.name)
        self.lbHp:setString(self.data.hp)
        self.lbDesc:setString(self.data.desc)
        self.lbUp:setString(MultiLan("skill_desc202"))
        if self.data.order == 1 then 
        	self.btUp:setEnabled(false)
        	self.lbUp:setString(MultiLan("skill_desc201"))
        end
        self.btSkillBg:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(self.data.backName), cc.CONTROL_STATE_NORMAL)
		self.btSkillBg:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(self.data.backName), cc.CONTROL_STATE_HIGH_LIGHTED)
		self.btSkillBg:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(self.data.backName), cc.CONTROL_STATE_DISABLED)
	elseif self.data.type == 3 then
		self.layerLock:setVisible(false)
        self.layerSkill:setVisible(false)
        self.layerUnlock:setVisible(true)
        self.lbUnlock:setString(MultiLan("skill_desc8"))
        self.btBg:setSwallowTouch(false)
        self.btBg:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(self.data.backName), cc.CONTROL_STATE_NORMAL)
		self.btBg:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(self.data.backName), cc.CONTROL_STATE_HIGH_LIGHTED)
		CommonMoveLabelUnderBtn(self.btBg,self.imKuang)
	end	
end
function skillHomeCell:onClickSetskill( sender )
	self.owner.data.onSkillMoreSkillBtnClick()
end
function skillHomeCell:onClickUp( sender)
	self.owner.data.onSkillUp(self.owner.data.order)
end



