BattleListLayer = class("BattleListLayer")

function BattleListLayer.getCellSize(  )
	return cc.size(554, 624)
end
--new
function BattleListLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function BattleListLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["BattleListLayer"] = self
	ccb["BattleListLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Family/BattleListLayer.ccbi", proxy, self)
	self.data = data
	self.guildNameTable = {}
	self:initUI()
	return self
end
function BattleListLayer:initUI(  )
	self.linatable32 = {self.imline32_1,  self.imline32_2,  self.imline32_3,  self.imline32_4,  self.imline32_5,  self.imline32_6,  self.imline32_7,  self.imline32_8,
						self.imline32_9,  self.imline32_10, self.imline32_11, self.imline32_12, self.imline32_13, self.imline32_14, self.imline32_15, self.imline32_16,
						self.imline32_17, self.imline32_18, self.imline32_19, self.imline32_20, self.imline32_21, self.imline32_22, self.imline32_23, self.imline32_24,
						self.imline32_25, self.imline32_26, self.imline32_27, self.imline32_28, self.imline32_29, self.imline32_30, self.imline32_31, self.imline32_32,}
	self.linatable16 = {self.imline16_1,  self.imline16_2,  self.imline16_3,  self.imline16_4,  self.imline16_5,  self.imline16_6,  self.imline16_7,  self.imline16_8, 
						self.imline16_9,  self.imline16_10, self.imline16_11, self.imline16_12, self.imline16_13, self.imline16_14, self.imline16_15, self.imline16_16,}
	self.linatable8  = {self.imline8_1,   self.imline8_2,   self.imline8_3,   self.imline8_4,   self.imline8_5,   self.imline8_6,   self.imline8_7,   self.imline8_8,  }
	self.buttontable ={self.btBattleReport1,   self.btBattleReport2,   self.btBattleReport3,   self.btBattleReport4,   self.btBattleReport5,   self.btBattleReport6,   self.btBattleReport7,   self.btBattleReport8,  
				 	   self.btBattleReport9,   self.btBattleReport10,  self.btBattleReport11,  self.btBattleReport12,  self.btBattleReport13,  self.btBattleReport14,  self.btBattleReport15,  self.btBattleReport16,  
				 	   self.btBattleReport17,  self.btBattleReport18,  self.btBattleReport19,  self.btBattleReport20,  self.btBattleReport21,  self.btBattleReport22,  self.btBattleReport23,  self.btBattleReport24,  
				 	   self.btBattleReport25,  self.btBattleReport26,  self.btBattleReport27,  self.btBattleReport28,  self.btBattleReport29,  self.btBattleReport30,  self.btBattleReport31,  self.btBattleReport32,   }
	self.linatable4  = {self.imline4_1,   self.imline4_2,   self.imline4_3,   self.imline4_4,  }
	for i = 1, 32 do
		if self.linatable32[i] ~= nil then
			self.linatable32[i]:setVisible(false)
		end
		if self.linatable16[i] ~= nil then
			self.linatable16[i]:setVisible(false)
		end
		if self.linatable8[i] ~= nil then
			self.linatable8[i]:setVisible(false)
		end
		if self.linatable4[i] ~= nil then
			self.linatable4[i]:setVisible(false)
		end
		self.buttontable[i].owner = self
	end
	self.lbChampion:setVisible(false)
	-- ccdump(self.data.MatrixPre[tostring(3200+2)].name1,"MatrixPre")
	for i = 1,32 do
		local name1 = ""
		local name2 = ""
		local id1 = -1
		local id2 = -1
		local win_id = self.data.MatrixPre[tostring(3200 + math.ceil(i / 2))].win_id
		if i % 2 == 1 then
			-- cclog("name "..i.." is "..self.data.MatrixPre[tostring(3200+i)].name1)
			name1 = tostring(self.data.MatrixPre[tostring(3200 + math.ceil(i / 2))].name1)
			id1 = self.data.MatrixPre[tostring(3200 + math.ceil(i / 2))].id1
			if name1 == "" then
				self.buttontable[i]:setTitleForState(" ", 1)
				self.buttontable[i]:setEnabled(false)
			else
				self.buttontable[i]:setTitleForState(name1, 1)
				if UserFamilyInfo.info.id == id1 then
					local Sprite = cc.Sprite:createWithSpriteFrameName("Event_btn_eff2.png")
					Sprite:setPosition(cc.p(self.buttontable[i]:getContentSize().width / 2, self.buttontable[i]:getContentSize().height * 0.5))
					self.buttontable[i]:addChild(Sprite)
				end
			end
			local mytable = {}
			mytable.name = name1
			table.insert(self.guildNameTable,mytable)
		else
			name2 = tostring(self.data.MatrixPre[tostring(3200 + math.ceil(i / 2))].name2)
			id2 = self.data.MatrixPre[tostring(3200 + math.ceil(i / 2))].id2
			-- cclog("name "..i.." is "..self.data.MatrixPre[tostring(3200+i)].name1)
			if name2 == "" then
				self.buttontable[i]:setTitleForState(" ", 1)
				self.buttontable[i]:setEnabled(false)
			else
				self.buttontable[i]:setTitleForState(name2, 1)
				if UserFamilyInfo.info.id == id2 then
					local Sprite = cc.Sprite:createWithSpriteFrameName("Event_btn_eff2.png")
					Sprite:setPosition(cc.p(self.buttontable[i]:getContentSize().width / 2, self.buttontable[i]:getContentSize().height * 0.5))
					self.buttontable[i]:addChild(Sprite)
				end
			end
			local mytable = {}
			mytable.name = name2
			table.insert(self.guildNameTable,mytable)
		end
		if win_id ~= 0 then
			if win_id == id1 then
				self.linatable32[i]:setVisible(true)
			end
			if win_id == id2 then
				self.linatable32[i]:setVisible(true)
			end
		end
	end
	if self.data.MatrixPre["1601"] ~= nil then
		for i =1 ,16 do
			local id1 = -1
			local id2 = -1
			local win_id = self.data.MatrixPre[tostring(1600 + math.ceil(i / 2))].win_id
			if i % 2 == 1 then
				id1 = self.data.MatrixPre[tostring(1600 + math.ceil(i / 2))].id1
			else
				id2 = self.data.MatrixPre[tostring(1600 + math.ceil(i / 2))].id2
			end
			if win_id ~= 0 then
				if win_id == id1 then
					self.linatable16[i]:setVisible(true)
				end
				if win_id == id2 then
					self.linatable16[i]:setVisible(true)
				end
			end
		end
	end
	if self.data.MatrixPre["801"] ~= nil then
		for i =1 ,8 do
			local id1 = -1
			local id2 = -1
			local win_id = self.data.MatrixPre[tostring(800 + math.ceil(i / 2))].win_id
			if i % 2 == 1 then
				id1 = self.data.MatrixPre[tostring(800 + math.ceil(i / 2))].id1
			else
				id2 = self.data.MatrixPre[tostring(800 + math.ceil(i / 2))].id2
			end
			if win_id ~= 0 then
				if win_id == id1 then
					self.linatable8[i]:setVisible(true)
				end
				if win_id == id2 then
					self.linatable8[i]:setVisible(true)
				end
			end
		end
	end
	-- ccdump(self.data.MatrixPre["401"],"self.data.MatrixPre[]")
	if self.data.MatrixPre["401"] ~= nil then
		for i =1 ,4 do
			-- cclog("---------")
			local id1 = -1
			local id2 = -1
			local win_id = self.data.MatrixPre[tostring(400 + math.ceil(i / 2))].win_id
			if i % 2 == 1 then
				id1 = self.data.MatrixPre[tostring(400 + math.ceil(i / 2))].id1
			else
				id2 = self.data.MatrixPre[tostring(400 + math.ceil(i / 2))].id2
			end
			if win_id ~= 0 then
				if win_id == id1 then
					self.linatable4[i]:setVisible(true)
				end
				if win_id == id2 then
					self.linatable4[i]:setVisible(true)
				end
			end
		end
	end
	if self.data.MatrixPre["201"] ~= nil then
		local win_id = self.data.MatrixPre["201"].win_id
		if win_id ~= 0 then
			self.lbChampion:setVisible(true)
			local win_id = self.data.MatrixPre["201"].win_id
			if win_id == self.data.MatrixPre["201"].id1 then
				self.lbChampion:setString(self.data.MatrixPre["201"].name1)
			end
			if win_id == self.data.MatrixPre["201"].id2 then
				self.lbChampion:setString(self.data.MatrixPre["201"].name2)
			end
		end
	end
end
function BattleListLayer:onClickBattleReport(sender)
	tag = self:getTag()
	-- cclog("tag is "..tag)
	local flage = tag
	local num = ""
	local myflage = 3200
	local layer = cc.Layer:create()
	
	local count = 0
	for i = 1,5 do
		num = tostring(myflage + math.ceil(flage / 2))
		myflage = myflage / 2
		flage = math.ceil(flage / 2)
		if self.owner.data.MatrixPre[num] ~= nil then
			if self.owner.data.MatrixPre[num].win_id ~= 0 then
				if self.owner.guildNameTable[tag].name == self.owner.data.MatrixPre[num].name1 or self.owner.guildNameTable[tag].name == self.owner.data.MatrixPre[num].name2 then
					count = count + 2
				end
			end
		end
	end
	layer:setContentSize(cc.size(GuildWarListCell.getCellSize().width, GuildWarListCell.getCellSize().height * count))
	local y = 0 - 2*GuildWarListCell.getCellSize().height
	-- y = GuildWarListCell.getCellSize().height * count
	flage = tag
	myflage = 3200
	for i = 1,5 do
		num = tostring(myflage + math.ceil(flage / 2))
		myflage = myflage / 2
		local listTag = flage
		flage = math.ceil(flage / 2)
		if self.owner.data.MatrixPre[num] ~= nil then
			if self.owner.data.MatrixPre[num].win_id ~= 0 then
				if self.owner.guildNameTable[tag].name == self.owner.data.MatrixPre[num].name1 or self.owner.guildNameTable[tag].name == self.owner.data.MatrixPre[num].name2 then
					-- cclog("1")
					local guildWarListCell = GuildWarListCell:new()
					guildWarListCell:create({
						atype = 1,
						atag = i,
						})
					local cellNode = guildWarListCell.topNode
					y = y + 3 * GuildWarListCell.getCellSize().height
					-- y = y - GuildWarListCell.getCellSize().height
					-- cclog("y is "..y)
					cellNode:setPositionY(y)
					layer:addChild(cellNode)
					local guildWarListCell = GuildWarListCell:new()
					guildWarListCell:create({
						atype = 2,
						info = self.owner.data.MatrixPre[num],
						mytag = listTag,
						})
					local cellNode = guildWarListCell.topNode
					y = y - GuildWarListCell.getCellSize().height
					-- cclog("y is "..y)
					cellNode:setPositionY(y)
					layer:addChild(cellNode)
				end
			end
		end
	end


	local guildwartan = GuildWarTanLayer:new()
	guildwartan:create({
		title = MultiLan("guild_war_zhanbao_title"),
		desc = MultiLan("guild_war_zhanbao_desc"),
		layer = layer,
		size = layer:getContentSize(),
		})
	local layerNode = guildwartan.topNode
	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode)
end






