WingRankcell = class("WingRankcell")

function WingRankcell.getCellSize(  )
	return cc.size(439, 115)
end

--new
function WingRankcell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function WingRankcell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["WingRankcell"] = self
	ccb["WingRankcellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/wing/wingRankCell.ccbi", proxy, self, WingRankcell.getCellSize())
	self.data = data
	self:initUI()
	self.btHead.owner = self
	return self
end
function WingRankcell:initUI()
	if self.data.rank <=3 then
		self.im_rank:setSpriteFrame("tianyu_paihang"..self.data.rank..".png")
	else
		self.im_rank:setVisible(false)
	end
	local head = SetMyHead(self.data.info.role,self.data.info.sex,2)
	self.btHead:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(head), 1)
	self.btHead:setBackgroundSpriteForState(cc.Scale9Sprite:createWithSpriteFrameName(head), 2)
	self.lbName:setString(self.data.info.UName)
	self.lb_rank:setString(MultiLan("lan_rank")..":".. tostring(self.data.rank))
	self.lbWingLevel:setString(MultiLan("wings_cell_desc_1")..self.data.info.wing_lv)
	-- setup button name
	self.btHead:setName(self.data.info.uid)
end
function WingRankcell:onClickHend( sender )
	onPlayerDetailClick(self.owner.btHead)
end