WishesLayer = class("WishesLayer")

--new
function WishesLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function WishesLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["WishesLayer"] = self
	ccb["WishesLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/Event/wishesLayer.ccbi", proxy, self)
	self.data = data
   
	-- set button onlick
	self.mActPayBack.owner = self
	self.btGetKey1.owner = self
	self.btGetKey2.owner = self
	self.btGetKey3.owner = self
	self:initUI()
	return self
end
function WishesLayer:initUI()
	self.lbActWisheslTitle:setString(ZGMultiLan("act_title_wishes"))
	self.lbTimeDesc:setString(MultiLan("GAL_wishes_desc1"))
	self.lbTimeName:setString(MultiLan("GAL_wishes_desc2"))
	self.lbDireName:setString(MultiLan("GAL_wishes_desc3"))
	self.lbDireDesc:setString(MultiLan("GAL_wishes_desc4"))
	self.lbDireLeft1:setString(MultiLan("GAL_wishes_desc5"))
	self.lbDireLeft2:setString(MultiLan("GAL_wishes_desc6"))
	self.lbDireLeft3:setString(MultiLan("GAL_wishes_desc7"))
	self.lbDireRight1:setString(MultiLan("GAL_wishes_desc8"))
	self.lbDireRight2:setString(MultiLan("GAL_wishes_desc9"))
	self.lbDireRight3:setString(MultiLan("GAL_wishes_desc10"))
	self.lbWelfareName:setString(MultiLan("GAL_wishes_desc11"))
	self.lbFirDay:setString(MultiLan("GAL_wishes_desc12"))
	self.lbSenDay:setString(MultiLan("GAL_wishes_desc13"))
	self.lbThirdDay:setString(MultiLan("GAL_wishes_desc14"))
	self.btGetKey1:setTitleForState(MultiLan("GAL_wishes_button"),1)
	self.btGetKey2:setTitleForState(MultiLan("GAL_wishes_button"),1)
	self.btGetKey3:setTitleForState(MultiLan("GAL_wishes_button"),1)

end
function WishesLayer:onActPayBack( sender )
    self.owner.data.resetActLayer()
	self.owner.topNode:setVisible(false)
end
function WishesLayer:onActHelpClick(sender)
    -- HelpPopup("actiwishes")
end
function WishesLayer:onClickBtGetKey1(sender)
	cclog("onClickBtGetKey1")
	local function getKey(jsonDataTable)
		-- ccdump(jsonDataTable,"jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.btGetKey1:setEnabled(false)
			--添加道具
			UserInfo:addProp(jsonDataTable.data.items)
			UserInfo:addPropNote(jsonDataTable.data.items)
			UserActiveInfo.daily_boxBlessing.awardId = 0
			Activity_ActArr[ACT_TYPE_WISHES].canReward = false
			if Activity_ActArr[ACT_TYPE_WISHES].canReward == false and Activity_ActArr[ACT_TYPE_WISHES].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_WISHES].noteNode)
			end
		end
	end
	HttpSend("activity/boxblessingaward", {}, getKey)
end
function WishesLayer:onClickBtGetKey2(sender)
	cclog("onClickBtGetKey2")
	local function getKey(jsonDataTable)
		-- ccdump(jsonDataTable,"jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.btGetKey2:setEnabled(false)
			--添加道具
			UserInfo:addProp(jsonDataTable.data.items)
			UserInfo:addPropNote(jsonDataTable.data.items)
			UserActiveInfo.daily_boxBlessing.awardId = 0
			Activity_ActArr[ACT_TYPE_WISHES].canReward = false
			if Activity_ActArr[ACT_TYPE_WISHES].canReward == false and Activity_ActArr[ACT_TYPE_WISHES].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_WISHES].noteNode)
			end
		end
	end
	HttpSend("activity/boxblessingaward", {}, getKey)
end
function WishesLayer:onClickBtGetKey3(sender)
	cclog("onClickBtGetKey3")
	local function getKey(jsonDataTable)
		-- ccdump(jsonDataTable,"jsonDataTable")
		if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
			self.owner.btGetKey3:setEnabled(false)
			--添加道具
			UserInfo:addProp(jsonDataTable.data.items)
			UserInfo:addPropNote(jsonDataTable.data.items)
			UserActiveInfo.daily_boxBlessing.awardId = 0
			Activity_ActArr[ACT_TYPE_WISHES].canReward = false
			if Activity_ActArr[ACT_TYPE_WISHES].canReward == false and Activity_ActArr[ACT_TYPE_WISHES].noteNode ~= nil then
				removeSelf(Activity_ActArr[ACT_TYPE_WISHES].noteNode)
			end
		end
	end
	HttpSend("activity/boxblessingaward", {}, getKey)
end





