SkillMasteryLayer = class("SkillMasteryLayer")

--new
function SkillMasteryLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function SkillMasteryLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["SkillMasteryLayer"] = self
	ccb["SkillMasteryLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/skillZhuanjing.ccbi", proxy, self)
	self.data = data
	-- set button onlick
	self.btClose.owner = self
	self.btHelp.owner = self
	self.mButtonBuy.owner = self
	self.mButtonMerger.owner = self
	self.mButtonExchange.owner = self

	--exchange button
	self.btLv2.owner = self
	self.btLv3.owner = self
	self.btLv4.owner = self
	self.btLv5.owner = self
	--Buy button
	self.btLeft.owner = self
	self.btRight.owner = self

	self:initUI()
	return self
end
function SkillMasteryLayer:initUI()
	self.leRankTittle:setString(ZGMultiLan("title_goumaimj"))
	self.mButtonBuy:setTitleForState(MultiLan("skill_desc15"),1)
	self.mButtonMerger:setTitleForState(MultiLan("skill_desc16"),1)
	self.mButtonExchange:setTitleForState(MultiLan("skill_desc17"),1)
	SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
	self.tanLayer:setVisible(false)
	self.tanLayer02:setVisible(false)
	self.effectLayer:setVisible(false)
	self:buyInit()
end
function SkillMasteryLayer:onClickHelp( sender )
	HelpPopup("skillmaster")
end
function SkillMasteryLayer:onClickClose( sender )
	removeSelf(self.owner.topNode)
end
function SkillMasteryLayer:onBuyClick( sender )
	self.owner:buyInit()
end
function SkillMasteryLayer:onMergerClick( sender )
	self.owner.mButtonBuy:setEnabled(true)
	self.owner.mButtonMerger:setEnabled(false)
	self.owner.mButtonExchange:setEnabled(true)
	self.owner.buySkillLayer:setVisible(false)
	self.owner.mergerSkillLayer:setVisible(true)
	self.owner.exchangeSkilLayer:setVisible(false)
	self.owner:mergerInit()
end
function SkillMasteryLayer:onExchangeClick( sender )
	self.owner.mButtonBuy:setEnabled(true)
	self.owner.mButtonMerger:setEnabled(true)
	self.owner.mButtonExchange:setEnabled(false)
	self.owner.buySkillLayer:setVisible(false)
	self.owner.mergerSkillLayer:setVisible(false)
	self.owner.exchangeSkilLayer:setVisible(true)
	self.owner:exchangeInit()
end

