FlashSaleTan = class("FlashSaleTan")

--new
function FlashSaleTan:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function FlashSaleTan:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["FlashSaleTan"] = self
	ccb["FlashSaleTanOwner"] = self
	self.topNode = CCBReaderLoad("ccb/tanchuang/FlashSaleTan.ccbi", proxy, self)
	self.data = data
    
    SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	-- set button onlick
    self.btTanBuy.owner = self
    self.btTanClose.owner = self
    self.btTanCancel.owner = self
    self.button1.owner = self
    self.button2.owner = self
    self.button3.owner = self
    self.button4.owner = self
	self:initUI()
	return self
end
function FlashSaleTan:initUI(  )
	self.btTanClose:setTitleForState(MultiLan("button_close"),1)
	self.btTanBuy:setTitleForState(MultiLan("button_ok"),1)
	self.btTanCancel:setTitleForState(MultiLan("button_cancel"),1)
	if self.data.type == 1 then
		self.btTanClose:setVisible(false)
	end
	if self.data.type == 2 then
		self.btTanBuy:setVisible(false)
		self.btTanCancel:setVisible(false)
	end
	local saleComLayer = {
	{["saleComLayer"] = self.saleComLayer1, ["imIco"] = self.imIco1 , ["lbNum"] = self.lbNum1 , ["lbName"] = self.lbName1,},
	{["saleComLayer"] = self.saleComLayer2, ["imIco"] = self.imIco2 , ["lbNum"] = self.lbNum2 , ["lbName"] = self.lbName2,},
	{["saleComLayer"] = self.saleComLayer3, ["imIco"] = self.imIco3 , ["lbNum"] = self.lbNum3 , ["lbName"] = self.lbName3,},
	{["saleComLayer"] = self.saleComLayer4, ["imIco"] = self.imIco4 , ["lbNum"] = self.lbNum4 , ["lbName"] = self.lbName4,},
}
	for i = 1, 4 do
		if self.data.info.items[i] ~= nil then
            saleComLayer[i].lbNum:setString("x"..self.data.info.items[i].num)
            saleComLayer[i].lbName:setString(MultiLan("prop_name_"..self.data.info.items[i].prop_id))
            tolua.cast(saleComLayer[i].imIco, "cc.Sprite"):setSpriteFrame("prop_"..self.data.info.items[i].prop_id..".png")
        else
        	saleComLayer[i].saleComLayer:setVisible(false)
		end
	end
end
function FlashSaleTan:onClickBtTanBuy(sender)
	cclog("onClickBtTanBuy")
	local price = self.owner.data.info.price_co
	if UserSelfInfo.cash < self.owner.data.info.price_co then
		CommonCashNeed()
		return
	end
    local function buyCallback(jsonDataTable)
    	ccdump(jsonDataTable,"jsonDataTable")
		UserInfo:addProp(jsonDataTable.data.items)
		UserInfo:addPropNote(jsonDataTable.data.items)
		removeSelf(self.owner.topNode)
		UserSelfInfo.cash = UserSelfInfo.cash - jsonDataTable.data.cost_cash
		setFlashSela()
		-- ccdump(UserSelfInfo,"UserSelfInfo")	
	end
	HttpSend("activity/buyLimitPurchase", {"buyId="..self.owner.data.info.id}, buyCallback)
end
function FlashSaleTan:onClickBtTanClose(sender)
	removeSelf(self.owner.topNode)
end
function FlashSaleTan:onClickBtTanCancel(sender)
	removeSelf(self.owner.topNode)
end
function FlashSaleTan:onclickButton1(sender)
	local itemInfoTable = GameData:getPropDataTable(self.owner.data.info.items[1].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(self.owner.data.info.items[1], true)
end
function FlashSaleTan:onclickButton2(sender)
	local itemInfoTable = GameData:getPropDataTable(self.owner.data.info.items[2].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(self.owner.data.info.items[2], true)
end
function FlashSaleTan:onclickButton3(sender)
	local itemInfoTable = GameData:getPropDataTable(self.owner.data.info.items[3].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(self.owner.data.info.items[3], true)
end
function FlashSaleTan:onclickButton4(sender)
	local itemInfoTable = GameData:getPropDataTable(self.owner.data.info.items[4].prop_id)
	if itemInfoTable.ptype == 7 then
		return
	end
	PropDetail:PropDetailEnter(self.owner.data.info.items[4], true)
end




