GuildWarTanLayer = class("GuildWarTanLayer")

--new
function GuildWarTanLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function GuildWarTanLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["GuildWarTanLayer"] = self
	ccb["GuildWarTanLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/tanchuang/GuildWarTanLayer.ccbi", proxy, self)
	self.data = data
    
    SetTouchEventForLayer(self.swallowLayerSmall, TouchSwallow)
	-- set button onlick
 	self.btClose.owner = self
	self:initUI()
	return self
end
function GuildWarTanLayer:initUI(  )
	self.title_hero_aura:setString(self.data.title)
	self.lbDesc:setString(self.data.desc)
	local scrollLayer = self.scrollLayer 
    local alayer = cc.Layer:create()
    local y = self.data.size.height
    self.data.layer:setPosition(cc.p((scrollLayer:getContentSize().width - self.data.size.width)/2,0))
    alayer:setContentSize(cc.size(scrollLayer:getContentSize().width, y))
	local scrolView = CreateScrollViewByFather(scrollLayer, alayer, cc.p(0, scrollLayer:getContentSize().height - y), kScrollViewDirectionVertical)
	alayer:addChild(self.data.layer)


end
function GuildWarTanLayer:onClickClose(sender)
	removeSelf(self.owner.topNode)
end