AwardLeijiCell = class("AwardLeijiCell")

function AwardLeijiCell.getCellSize(  )
	return cc.size(580, 150)
end

--new
function AwardLeijiCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function AwardLeijiCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["AwardLeijiCell"] = self
	ccb["AwardLeijiCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/Lingqujiangli.ccbi", proxy, self, AwardLeijiCell.getCellSize())
	self.data = data
	self.buttonclike.owner = self
	self:initUI()
	
	return self
end
function AwardLeijiCell:initUI()
	local itemLayerTable = {self.itemLayer1, self.itemLayer2, self.itemLayer3, self.itemLayer4, }
	self.lbPurchases:setString(string.format(MultiLan("awardleijicelldesc"),tostring(self.data.itemTable.price)))
	if self.data.count >= self.data.itemTable.price then
		if self.data.reward[tostring(self.data.itemTable.price)] == 1 then
			self.buttonclike:setTitleForState(MultiLan("award_cell_button2"),1)
			self.buttonclike:setEnabled(false)
		else
			self.buttonclike:setTitleForState(MultiLan("award_cell_button2"),1)
			self.buttonclike:setEnabled(true)
		end
	else
		self.buttonclike:setTitleForState(MultiLan("award_cell_button1"),1)
		self.buttonclike:setEnabled(false)
	end
	-- ccdump(self.data,"aaaa")
	for i = 1,4 do
		if self.data.itemTable.items[i] ~= nil then
			local bagItem = CreateBagItem()
			bagItem:setItemType(BAG_ITEM_TYPE_GET_AWARD)
			local myitems = {}
			myitems.amount = self.data.itemTable.items[i].num
			myitems.prop_id = self.data.itemTable.items[i].id
			bagItem:setItemInfoTable(myitems)
			bagItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			itemLayerTable[i]:addChild(bagItem)
		end
	end
end
function AwardLeijiCell:onClickButton(sender)
	if self.owner.data.flag == "xinfu" then
		local function GetAwardXinCallback(jsonDataTable)
			if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
				self.owner.data.reward[tostring(self.owner.data.itemTable.price)] = 1
				self.owner.buttonclike:setEnabled(false)
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				Activity_ActArr[ACT_TYPE_PAY].canReward = IsLeijiCanReward()
				if Activity_ActArr[ACT_TYPE_PAY].canReward == false and Activity_ActArr[ACT_TYPE_PAY].noteNode ~= nil then
						removeSelf(Activity_ActArr[ACT_TYPE_PAY].noteNode)
				end
			end
		end
		HttpSend("activity/rewardNServerPay", {"price="..self.owner.data.itemTable.price}, GetAwardXinCallback)
	end
	if self.owner.data.flag == "laofu" then
		local function GetAwardLaoCallback(jsonDataTable)
			if jsonDataTable.ret == 0 and jsonDataTable.msg == "ok" then
				self.owner.data.reward[tostring(self.owner.data.itemTable.price)] = 1
				self.owner.buttonclike:setEnabled(false)
				UserInfo:addProp(jsonDataTable.data.items)
				UserInfo:addPropNote(jsonDataTable.data.items)
				Activity_ActArr[ACT_TYPE_PAY_TEMP].canReward = IsLaofuLeijiCanReward()
				if Activity_ActArr[ACT_TYPE_PAY_TEMP].canReward == false and Activity_ActArr[ACT_TYPE_PAY_TEMP].noteNode ~= nil then
						removeSelf(Activity_ActArr[ACT_TYPE_PAY_TEMP].noteNode)
				end
			end
		end
		HttpSend("activity/rewardAccPay", {"price="..self.owner.data.itemTable.price}, GetAwardLaoCallback)
	end
end

