EventsCell = class("EventsCell")

function EventsCell.getCellSize(  )
	return cc.size(548, 140)
end

--new
function EventsCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function EventsCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["EventsCell"] = self
	ccb["EventsCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/EventsCell.ccbi", proxy, self, EventsCell.getCellSize())
	self.data = data
	self.clickButton.owner = self
	-- cclog("   AAAA "..self.data.imbg)
	if self.data.imbg ~= "board_zhongshenka.png" then
		
		self.effectlayer:setVisible(false)
		
	end
	tolua.cast(self.imBg, "cc.Sprite"):setSpriteFrame(self.data.imbg)
	if Activity_ActArr[self.data.tag] ~= nil then
		-- ccdump(Activity_ActArr[self.data.tag],"Activity_ActArr"..self.data.tag)
		if Activity_ActArr[self.data.tag].canReward then
			Activity_ActArr[self.data.tag].noteNode = GameGuide:setButtonNote(self.imBg, true, cc.p(530,130), 1.5)
		else
			Activity_ActArr[self.data.tag].noteNode = nil
		end
	end
	self.lbTitle:setString(self.data.title)
    self.clickButton:setSwallowTouch(false)
	return self
end
function EventsCell:onClickBtn(sender)
	-- cclog("aaaaaa")
	self.owner.data.actClick(self.owner.data.tag)
end
