FlashSaleCell = class("FlashSaleCell")

function FlashSaleCell.getCellSize(  )
	return cc.size(570, 140)
end

--new
function FlashSaleCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function FlashSaleCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["FlashSaleCell"] = self
	ccb["FlashSaleCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/FlashSaleCell.ccbi", proxy, self, FlashSaleCell.getCellSize())
	self.data = data
	self.buttonclike.owner = self
	self.buttonHear.owner = self
	self:initUI()

	return self
end
function FlashSaleCell:initUI()
	local info = self.data.info
	self.lbPurchases:setString(string.format(MultiLan("flashsale_desc_1"),tostring(info.userBought),tostring(info.rn_user)))
	self.lbName:setString("name is nil")
	self.lbWas:setString(string.format(MultiLan("flashsale_desc_2"),tostring(info.price)))
	self.lbNow:setString(string.format(MultiLan("flashsale_desc_3"),tostring(info.price_co)))
	self.lbStock:setString(MultiLan("flashsale_desc_4"))
	self.lbStockNum:setString(tostring(info.rn_server - info.serverBought))
	if info.type == 1 then
		tolua.cast(self.imHend, "cc.Sprite"):setSpriteFrame("flashsale_"..info.id..".png")
		self.lbName:setString(MultiLan("flashsale_name_"..info.id))
		self.lbNum:setVisible(false)
	end
	if info.type == 2 then
		self.lbStock:setVisible(false)
		self.lbStockNum:setVisible(false)
		tolua.cast(self.imHend, "cc.Sprite"):setSpriteFrame("prop_"..info.items[1].prop_id..".png")
		self.lbName:setString(MultiLan("prop_name_"..info.items[1].prop_id))
		self.lbNum:setString("x"..info.items[1].num)
	end
	self.lbCanbuy:setString(string.format(MultiLan("flashsale_desc_5"),tostring(info.vip_min)))
	self.buttonclike:setTitleForState(MultiLan("flashsale_button"),1)
	local btbuyflga = flase
	if info.type == 1 then
		if info.rn_server - info.serverBought > 0 then
			if info.rn_user - info.userBought > 0 then
				if UserSelfInfo.vip >= info.vip_min then
					btbuyflga = true
				end
			end
		end
	end
	if info.type == 2 then	
		if info.rn_user - info.userBought > 0 then
			if UserSelfInfo.vip >= info.vip_min then
				btbuyflga = true
			end
		end
	end
	self.buttonclike:setEnabled(btbuyflga)

end
function FlashSaleCell:onClickRButton( sender )
	self.owner.data.freshFlashSela(self.owner.data.info)
end
function FlashSaleCell:onClickButtonHear( sender )
	self.owner.data.showFlasjsela(self.owner.data.info)
end


