GuildWarListCell = class("GuildWarListCell")
function GuildWarListCell.getCellSize(  )
	return cc.size(494, 43)
end
--new
function GuildWarListCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function GuildWarListCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["GuildWarListCell"] = self
	ccb["GuildWarListCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/GuildWarListCell.ccbi", proxy, self, GuildWarListCell.getCellSize())
	self.data = data
	self.btZhanbao.owner = self
	self:initUI()
	return self
end
function GuildWarListCell:initUI()
	if self.data.atype == 1 then
		self.layertype2:setVisible(true)
		self.layertype1:setVisible(false)
		self.lbMingci:setString(MultiLan("guilg_war_list_"..self.data.atag))
	else
		self.layertype2:setVisible(false)
		self.layertype1:setVisible(true)
		if self.data.info.name1 ~= "" then
			self.lbguild1:setString(self.data.info.name1)
		else
			self.lbguild1:setString(MultiLan("guilg_war_list_desc"))
			self.btZhanbao:setEnabled(false)
		end
		if self.data.info.name2 ~= "" then
			self.lbguild2:setString(self.data.info.name2)
		else
			self.lbguild2:setString(MultiLan("guilg_war_list_desc"))
			self.btZhanbao:setEnabled(false)
		end
		if self.data.info.win_id == self.data.info.id1 then
			self.lbguild1:setColor(cc.c3b(0,255,0))
			self.lbguild2:setColor(cc.c3b(140,140,140))
		else
			self.lbguild1:setColor(cc.c3b(140,140,140))
			self.lbguild2:setColor(cc.c3b(0,255,0))
		end
	end

end
function GuildWarListCell:onClickZhanbao( sender )
	local guildwartan = GuildWarZhanTanLayer:new()
	guildwartan:create({
		info = self.owner.data.info,
		})
	local layerNode = guildwartan.topNode
	if POPUP_LAYER == nil then
		POPUP_LAYER = CreateLayer(CommonSize ,COMMON_SCALE, Pos(CommonSize))
		scene:addChild(POPUP_LAYER, POPUP_TAG, POPUP_TAG)
	end
	POPUP_LAYER:addChild(layerNode)
end