PlaceAwardCell = class("PlaceAwardCell")

function PlaceAwardCell.getCellSize(  )
	return cc.size(580, 150)
end

--new
function PlaceAwardCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function PlaceAwardCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["PlaceAwardCell"] = self
	ccb["PlaceAwardCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/cells/Paimingxianli.ccbi", proxy, self, PlaceAwardCell.getCellSize())
	self.data = data
	self:initUI()
	
	return self
end
function PlaceAwardCell:initUI()
	self.lbPaiming:setString(MultiLan("placeaward_cell_pai_"..self.data.tag))
	self.lbPurchases:setString(MultiLan("placeaward_cell_pai"))
	if self.data.tag <= 3 then
		if self.data.listInfo[self.data.tag] ~= nil then
			self.lbName:setString(self.data.listInfo[self.data.tag].name)
		else
			self.lbName:setVisible(false)
		end
	else
		self.lbName:setVisible(false)
	end
	local itemlayer = {self.layerItem1, self.layerItem2, self.layerItem3, self.layerItem4, self.layerItem5,}
	local award = {}
	local tagstr = tostring(self.data.tag)
	for k,v in pairs(self.data.awardInfo[tagstr]) do
		local item = {}
		item.amount = tonumber(v)
		item.prop_id = tonumber(k)
		table.insert(award,item)
	end
	for i = 1,5 do
		if award[i] ~= nil then
			local bagItem = CreateBagItem()
			bagItem:setItemType(BAG_ITEM_TYPE_GET_AWARD)
			bagItem:setItemInfoTable(award[i])
			bagItem:setPosition(cc.p(BAG_ITEM_SIZE / 2, BAG_ITEM_SIZE / 2))
			itemlayer[i]:addChild(bagItem)
		end
	end
end


