RankLayer = class("RankLayer")

--new
function RankLayer:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function RankLayer:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["RankLayer"] = self
	ccb["RankLayerOwner"] = self
	self.topNode = CCBReaderLoad("ccb/RankListLayer.ccbi", proxy, self)
	self.data = data

	-- set button onlick
	self.mButtonClose.owner = self
	self:initUI()
	return self
end

function RankLayer:initUI()
	self.mButtonClose:setTitleForState(MultiLan("button_close"),1)
	local roleListTitle = {"shaolinb", "wudangb", "tangmenb", "levelb"}
	if self.data.roleType <= 4 then
	    self.leRankTop:setString(MultiLan("list_desc"..self.data.roleType))
	    self.leRankTittle:setString(ZGMultiLan("title_"..roleListTitle[self.data.roleType]))
    elseif self.data.roleType == 5 then
        self.leRankTop:setString(self.data.title)
        self.leRankTittle:setString(ZGMultiLan("title_bhphang"))
    elseif  self.data.roleType == 6 then
    	self.leRankTop:setString(MultiLan("GALa_rankDesc"))
    	self.leRankTittle:setString(ZGMultiLan("title_pvplist"))
    end

	SetTouchEventForLayer(self.swallowLayer, TouchSwallow)
end

function RankLayer:onCloseClick(sender)
	removeSelf(self.owner.topNode)
end