HeroTokenTaskCell = class("HeroTokenTaskCell")

function HeroTokenTaskCell.getCellSize(  )
	return cc.size(485, 135)
end

--new
function HeroTokenTaskCell:new( o )
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

-- create
function HeroTokenTaskCell:create( data )
	local proxy = cc.CCBProxy:create()
	ccb["HeroTokenTaskCell"] = self
	ccb["HeroTokenTaskCellOwner"] = self
	self.topNode = CCBReaderLoad("ccb/wing/HeroTokenTaskCell.ccbi", proxy, self, HeroTokenTaskCell.getCellSize())
	self.data = data
	self.bt_lingqu.owner = self
	self:initUI()
	return self
end
function HeroTokenTaskCell:initUI()
	self.lbName:setString(MultiLan("prop_name_"..self.data.info.prop_id))
	self.lbTask:setString(MultiLan("wing_hero_task_1"))
	self.bt_lingqu:setTitleForState(MultiLan("button_collect"),1)
	self.lbJindu:setString(string.format(MultiLan("wing_hero_task_2"),self.data.info.num,self.data.info.total))
	if self.data.info.num < self.data.info.total then
		self.bt_lingqu:setEnabled(false)
	end
	if self.data.info.prop_id == 100701 then
		self.imBian:setSpriteFrame("frame_grey.png")
	elseif self.data.info.prop_id == 100702 then
		self.imBian:setSpriteFrame("frame_green.png")
	elseif self.data.info.prop_id == 100703 then
		self.imBian:setSpriteFrame("frame_blue.png")
	elseif self.data.info.prop_id == 100704 then
		self.imBian:setSpriteFrame("frame_violet.png")
	elseif self.data.info.prop_id == 100705 then
		self.imBian:setSpriteFrame("frame_yellow.png")
	end
end
function HeroTokenTaskCell:onClickLingqu(sender)
	local function rewardCallback( jsonDataTable )
		if jsonDataTable.ret~= 0 then
			return
		end
		UserInfo:addProp(jsonDataTable.data.items)
		UserInfo:addPropNote(jsonDataTable.data.items)
		-- ccdump(jsonDataTable.data.wingInfo,"token_infos")
		self.owner.data.layer:refreshScrol1(jsonDataTable.data.wingInfo)
	end
	HttpSend("wing/tokenreward",{"propId="..self.owner.data.info.prop_id},rewardCallback)
end









